#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll max_op = (int)2e8 + (int)1e6;
///const ll max_op = (int)1e8 + 1;
///const ll max_op = 0;

#define all(v) v.begin(), v.end()

void gen(vector<bool> &ans, const vector<int> &a, const vector<int> &sol) {
    int r = -1;
    for (int l = 0; l < sol.size(); ++l) {
        while (r + 1 < a.size() && sol[l] != a[r + 1])
            ++r;
        ++r;
        ans[r + 1] = 1;
    }
    ///return ans;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if ((long long)(a.size()) * (long long)(b.size()) <= max_op)
        return vector<bool>(0);
    vector<bool> ans;
    if (a.size() < b.size()) {
        ans.resize(a.size() + 1);
        ans[0] = 0;
        gen(ans, a, sol);
    } else {
        ans.resize(b.size() + 1);
        ans[0] = 1;
        gen(ans, b, sol);
    }
    return ans;
}

vector<int> slow(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    int dp[n + 1][m + 1];
    ///pair<int, int> p[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 0;

    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
            if (a[i - 1] == b[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (dp[x][y] == dp[x - 1][y]) {
            --x;
            continue;
        }
        if (dp[x][y] == dp[x][y - 1]) {
            --y;
            continue;
        }
        ans.emplace_back(a[x - 1]);
        --x;
        --y;
    }
    reverse(all(ans));
    return ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    ///vector<int> ans;
    if ((ll)a.size() * (ll)b.size() <= max_op) {
        return slow(a, b);
    }
    vector<int> cur = a;
    if (hint[0] == 1)
        cur = b;
    vector<int> ans;
    for (int i = 1; i < hint.size(); ++i) {
        if (hint[i])
            ans.push_back(cur[i - 1]);
    }
    return ans;
}

/**signed main() {
    int type;
    cin >> type;
    if (type == 1) {
        int n, m, k;
        cin >> n >> m >> k;
        vector<int> a(n);
        vector<int> b(m);
        vector<int> c(k);
        for (int &x : a)
            cin >> x;
        for (int &x : b)
            cin >> x;
        for (int &x : c)
            cin >> x;
        vector<bool> hint = genHint(a, b, c);
        for (int i = 0; i < hint.size(); ++i) {
            cout << hint[i] << '\n';
        }
    }
}**/
