#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll max_op = (int)2e8 + (int)1e6;
///const ll max_op = (int)1e8 + 1;
///const ll max_op = 0;

#define all(v) v.begin(), v.end()

void gen(vector<bool> &ans, const vector<int> &a, const vector<int> &sol) {
    int r = -1;
    for (int l = 0; l < sol.size(); ++l) {
        while (r + 1 < a.size() && sol[l] != a[r + 1])
            ++r;
        ++r;
        ans[r + 1] = 1;
    }
    vector<bool> ans1 = ans;
    vector<bool> ans2 = ans;
    for (int i = 0; i < ans2.size(); ++i) {
        ans2[i] = !ans2[i];
    }
    while (!ans1.empty() && ans1[(int)ans1.size() - 1] == 0)
        ans1.pop_back();
    if (ans1.size() == 1)
        ans1.pop_back();
    if (!ans1.empty())
        ans1.push_back(1);
    while (!ans2.empty() && ans2[(int)ans2.size() - 1] == 0)
        ans2.pop_back();
    if (ans2.size() == 1)
        ans2.pop_back();
    if (!ans2.empty())
        ans2.push_back(0);
    ans = ans1;
    if (ans2.size() < ans.size())
        ans = ans2;
    ///return ans;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if ((long long)(a.size()) * (long long)(b.size()) <= max_op)
        return vector<bool>(0);
    vector<bool> h1;
    vector<bool> h2;
    h1.resize(a.size() + 1);
    h2.resize(b.size() + 1);
    h1[0] = 0;
    h2[0] = 1;
    gen(h1, a, sol);
    gen(h2, b, sol);
    if (h1.size() < h2.size())
        return h1;
    else
        return h2;
}

vector<int> slow(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    int dp[n + 1][m + 1];
    ///pair<int, int> p[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 0;

    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
            if (a[i - 1] == b[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (dp[x][y] == dp[x - 1][y]) {
            --x;
            continue;
        }
        if (dp[x][y] == dp[x][y - 1]) {
            --y;
            continue;
        }
        ans.emplace_back(a[x - 1]);
        --x;
        --y;
    }
    reverse(all(ans));
    return ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    ///vector<int> ans;
    if ((ll)a.size() * (ll)b.size() <= max_op) {
        return slow(a, b);
    }
    if (hint.empty()) {
        return vector<int>(0);
    }
    vector<int> cur = a;
    if (hint[0] == 1)
        cur = b;
    vector<int> ans;
    vector<bool> HINT = hint;
    int last = HINT[(int)HINT.size() - 1];
    HINT.pop_back();
    if (last == 0) {
        for (int i = 1; i < HINT.size(); ++i)
            HINT[i] = !HINT[i];
    }
    for (int i = 1; i < HINT.size(); ++i) {
        if (HINT[i])
            ans.push_back(cur[i - 1]);
    }
    return ans;
}

/**signed main() {
    int type;
    cin >> type;
    if (type == 1) {
        int n, m, k;
        cin >> n >> m >> k;
        vector<int> a(n);
        vector<int> b(m);
        vector<int> c(k);
        for (int &x : a)
            cin >> x;
        for (int &x : b)
            cin >> x;
        for (int &x : c)
            cin >> x;
        vector<bool> hint = genHint(a, b, c);
        for (int i = 0; i < hint.size(); ++i) {
            cout << hint[i] << ' ';
        }
    }
}**/
