#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll max_op = (int)2e8 + (int)1e6;

const int K = 1000;
///const ll max_op = (int)1e8 + 1;
///const ll max_op = 0;

#define all(v) v.begin(), v.end()

vector<int> slow(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    int dp[n + 1][m + 1];
    ///pair<int, int> p[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 0;

    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
            if (a[i - 1] == b[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (dp[x][y] == dp[x - 1][y]) {
            --x;
            continue;
        }
        if (dp[x][y] == dp[x][y - 1]) {
            --y;
            continue;
        }
        ans.emplace_back(a[x - 1]);
        --x;
        --y;
    }
    reverse(all(ans));
    return ans;
}

void gen(vector<bool> &ans, const vector<int> &a, const vector<int> &sol) {
    int r = -1;
    for (int l = 0; l < sol.size(); ++l) {
        while (r + 1 < a.size() && sol[l] != a[r + 1])
            ++r;
        ++r;
        ans[r + 1] = 1;
    }
    while (!ans.empty() && ans[(int)ans.size() - 1] == 0)
        ans.pop_back();
    if (ans.size() == 1)
        ans.pop_back();
    ///return ans;
}

void Insert(vector<bool> &h, int x) {
    for (int i = 16; i >= 0; --i) {
        if (x & (1 << i))
            h.push_back(1);
        else
            h.push_back(0);
    }
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if ((long long)(a.size()) * (long long)(b.size()) <= max_op)
        return vector<bool>(0);
    /**vector<bool> h1;
    vector<bool> h2;
    h1.resize(a.size() + 1);
    h2.resize(b.size() + 1);
    h1[0] = 0;
    h2[0] = 1;
    gen(h1, a, sol);
    gen(h2, b, sol);
    if (h1.size() < h2.size())
        return h1;
    else
        return h2;**/
    vector<bool> h;
    int pi = -1, pj = -1;
    vector<int> p1, p2;
    for (int k = 0; k < sol.size(); ++k) {
        int i = pi + 1;
        int j = pj + 1;
        while (a[i] != sol[k])
            ++i;
        while (b[j] != sol[k])
            ++j;
        p1.emplace_back(i);
        p2.emplace_back(j);
        pi = i;
        pj = j;
    }
    for (int l = 0; l < sol.size(); ++l) {
        int r = l;
        while (r + 1 < sol.size() && p1[r + 1] - sol[l] <= K && p2[r + 1] - sol[l] <= K)
            ++r;
        Insert(h, p1[r]);
        Insert(h, p2[r]);
        l = r + 1;
    }
    return h;
}

int Get(const vector<bool> &hint, int i) {
    int x = 0;
    for (int j = i; j < i + 17; ++j) {
        x <<= 1;
        if (hint[i])
            x |= 1;
    }
    return x;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if ((ll)a.size() * (ll)b.size() <= max_op) {
        return slow(a, b);
    }
    if (hint.empty()) {
        return vector<int>(0);
    }
    int prev1 = -1;
    int prev2 = -1;
    vector<int> ans;
    vector<int> cur;
    for (int i = 0; i < hint.size(); ++i) {
        int p1 = Get(hint, i);
        int p2 = Get(hint, i + 17);
        vector<int> A(a.begin() + prev1 + 1, a.begin() + p1 + 1);
        vector<int> B(b.begin() + prev2 + 1, b.begin() + p2 + 1);
        prev1 = p1;
        prev2 = p2;
        cur = slow(A, B);
        for (int x : cur)
            ans.emplace_back(x);
    }
    return ans;
}

/**signed main() {
    int type;
    cin >> type;
    if (type == 1) {
        int n, m, k;
        cin >> n >> m >> k;
        vector<int> a(n);
        vector<int> b(m);
        vector<int> c(k);
        for (int &x : a)
            cin >> x;
        for (int &x : b)
            cin >> x;
        for (int &x : c)
            cin >> x;
        vector<bool> hint = genHint(a, b, c);
        for (int i = 0; i < hint.size(); ++i) {
            cout << hint[i] << ' ';
        }
        cout << endl;
        vector<int> res = solve(a, b, hint);
        for (int x : res)
            cout << x << ' ';
    }
}**/
