#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()

using ll = long long;

const int N = 10000 + 1;
const int K = 1000;

///K <= N

int dp[N + 1][N + 1];

vector<int> slow(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    ///int dp[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 0;

    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
            if (a[i - 1] == b[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (dp[x][y] == dp[x - 1][y]) {
            --x;
            continue;
        }
        if (dp[x][y] == dp[x][y - 1]) {
            --y;
            continue;
        }
        ans.emplace_back(a[x - 1]);
        --x;
        --y;
    }
    reverse(all(ans));
    return ans;
}

void Insert(vector<bool> &h, int x, int &last) {
    for (int i = 16; i >= 0; --i) {
        if (x & (1 << i))
            h[last++] = 1;
        else
            h[last++] = 0;
    }
}

int Get(const vector<bool> &hint, int i) {
    int x = 0;
    for (int j = i; j < i + 17; ++j) {
        x <<= 1;
        if (hint[j])
            x |= 1;
    }
    return x;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<int> p1;
    vector<int> p2;
    int r = -1;
    for (int l = 0; l < sol.size(); ++l) {
        ++r;
        while (a[r] != sol[l])
            ++r;
        p1.emplace_back(r);
    }
    r = -1;
    for (int l = 0; l < sol.size(); ++l) {
        ++r;
        while (b[r] != sol[l])
            ++r;
        p2.emplace_back(r);
    }
    r = -1;
    vector<int> add1, add2;
    vector<bool> hint;
    for (int l = 0; l < sol.size(); ) {
        ++r;
        while (r + 1 < sol.size() && p2[r + 1] - p2[l] + 1 <= K && p1[r + 1] - p1[l] + 1 <= K) {
            ++r;
        }
        l = r + 1;
        add1.emplace_back(p1[r]);
        add2.emplace_back(p2[r]);
    }
    int last = 0;
    hint.resize(34 * add1.size());
    for (int x : add1)
        Insert(hint, x, last);
    for (int x : add2)
        Insert(hint, x, last);
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if (a.size() <= N && b.size() <= N) {
        return slow(a, b);
    }
    vector<int> p1;
    vector<int> p2;
    vector<int> ans;
    vector<int> cur;
    int len1 = hint.size() / 2;
    p1.emplace_back(-1);
    p2.emplace_back(-1);
    for (int i = 0; i < len1; i += 17)
        p1.emplace_back(Get(hint, i));
    for (int i = len1; i < hint.size(); i += 17)
        p2.emplace_back(Get(hint, i));
    for (int i = 1; i < p1.size(); ++i) {
        vector<int> A(a.begin() + (p1[i - 1] + 1), a.begin() + p1[i] + 1);
        vector<int> B(b.begin() + (p2[i - 1] + 1), b.begin() + p2[i] + 1);
        cur = slow(A, B);
        for (int x : cur)
            ans.emplace_back(x);
    }
    return ans;
}
