#include "hint.h"

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define spr(x) cout << x << " "
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) { for(auto it2 : it) cout << it2 << " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)



using namespace std;

using ll = int;
using vll = vector<ll>;
using vvll = vector<vll>;
using vb = vector<bool>;
using vvb = vector<vb>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;
using vi = vector<int>;


/*

Finds longest match using dp
dp[i][j] = longest match when we went through first i in a and first j in b
splendid, this works

Now split the arrays to smaller arrays.
And then solve each one seperately.
My problem is that the values don't seperate equally, so my indexes could be:
1, 4, 7, 1000, 1002, 50000

To do this, just split the arrays and solve each one.

Push the firsts. and continue pushing until you get to the end
*/

const ll vsz = 18; // CHECK
const ll block = 650000; // max MULT of lengths


vll longest_match(const vll &a, const vll &b)
{
	//wprv(a);
	//wprv(b);
	ll n = a.size(), m = b.size();
	if (n == 0 || m == 0) {
		vll res;
		return res;
	}
	if (n * m > block) {
		vll res = { a[0] };
		return res;
	}
	vvll dp(n, vll(m, -1));
	/*
	last[i][j] = 1 => goto dp[i-1][j]
	last[i][j] = 2 => goto dp[i][j-1]
	last[i][j] = 3 => goto dp[i-1][j-1]
	*/
	vvll last(n, vll(m, -1));
	ll besti = -1, bestj = -1, bestv = -1;
	rep(i, 0, n) {
		rep(j, 0, m) {
			ll add = (a[i] == b[j]);
			ll v1 = 0, v2 = 0, v3 = add;
			if (i > 0) v1 = dp[i - 1][j];
			if (j > 0) v2 = dp[i][j - 1];
			if (i > 0 && j > 0) v3 = dp[i - 1][j - 1] + add;
			dp[i][j] = max({ v1, v2, v3 });
			if (v1 == dp[i][j]) {
				last[i][j] = 1;
			}
			if (v2 == dp[i][j]) {
				last[i][j] = 2;
			}
			if (v3 == dp[i][j]) {
				last[i][j] = 3;
			}
			if (bestv < dp[i][j]) {
				bestv = dp[i][j];
				besti = i, bestj = j;
			}
		}
	}
	ll ci = besti, cj = bestj;
	vll seq;
	if (bestv == 0) return seq;
	while (true) {
		//wpr(ci); wpr(cj);
		
		if (ci < 0 || cj < 0) break;
		//wpr(last[ci][cj]);
		if (last[ci][cj] == 1) {
			ci--;
		}
		else if (last[ci][cj] == 2) {
			cj--;
		}
		else {
			if (a[ci] == b[cj]) seq.push_back(a[ci]);
			ci--, cj--;
		}	
	}
	reverse(seq.begin(), seq.end());
	return seq;
}


vll get_indexes(const vll &a, const vll &sol)
{
	vll inds;
	ll p = 0;
	rep(i, 0, a.size()) {
		if (p < sol.size() && sol[p] == a[i]) {
			inds.push_back(i);
			p++;
		}
	}
	return inds;
}

vb to_bin(ll x) {
	vb res(vsz, 0);
	rep(i, 0, vsz) {
		if ((x >> i) & 1) res[i] = 1;
	}
	return res;
}

ll to_num(vb& bina) {
	ll x = 0;
	rep(i, 0, vsz) {
		if (bina[i]) x += (1 << i);
	}
	return x;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	vll inda = get_indexes(a, sol);
	vll indb = get_indexes(b, sol);
	if (inda.size() != indb.size()) while (true);
	//wprv(inda);
	//wprv(indb);
	vb res;
	ll p = 0;
	while (p < inda.size()) {
		//wpr(p);
		//pr("pushing: ");
		//wpr(inda[p]);
		//wpr(indb[p]);
		vb bina = to_bin(inda[p]);
		//wprv(bina);
		vb binb = to_bin(indb[p]);
		rep(j, 0, vsz) {
			res.push_back(bina[j]);
		}
		rep(j, 0, vsz) {
			res.push_back(binb[j]);
		}
		ll sa = inda[p];
		ll sb = indb[p];
		p++;
		bool in = false;
		while (p < inda.size()) {
			ll mult = (inda[p] - sa) * (indb[p] - sb);
			if (mult > block) {
				break;
			}
			in = true;
			p++;
		}
		if (in) p--;
	}
	//wprv(res);
	return res;
}



////////////////////////////////////////////////////////////////


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	//wprv(hint);
	vi ans;
	vi inda;
	vi indb;
	for (ll i = 0; i < hint.size();) {
		vb cura(vsz);
		rep(j, 0, vsz) {
			cura[j] = hint[i + j];
		}
		i += vsz;
		vb curb(vsz);
		rep(j, 0, vsz) {
			curb[j] = hint[i + j];
		}
		i += vsz;
		inda.push_back(to_num(cura));
		indb.push_back(to_num(curb));
	}
	inda.push_back(a.size());
	indb.push_back(b.size());
	//wprv(inda);
	//wprv(indb);
	ll starta = inda[0], startb = indb[0];
	rep(i, 1, inda.size()) {
		ll enda = inda[i]-(ll)1;
		ll endb = indb[i]-(ll)1;
		vll ca;
		rep(j, starta, enda+1) {
			ca.push_back(a[j]);
		}
		vll cb;
		rep(j, startb, endb+1) {
			cb.push_back(b[j]);
		}
		//wprv(ca);
		//wprv(cb);
		vll cur = longest_match(ca, cb);
		rep(j, 0, cur.size()) {
			ans.push_back(cur[j]);
		}
		starta = enda+1, startb = endb+1;
	}
	//wprv(inda);
	//wprv(indb);
	return ans;
}



