#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
#include <climits>

int r [ 20'005 ] ;
std::vector<int> p [ 20'005 ] ;
std::vector<int> adj [ 20'005 ] ;

int cmp ( const void *a , const void *b ) {
	return adj [ *(const int *)a ].size ( ) - adj [ *(const int *)b ].size ( ) ;
}

bool vis [ 20'005 ] ;

int T [ 20'005 ] ;
int H [ 20'005 ] ;

void rdfs ( int leaf ) {
	if ( vis [ leaf ] ) return ;
	vis [ leaf ] = true ;
	int best_parent = -1 , cnt = INT_MAX ;
	for ( int i = 0 ; i < p [ leaf ].size ( ) ; i++ ) {
		if ( vis [ p [ leaf ][ i ] ] == false && adj [ p [ leaf ][ i ] ].size ( ) < cnt ) {
			cnt = adj [ p [ leaf ][ i ] ].size ( ) ;
			best_parent = p [ leaf ][ i ] ;
		}
	}
	// printf ( "p[%d] = %d\n", leaf,best_parent) ;
	r [ leaf ] = best_parent ;
	if ( best_parent != -1 ) {
		rdfs ( best_parent ) ;
	}
}

int main ( void ) {
	int N ;
	scanf ( " %d" , &N ) ;
	for ( int i = 1 ; i <= N ; i++ ) {
		scanf ( " %d %d" , &T [ i ] , &H [ i ] ) ;
	}
	for ( int i = 1 ; i <= N ; i++ ) {
		for ( int j = 1 ; j <= N ; j++ ) {
			if ( i == j ) continue ;
			if ( ( T [ j ] - T [ i ] ) >= abs ( H [ j ] - H [ i ] ) ) {
				adj [ i ].push_back ( j ) ;
				p [ j ].push_back ( i ) ;
			}
		}
	}
	int ans = 0 ;
	for ( int i = 1 ; i <= N ; i++ )
		if ( adj [ i ].size ( ) == 0)
			rdfs ( i ) ;
	for ( int i = 1 ; i <= N ; i++ )
		if ( r [ i ] == -1 )
			ans++;
	printf ( "%d\n" , ans ) ;
	return 0 ;
}
