//#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
//#endif
#include <bits/stdc++.h>
using namespace std;

const int BUBEN = 1300;

int get_cnt_bit(int n) {
    int cur = 1;
    while ((1 << cur) <= n) {
        cur++;
    }
    return cur;
}

vector<int> getpos(const vector<int> &a, const vector<int> &sol) {
    vector<int> ans;
    int cur_pos = 0;
    for (int el : sol) {
        while (a[cur_pos++] != el);
        ans.push_back(cur_pos - 1);
    }
    return ans;
}

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    if (a.size() * b.size() <= 1.5e8) {
        return {};
    }
    int cntb = get_cnt_bit((int) max(a.size(), b.size()));
    vector<int> posa = getpos(a, sol);
    vector<int> posb = getpos(b, sol);
    int cntnums = min((int) sol.size(), BUBEN);
    vector<int> used(sol.size());
    mt19937 rd(chrono::high_resolution_clock().now().time_since_epoch().count());
    vector<int> send;
    used[0] = 1;
    used.back() = 1;
    for (int i = 0; i + 1 < (int) sol.size(); i++) {
        if ((posa[i + 1] - posa[i]) * (posb[i + 1] - posb[i]) > 1e6) {
            used[i] = used[i + 1] = 1;
        }
    }
    int sum = accumulate(used.begin(), used.end(), 0);
    for (int i = 0; i < cntnums - sum; i++) {
        int a = (int) (rd() % used.size());
        while (used[a]) {
            a = (int) (rd() % used.size());
        }
        used[a] = 1;
    }

    for (int i = 0; i < (int) sol.size(); i++) {
        if (used[i]) {
            send.push_back(i);
        }
    }
    sort(send.begin(), send.end());
    vector<bool> bits;
    for (int el : send) {
        for (int i = 0; i < cntb; i++) {
            bits.push_back((posa[el] >> i) & 1);
        }
        for (int i = 0; i < cntb; i++) {
            bits.push_back((posb[el] >> i) & 1);
        }
    }
#ifdef LOCAL
    cout << "Nums was:" << endl;
    for (int el : send) {
        cout << posa[el] << " " << posb[el] << " ";
    }
    cout << endl;
#endif
    return bits;
}

vector<int> solve2(vector<int> a, vector<int> b) {
    unordered_set<int> sa, sb;
    for (int el : a)
        sa.insert(el);
    for (int el : b)
        sb.insert(el);
    {
        vector<int> a2;
        for (int el : a) {
            if (sb.count(el))
                a2.push_back(el);
        }
        a = a2;
    }
    {
        vector<int> b2;
        for (int el : b) {
            if (sa.count(el))
                b2.push_back(el);
        }
        b = b2;
    }
    int n = (int) a.size();
    int m = (int) b.size();
    vector<vector<int>> dp(n + 1, vector<int> (m + 1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i - 1] == b[j - 1]) {
                dp[i][j] = 1 + dp[i - 1][j - 1];
            }
            dp[i][j] = max({dp[i - 1][j], dp[i][j - 1], dp[i][j]});
        }
    }
    vector<int> ans;
    int i = n;
    int j = m;
    while (dp[i][j]) {
        if (dp[i][j] == dp[i - 1][j]) {
            i--;
        } else if (dp[i][j] == dp[i][j - 1]) {
            j--;
        } else {
            assert(a[i - 1] == b[j - 1]);
            ans.push_back(a[i - 1]);
            i--;
            j--;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    if (hint.empty()) {
        return solve2(a, b);
    }
    int n = (int) a.size();
    int m = (int) b.size();
    int cntb = get_cnt_bit((int) max(a.size(), b.size()));
    int k = (int) hint.size() / (2 * cntb);
    vector<int> posa;
    vector<int> posb;
    for (int i = 0; i < k; i++) {
        int a = 0;
        for (int j = 0; j < cntb; j++) {
            a ^= hint[i * cntb * 2 + j] << j;
        }
        posa.push_back(a);
    }
    for (int i = 0; i < k; i++) {
        int a = 0;
        for (int j = 0; j < cntb; j++) {
            a ^= hint[i * cntb * 2 + cntb + j] << j;
        }
        posb.push_back(a);
    }
#ifdef LOCAL
    cout << "NOW: " << endl;
    for (int el : posa) {
        cout << el << " ";
    }
    cout << endl;
    for (int el : posb) {
        cout << el << " ";
    }
    cout << endl;
    cout << endl;
#endif
    if (posa.size() < BUBEN) {
        vector<int> ans;
        for (int i = 0; i < posa.size(); i++) {
            ans.push_back(a[posa[i]]);
        }
        return ans;
    }
    int lasta = 0;
    int lastb = 0;
    vector<int> ans;
    for (int i = 0; i < k; i++) {
        if (i != 0) {
            vector<int> aa, bb;
            for (int j = lasta; j < posa[i]; j++) {
                aa.push_back(a[j]);
            } 
            for (int j = lastb; j < posb[i]; j++) {
                bb.push_back(b[j]);
            } 
            auto sol = solve2(aa, bb);
            for (int el : sol) {
                ans.push_back(el);
            }
        }
        ans.push_back(a[posa[i]]);
        lasta = posa[i] + 1;
        lastb = posb[i] + 1;
    }
    if (0) {
        vector<int> aa, bb;
        for (int j = lasta; j < n; j++) {
            aa.push_back(a[j]);
        } 
        for (int j = lastb; j < m; j++) {
            bb.push_back(b[j]);
        } 
        auto sol = solve2(aa, bb);
        for (int el : sol) {
            ans.push_back(el);
        }
    }
    return ans;
    return {-1};
}

