#include "hint.h"
#include <vector>
#include <algorithm>
#define pii pair<bool, bool>

using namespace std;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	if (a.size() <= (int)1e4)
		return vector<bool>();

	int n = a.size();
	int pnt = 0;
	vector<bool> out;
	for (int i = 0; i < n; i++) {
		if (sol[pnt] == a[i])
		{
			out.push_back(true);
			pnt++;
		}
		else
			out.push_back(false);
	}

	return out;
}
vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	if (hint == vector<bool>()) {
		// normal LCS dp

		int n = a.size(), m = b.size();
		vector<vector<pii> > precursor(n + 1, vector<pii>(m + 1, pii(0,0)));
		vector<vector<int> > dp(n + 1, vector<int>(m + 1, 0));
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				int mult = 0;
				if (a[i - 1] == b[j - 1])
					mult = 1;
				if (dp[i - 1][j - 1] + mult > max(dp[i][j - 1], dp[i - 1][j - 1]))
					dp[i][j] = dp[i - 1][j - 1] + mult, precursor[i][j] = pii(true, true);
				else if (dp[i - 1][j] > max(dp[i][j - 1], dp[i - 1][j - 1] + mult))
					dp[i][j] = dp[i - 1][j], precursor[i][j] = pii(true, false);
				else
					dp[i][j] = dp[i][j - 1], precursor[i][j] = pii(true, false);
			}
		}

		vector<int> ans;
		int i = n, j = n;
		while (ans.size() < dp[n][n]) {
			if (a[i - 1] == b[j - 1])
				ans.push_back(a[i - 1]);
			pair<int, int> neww(i, j);
			if (precursor[i][j].first)
				neww.first--;
			if (precursor[i][j].second)
				neww.second--;

			i = neww.first;
			j = neww.second;
		}

		reverse(ans.begin(), ans.end());
		return ans;
	}

	vector<int> ans;
	for (int i = 0; i < a.size(); i++) {
		if (hint[i] == true)
			ans.push_back(a[i]);
	}
	return ans;
}
