#include <vector>
#include <math.h>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    int need = min(log2((int)a.size()),log2((int)b.size()));
    vector<bool> ans;
    for(int i = 0,j = 0; i < b.size() && j < sol.size(); ++i) {
        if(b[i] == sol[j]) {
            ans.push_back(1);
            ++j;
        } else {
            ans.push_back(0);
        }
    }
    while(ans.size() && !ans.back()) ans.pop_back();
    vector<bool> real_ans;
    for(int i = 0; i < ans.size(); ++i) {
        int j = i,cnt = 1;
        while(j + 1 < ans.size() && ans[j + 1] == ans[j]) {
            ++j;
            ++cnt;
        }
        if(cnt == 1) {
            real_ans.push_back(0);
            real_ans.push_back(ans[i]);
        } else {
            real_ans.push_back(1);
            for(int q = need;q >= 0; --q) {
                if(cnt & (1 << q)) {
                    real_ans.push_back(1);
                } else {
                    real_ans.push_back(0);
                }
            }
            real_ans.push_back(ans[i]);
        }
        i = j;
    }
    return real_ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    int need = min(log2((int)a.size()),log2((int)b.size()));
    vector<int> ans;
    for(int i = 0,j = 0; i < hint.size() && j < b.size();) {
        if(hint[i]) {
            ++i;
            int cnt = 0;
            for(int q = need;q >= 0; --q,++i) {
                if(hint[i]) {
                    cnt += (1 << q);
                }
            }
            if(hint[i] == 0) {
                while(cnt--) ++j;
            } else {
                while(cnt--) ans.push_back(b[j]),++j;
            }
        } else {
            ++i;
            if(hint[i]) ans.push_back(b[j]);
            ++i,++j;
        }
    }
    return ans;
}

