#include <vector>
#include <math.h>
#include <iostream>
#include <algorithm>
using namespace std;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if(a.size() <= 10000 && b.size() <= 10000) {
        vector<bool> ans;
        return ans;
    }
    int need = min(log2((int)a.size()),log2((int)b.size()));
    vector<bool> ans;
    if(b.size() < a.size()) {
        ans.push_back(1);
        for(int i = 0,j = 0; i < b.size() && j < sol.size(); ++i) {
            if(b[i] == sol[j]) {
                ans.push_back(1);
                ++j;
            } else {
                ans.push_back(0);
            }
        }
    } else {
        ans.push_back(0);
        for(int i = 0,j = 0; i < a.size() && j < sol.size(); ++i) {
            if(a[i] == sol[j]) {
                ans.push_back(1);
                ++j;
            } else {
                ans.push_back(0);
            }
        }
    }
    while(ans.size() && !ans.back()) ans.pop_back();
    vector<bool> real_ans;
    real_ans.push_back(ans[0]);
    for(int i = 1; i < ans.size(); ++i) {
        int j = i,cnt = 1;
        while(j + 1 < ans.size() && ans[j + 1] == ans[j]) {
            ++j;
            ++cnt;
        }
        if(cnt == 1) {
            real_ans.push_back(0);
            real_ans.push_back(ans[i]);
        } else {
            real_ans.push_back(1);
            for(int q = need; q >= 0; --q) {
                if(cnt & (1 << q)) {
                    real_ans.push_back(1);
                } else {
                    real_ans.push_back(0);
                }
            }
            real_ans.push_back(ans[i]);
        }
        i = j;
    }
    vector<bool> out;
    if(ans.size() < real_ans.size()) {
        out.push_back(0);
        for(bool x : ans) out.push_back(x);
    } else {
        out.push_back(1);
        for(bool x : real_ans) out.push_back(x);
    }
    return out;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if(hint.size() == 0) {
        vector<vector<int> > dp(a.size(),vector<int> (b.size()));
        for(int i = 0;i < a.size(); ++i) {
            for(int j = 0;j < b.size(); ++j) {
                if(a[i] == b[j]) {
                    if(i - 1 >= 0 && j - 1 >= 0) dp[i][j] = max(dp[i][j],dp[i - 1][j - 1] + 1);
                    else dp[i][j] = max(dp[i][j],1);
                }
                if(i - 1 >= 0) dp[i][j] = max(dp[i - 1][j],dp[i][j]);
                if(j - 1 >= 0) dp[i][j] = max(dp[i][j - 1],dp[i][j]);
            }
        }
        vector<int> ans;
        int i = a.size() - 1,j = b.size() - 1;
        while(true) {
            if((i - 1 >= 0 && j - 1 >= 0 && dp[i][j] == dp[i - 1][j - 1] + 1) || ((i == 0 || j == 0) && dp[i][j] == 1)) ans.push_back(a[i]),--i,--j;
            else if(i - 1 >= 0 && dp[i][j] == dp[i - 1][j]) --i;
            else if(j - 1 >= 0 && dp[i][j] == dp[i][j - 1]) --j;
            else break;
        }
        reverse(ans.begin(),ans.end());
        return ans;
    }
    vector<int> ans;
    if(hint[0]) {
        int need = min(log2((int)a.size()),log2((int)b.size()));
        if(hint[1]) {
            for(int i = 2,j = 0; i < hint.size() && j < b.size();) {
                if(hint[i]) {
                    ++i;
                    int cnt = 0;
                    for(int q = need; q >= 0; --q,++i) {
                        if(hint[i]) {
                            cnt += (1 << q);
                        }
                    }
                    if(hint[i] == 0) {
                        while(cnt--) ++j;
                    } else {
                        while(cnt--) ans.push_back(b[j]),++j;
                    }
                    ++i;
                } else {
                    ++i;
                    if(hint[i]) ans.push_back(b[j]);
                    ++i,++j;
                }
            }
        } else {
            for(int i = 2,j = 0; i < hint.size() && j < a.size();) {
                if(hint[i]) {
                    ++i;
                    int cnt = 0;
                    for(int q = need; q >= 0; --q,++i) {
                        if(hint[i]) {
                            cnt += (1 << q);
                        }
                    }
                    if(hint[i] == 0) {
                        while(cnt--) ++j;
                    } else {
                        while(cnt--) ans.push_back(a[j]),++j;
                    }
                    ++i;
                } else {
                    ++i;
                    if(hint[i]) ans.push_back(a[j]);
                    ++i,++j;
                }
            }
        }
    } else {
        if(hint[1]) {
            for(int i = 2; i < hint.size(); ++i) {
                if(hint[i]) {
                    ans.push_back(b[i - 2]);
                }
            }
        } else {
            for(int i = 2; i < hint.size(); ++i) {
                if(hint[i]) {
                    ans.push_back(a[i - 2]);
                }
            }
        }
    }
    return ans;
}
/*
5 5
1 2 100 4 5
1 2 1 4 5
4
1 2 4 5
*/
