#include <iostream>
#include <vector>
#include "hint.h"

using namespace std;

static int n, m, k;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> hint;
    if (a.size() < b.size()) {
        int j = 0;
        hint.assign(a.size(), false);
        for (int i = 0; i < a.size() && j < sol.size(); ++i) {
            if (a[i] == sol[j]) {
                hint[i] = true;
                ++j;
            }
        }
    } else {
        int j = 0;
        hint.assign(b.size(), false);
        for (int i = 0; i < b.size() && j < sol.size(); ++i) {
            if (b[i] == sol[j]) {
                hint[i] = true;
                ++j;
            }
        }
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> res;
    if (a.size() < b.size()) {
        for (int i = 0; i < a.size(); ++i) {
            if (hint[i]) {
                res.push_back(a[i]);
            }
        }
    } else {
        for (int i = 0; i < b.size(); ++i) {
            if (hint[i]) {
                res.push_back(b[i]);
            }
        }
    }
    return res;
}