#include <iostream>
#include <vector>
#include "hint.h"
#include <algorithm>

using namespace std;

static int n, m, k;

std::vector<bool> genHint(const std::vector<int>& aa, const std::vector<int>& bb, const std::vector<int>& sol) {
    vector<bool> hint;
    auto a = aa, b = bb;
    if (a.size() > b.size()) {
        swap(a, b);
    } // a.size() <= b.size()
    if (18 * sol.size() > a.size()) {
        int j = 0;
        hint.assign(a.size(), false);
        for (int i = 0; i < a.size() && j < sol.size(); ++i) {
            if (a[i] == sol[j]) {
                hint[i] = true;
                ++j;
            }
        }
    } else {
        int j = 0;
        for (int i = 0; i < a.size() && j < sol.size(); ++i) {
            if (a[i] == sol[j]) {
                int ii = i;
                vector<bool> bits;
                for (int k = 0; k < 18; ++k) {
                    bits.push_back(ii & 1);
                    ii >>= 1;
                }
                reverse(bits.begin(),  bits.end());
                for (auto k : bits) {
                    hint.push_back(k);
                }
                ++j;
            }
        }
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& aa, const std::vector<int>& bb, const std::vector<bool>& hint) {
    vector<int> res;
    auto a = aa, b = bb;
    if (a.size() > b.size()) {
        swap(a, b);
    } // a.size() <= b.size()
    if (hint.size() == a.size()) {
        for (int i = 0; i < a.size(); ++i) {
            if (hint[i]) {
                res.push_back(a[i]);
            }
        }
    } else {
        for (int i = 0; i < hint.size(); i += 18) {
            int num = 0;
            for (int j = i; j < i + 18; ++j) {
                num = num * 2 + hint[j];
            }
            res.push_back(num);
        }
    }
    return res;
}