#include <iostream>
#include <vector>
#include "hint.h"
#include <algorithm>

using namespace std;
vector<int> kvadrat(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1, 0));
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < b.size(); ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = 1 + dp[i][j];
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    vector<int> res;
    int i = a.size(), j = b.size();
    while (i > 0 && j > 0) {
        if (dp[i][j] > max(dp[i - 1][j], dp[i][j - 1])) {
            res.push_back(a[i - 1]);
            --i;
            --j;
        } else if (dp[i - 1][j] == dp[i][j]) {
            --i;
        } else {
            --j;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

const int CANSOLVE = 1e4;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> hint;
    if (a.size() < b.size()) {
        int j = 0;
        if (int(a.size()) - CANSOLVE < 0) {
            return hint;
        }
        hint.assign(int(a.size()) - CANSOLVE, false);
        for (int i = 0; i < hint.size() && j < sol.size(); ++i) {
            if (a[i] == sol[j]) {
                hint[i] = true;
                ++j;
            }
        }
    } else {
        int j = 0;
        if (int(b.size()) - CANSOLVE < 0) {
            return hint;
        }
        hint.assign(int(b.size()) - CANSOLVE, false);
        for (int i = 0; i < hint.size() && j < sol.size(); ++i) {
            if (b[i] == sol[j]) {
                hint[i] = true;
                ++j;
            }
        }
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> res;
    if (a.size() < b.size()) {
        int j = 0;
        for (int i = 0; i < hint.size(); ++i) {
            if (hint[i]) {
                while (b[j] != a[i]) {
                    ++j;
                }
                ++j;
                res.push_back(a[i]);
            }
        }
        vector<int> aa, bb;
        for (int i = hint.size(); i < a.size(); ++i) {
            aa.push_back(a[i]);
        }
        for (int i = j; i < b.size(); ++i) {
            bb.push_back(b[i]);
        }
        vector<int> add = kvadrat(aa, bb);
        for (int i : add) {
            res.push_back(i);
        }
    } else {
        int j = 0;
        for (int i = 0; i < b.size(); ++i) {
            if (hint[i]) {
                while (a[j] != b[i]) {
                    ++j;
                }
                ++j;
                res.push_back(b[i]);
            }
        }
        vector<int> aa, bb;
        for (int i = hint.size(); i < b.size(); ++i) {
            bb.push_back(b[i]);
        }
        for (int i = j; i < a.size(); ++i) {
            aa.push_back(a[i]);
        }
        vector<int> add = kvadrat(aa, bb);
        for (int i : add) {
            res.push_back(i);
        }
    }
    return res;
}