#include <bits/stdc++.h>

using namespace std;

struct order {
    long long t, x;
};

bool check(vector<order>& v, int num) {
    vector<order> lastOrder;
    for (auto [needT, needX] : v) {
        bool isDone = false;
        for (auto& [lastT, lastX] : lastOrder) {
            if (abs(needX - lastX) <= needT - lastT) {
                lastT = needT;
                lastX = needX;
                isDone = true;
                break;
            }
        }
        if (!isDone) {
            lastOrder.push_back({needT, needX});
            --num;
            if (num < 0) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<order> v(n);
    for (auto& [t, x] : v) {
        cin >> t >> x;
    }
    sort(v.begin(),  v.end(), [](order a, order b){
        return a.t < b.t;
    });
    int left = 0, right = n;
    while (left + 1 < right) {
        int mid = (left + right) / 2;
        if (check(v, mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    cout << right << '\n';
    return 0;
}
