#include "hint.h"

// #include <iostream>
// #include <vector>

// static int n, m, k;
// static std::vector<int> a, b, sol, maybeSol;
// static std::vector<bool> hint;

std::vector<std::vector<int>> dp(1e4 + 10, std::vector<int> (1e4 + 10, -1));

int calc(int i, int j, const std::vector<int>& a, const std::vector<int>& b) {
    if (dp[i][j] != -1) {
        return dp[i][j];
    }
    if (i == a.size() || j == b.size()) {
        return 0;
    }
    dp[i][j] = std::max(calc(i + 1, j, a, b), calc(i, j + 1, a, b));
    if (a[i] == b[j]) {
        dp[i][j] = std::max(dp[i][j], 1 + calc(i + 1, j + 1, a, b));
    }
    return dp[i][j];
    
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector<bool> ans(a.size(), 0);
    if (a.size() <= 1e4 && b.size() <= 1e4) {
        ans.resize(0);
        return ans;
    }
    int cur_pointer = 0;
    // std::cout << "dp - " <<  calc(0, 0, a, b) << std::endl;
    // sol.push_back(-INT_MAX);
    for (int i = 0; i < a.size(); i++) {
        if (cur_pointer >= sol.size()) continue;
        if (sol[cur_pointer] == a[i]) {
            ans[i] = 1;
            cur_pointer++;
        }
    }
    // sol.pop_back();
    return ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if (a.size() <= 1e4 && b.size() <= 1e4) {
        std::vector<std::vector<std::pair<int, int>>> values(b.size() + 1);
        for (int i = a.size(); i >= 0; i--) {
            for (int j = b.size(); j >= 0; j--) {
                int numb = calc(i, j, a, b);
                values[numb].push_back({i, j});
            }
        }
        std::pair<int, int> cur_ind = {0, 0};
        std::vector<int> ans;
        for (int i = values.size() - 1; i >= 0; i--) {
            for (auto j : values[i]) {
                if (cur_ind.first <= j.first && cur_ind.second <= j.second) {
                    cur_ind = j;
                }
                if (a[cur_ind.first] == b[cur_ind.second]) {
                    ans.push_back(a[cur_ind.first]);
                    break;
                }
            }
        }
        return ans;

    }
    std::vector<int> rez;
    for (int i = 0; i < hint.size(); i++) {
        if (hint[i]) {
            rez.push_back(a[i]);
        }
    }
    return rez;
}


// int main()
// {
//     std::cin >> n >> m;

//     a.resize(n);
//     b.resize(m);

//     for (int& num : a)
//     {
//         std::cin >> num;
//     }

//     for (int& num : b)
//     {
//         std::cin >> num;
//     }

//     std::cin >> k;

//     sol.resize(k);

//     for (int& num : sol)
//     {
//         std::cin >> num;
//     }

//     hint = genHint(a, b, sol);
//     for (auto i : hint) {
//         std::cout << i << ' ';
//     }
//     std::cout << "\n";
//     maybeSol = solve(a, b, hint);

//     std::cout << hint.size() << std::endl;
//     std::cout << maybeSol.size() << std::endl;

//     for (int i = 0; i < (int) maybeSol.size(); ++i)
//     {
//         if (i > 0) std::cout << " ";
//         std::cout << maybeSol[i];
//     }
//     std::cout << std::endl;

//     return 0;
// }
