#include "hint.h"

#include <iostream>
#include <vector>

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int dp[5010][5010];

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector<bool> ans;

    std::vector<int> ind_a, ind_b;

    int cur_pointer = 0;

    for (int i = 0; i < a.size(); i++) {
        if (cur_pointer >= sol.size()) {
            continue;
        }
        if (a[i] == sol[cur_pointer]) {
            cur_pointer++;
            ind_a.push_back(i);
        }
    }

    cur_pointer = 0;
    for (int i = 0; i < b.size(); i++) {
        if (cur_pointer >= sol.size()) {
            continue;
        }
        if (b[i] == sol[cur_pointer]) {
            cur_pointer++;
            ind_b.push_back(i);
        }
    }
    std::pair<int, int> last_slice = {a.size(), b.size()};
    std::vector<std::pair<int, int>> values;
    for (int i = ind_b.size() - 1; i >= 0; i--) {
        if (std::max(last_slice.first - ind_a[i], last_slice.second - ind_b[i]) > 300) {
            if (i + 1 == ind_b.size() || ind_b[i + 1] == last_slice.second) {
                values.push_back({ind_a[i], ind_b[i]});
                last_slice = {ind_a[i], ind_b[i]};
                continue;
            }
            values.push_back({ind_a[i + 1], ind_b[i + 1]});
            last_slice = {ind_a[i + 1], ind_b[i + 1]};
            i++;
            continue;
        }
    }

    if (last_slice.first != ind_a[0]) {
        values.push_back({ind_a[0], ind_b[0]});
    }

    std::vector<bool> h;
    for (auto i : values) {
        // std::cout << i.first << ' ' << i.second << std::endl;
        for (int j = 0, pow = 1;j < 18; j++, pow <<= 1) {
            if (pow & i.first) {
                h.push_back(1);
            } else {
                h.push_back(0);
            }
        }
        for (int j = 0, pow = 1; j < 18; j++, pow <<= 1) {
            if (pow & i.second) {
                h.push_back(1);
            } else {
                h.push_back(0);
            }
        }
    }
    return h;
    
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    std::pair<int, int> cur_val = {a.size(), b.size()};
    std::vector<std::pair<int, int>> values;
    for (int i= 0; i < hint.size() / 36; i++) {
        int a_ind = 0, b_ind = 0;
        for (int j = i * 36, pow = 1; j < (i ) * 36 + 18; j++, pow <<= 1) {
            if (hint[j]) {
                a_ind += pow;
            }
        }
        for (int j = (i) * 36 + 18, pow = 1; j < (i + 1) * 36; j++, pow <<= 1) {
            if (hint[j]) {
                b_ind += pow;
            }
        }
        values.push_back({a_ind, b_ind});
    }
    std::vector<int> ans;
    
    std::vector<int> cur_a, cur_b;
    std::vector<int> real_a = a, real_b = b;
    for (auto next_generation : values) {
        cur_a.clear();
        while (real_a.size() != next_generation.first) {
            cur_a.push_back(real_a.back());
            real_a.pop_back();
        }
        cur_b.clear();
        while (real_b.size() != next_generation.second) {
            cur_b.push_back(real_b.back());
            real_b.pop_back();
        }
        if (cur_a.size() > 300 || cur_b.size() > 300) {
            ans.push_back(a.back());
            continue;
        }  

        std::vector<std::vector<std::pair<int, int>>> per_count(cur_b.size() + 1);
        
        for (int i = cur_a.size(); i >= 0; i--) {
            for (int j = cur_b.size(); j >= 0; j--) {
                if (i == cur_a.size() || j == cur_b.size()) {
                    dp[i][j] = 0;
                    continue;
                }
                dp[i][j] = std::max(dp[i + 1][j], dp[i][j + 1]);
                if (cur_a[i] == cur_b[j]) {
                    dp[i][j] = std::max(dp[i][j], 1 + dp[i + 1][j + 1]);
                }
                per_count[dp[i][j]].push_back({i, j});
                // return dp[i][j];
                
            }
        }

        // for (int i = cur_a.size(); i >= 0; i--) {
        //     for (int j = cur_b.size(); j >= 0; j--) {
        //         int numb = calc(i, j, cur_a, cur_b);
        //         per_count[numb].push_back({i, j});
        //     }
        // }
        std::pair<int, int> cur_ind = {0, 0};
        std::vector<int> cur_ans;
        // std::cout << "become count" << std::endl;
        for (int i = per_count.size() - 1; i >= 0; i--) {
            // std::cout << "per count - " << i << std::endl;
            for (auto j : per_count[i]) {
                if (cur_ind.first <= j.first && cur_ind.second <= j.second) {
                    cur_ind = j;
                }
                if (cur_a[cur_ind.first] == cur_b[cur_ind.second]) {
                    cur_ans.push_back(cur_a[cur_ind.first]);
                    break;
                }
            }
        }
        for (int i = 0; i < cur_ans.size(); i++) {
            ans.push_back(cur_ans[i]);
        }
        // std::cout << "new cicle" << std::endl;

    }
    for (int i= 0; i < ans.size() / 2; i++) {
        std::swap(ans[i], ans[ans.size() - 1- i]);
    }
    return ans;
 
}


// int main()
// {
//     std::cin >> n >> m;

//     a.resize(n);
//     b.resize(m);

//     for (int& num : a)
//     {
//         std::cin >> num;
//     }

//     for (int& num : b)
//     {
//         std::cin >> num;
//     }

//     std::cin >> k;

//     sol.resize(k);

//     for (int& num : sol)
//     {
//         std::cin >> num;
//     }

//     hint = genHint(a, b, sol);
//     for (auto i : hint) {
//         std::cout << i << ' ';
//     }
//     std::cout << "\n";
//     maybeSol = solve(a, b, hint);

//     std::cout << hint.size() << std::endl;
//     std::cout << maybeSol.size() << std::endl;

//     for (int i = 0; i < (int) maybeSol.size(); ++i)
//     {
//         if (i > 0) std::cout << " ";
//         std::cout << maybeSol[i];
//     }
//     std::cout << std::endl;

//     return 0;
// }
