#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;

struct DSU {
    vi parents;
    vi size;
    DSU(int n) {
        size = vi(n, 1);
        parents.resize(n);
        for (int i = 0; i < n; i++) {
            parents[i] = i;
        }
    }

    int get(int v) {
        if (parents[v] == v) {
            return v;
        }
        return parents[v] = get(parents[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (size[u] > size[v]) {
            swap(u, v);
        }
        size[v] += size[u];
        parents[u] = v;
    }
};

vvi gr;
vi used;
int ans_0 = 0, ans_1 = 0;
void dfs(int v, int val=0) {
    used[v] = 1;
    for (auto i : gr[v]) {
        if (!used[i]) {
            dfs(i);
        }
    }
    if (gr[v].size() <= 1) {
        ans_0 += val;
        ans_1 += !val;
    }
}


void solution() {
    
    int n;
    cin >> n;
    vpi mass(n);
    for (int i = 0; i < n; i++) {
        cin>> mass[i].first >> mass[i].second;
    }    
    sort(mass.begin(), mass.end());
    // for (auto i : mass) {
    //     cout << i.first << ' ' << i.second << endl;
    // }
    DSU d(n);
    gr = vvi(n);
    used = vi(n, 0);
    vpi out;
    for (int i = 0; i < n; i++) {
        for (int j = out.size() - 1; j >= 0; j--) {
            if (mass[i].first - out[j].second >= abs(mass[i].second - out[j].second)) {
                if (d.get(i) != d.get(j)) {
                    d.unite(i, j);
                    gr[i].push_back(j);
                    gr[j].push_back(i);
                }
            }
        }
        out.push_back(mass[i]);
    }
    // for (int i = 0; i < n; i++) {
    //     cout << i << " - ";
    //     for (auto j : gr[i]) {
    //         cout << j << ' ';
    //     }
    //     cout<< endl;
    // }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, 1);
        }
    }
    cout << max(ans_0, ans_1) << endl;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    t = 1;
    while (t--) {
        solution();
    }
    return 0;
}