#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using pi = pair<ll, ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;

struct DSU {
    vi parents;
    vi size;
    DSU(int n) {
        size = vi(n, 1);
        parents.resize(n);
        for (int i = 0; i < n; i++) {
            parents[i] = i;
        }
    }

    int get(int v) {
        if (parents[v] == v) {
            return v;
        }
        return parents[v] = get(parents[v]);
    }

    void unite(int u, int v) {
        u = get(u);
        v = get(v);
        if (size[u] > size[v]) {
            swap(u, v);
        }
        size[v] += size[u];
        parents[u] = v;
    }
};

vvi gr;
vi used;
vi parent;
vvi kids;
int ans_0 = 0, ans_1 = 0;

void dfs(int v) {
    used[v] = 1;
    for (auto i : gr[v]) {
        if (!used[i]) {
            dfs(i);
        }
    }
    if (gr[v].size() <= 1) {
        if (parent[v]) {
            ans_0++;
        } else {
            ans_1++;
        }
    }
}


void solution() {
    
    int n;
    cin >> n;
    parent = vi(n, 0);
    vpi mass(n);

    for (int i = 0; i < n; i++) {
        cin>> mass[i].first >> mass[i].second;
    }    
    sort(mass.begin(), mass.end());
    // for (auto i : mass) {
    //     cout << i.first << ' ' << i.second << endl;
    
    // }
    // cout << endl;
    DSU d(n);
    gr = vvi(n);
    used = vi(n, 0);
    kids = vvi(n);
    vpi out;
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            // cout << i << " " << j << " - " <<  mass[i].first << " " << mass[j].second << " " << abs(mass[i].second - mass[j].second) << endl;
            if (mass[i].first - mass[j].first >= abs(mass[i].second - mass[j].second)) {
                if (d.get(i) != d.get(j)) {
                    // cout << i << " " << j << endl;
                    if (gr[j].size() == 0) {
                        parent[j]  = 1;
                    }
                    d.unite(i, j);
                    
                    gr[j].push_back(i);
                    gr[i].push_back(j);
                }
            }
        }
        out.push_back(mass[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            // cout << i << endl;
            dfs(i);
            ans += max(ans_1, ans_0);
            ans_1 = 0;
            ans_0 = 0;
        }
    }
    cout << ans << endl;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    t = 1;
    while (t--) {
        solution();
    }
    return 0;
}