#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <cmath>

using ll = long long;

int const nmax = 10000;

std::vector<int> scarepickoff(int n, int s, int c) {
  int mid = ((n + 1) / 2);
  int counter = 0, lim = s + c;
  int l1 = 1, l2 = mid, r1 = mid, r2 = n;
  std::vector<int> sol;
  
  //std::cout << "startoff\n";

  while(l1 != -1 || r1 != n + 1) {
    int sz1 = l2 - l1 + 1;
    int sz2 = r2 - r1 + 1;
    
    if(l1 == -1)
      sz1 = 0;
    if(r1 == n + 1)
      sz2 = 0;
    if(counter < s) {
      if(sz1 <= sz2) {
        sol.push_back(r1);
        if(1 < l2) l2--;
        if(1 < l1) l1--;
        
        r1++;
        if(l2 < l1)
          l1 = l2 = -1;
        if(r2 < r1)
          r1 = r2 = n + 1;
        if(r1 < n) r1++;
        if(r2 < n) r2++;
      } else {
        sol.push_back(l2);
        l2--;
        if(r1 < n)
          r1++;
        if(r2 < n) r2++;
        
        if(l2 < l1)
          l1 = l2 = -1;
        if(1 < l1) l1--;
        if(1 < l2) l2--;
        if(r2 < r1)
          r1 = r2 = n + 1;
      }
    } else {
      if(sz1 <= sz2) {
        if(r1 == r2) {
          sol.push_back(r1);
          r1 = r2 = n + 1;
          continue;
        }
        sol.push_back(r2 - 1);
        l1++;
        l2++;
        if(r1 < r2 - 1) r1++;
          r2--;
      } else {
        if(l1 == l2) {
          sol.push_back(l1);
          l1 = l2 = -1;
          continue;
        }
        sol.push_back(l1 + 1);
        r1--;
        r2--;
        l1++;
        if(l1 + 1 < l2)
          l2--;
      }
    }
    counter = (counter + 1) % lim;
  }
  return sol;
}

std::vector<int> scareside(int n, int s, int c) {
  int mid = ((n + 1) / 2);
  int counter = 0, lim = s + c;
  int l1 = 1, l2 = n;
  std::vector<int> sol;
  
  //std::cout << "startside\n";

  while(l1 <= l2) {
    if(counter < s) {
      sol.push_back(l1);
      if(l1 == l2)
        return sol;
      l1++;
      if(l2 < n) l2++;
    } else {
      if(l1 == l2) {
        sol.push_back(l1);
        return sol;
      }
      sol.push_back(l2 - 1);
      if(l1 < l2 - 1)
        l1++;
      l2--;
    }
    counter = (counter + 1) % lim;
  }
  return sol;

}

int main() {
  int n, s, c;
  std::cin >> n >> s >> c;
  std::vector<int> sol1, sol2;
  sol1 = scarepickoff(n, s, c);
  sol2 = scareside(n, s, c);
  
  int t = n * (s + c) / (s + std::max(s, c)) + std::max(s, c);

  std::cerr << "actual limit: " << t << std::endl;

  if(sol1.size() < sol2.size()) {
    std::cout << sol1.size() << '\n';
    for(int i = 0; i < sol1.size(); i++)
      std::cout << sol1[i] << " ";
    std::cout << '\n';
  } else {
    std::cout << sol2.size() << '\n';
    for(int i = 0; i < sol2.size(); i++)
      std::cout << sol2[i] << " ";
    std::cout << '\n';
  }
  return 0;
}
