#include "hint.h"
#include <iostream>
#include <vector>
#include <stack>

using namespace std; 

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    return vector<bool>(); 
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    int a_s = a.size(), b_s = b.size(); 
    vector<vector<int>> dp(a_s+1, vector<int>(b_s+1, 0)); 
    for (int sum = 2; sum <= a_s + b_s; ++sum){
        for (int i = 1; i <= min(sum, a_s); ++i){
            int j = sum - i; 
            if (j > b_s || j < 1) continue; 
            dp[i][j] = max(dp[i][j-1], dp[i-1][j]); 
            if (a[i-1] == b[j-1]) dp[i][j] = max(dp[i][j], dp[i-1][j-1] + 1);  
        }
    }
    
    int i = a_s, j = b_s; 
    stack<int> st; 
    while (i > 0 && j > 0){
        if (dp[i][j] == dp[i][j-1]){
            j--;
            continue; 
        }
        if (dp[i][j] == dp[i-1][j]){
            i--; 
            continue; 
        }
        st.push(a[i-1]);   
        i--, j--; 
    }

    vector<int> res;
    while (!st.empty()){
        res.push_back(st.top()); st.pop(); 
    }
    return res; 
}
/*
int main(){
    vector<int> a(4), b(5); 
    a[0] = a[1] = 1;
    a[2] = a[3] = 0;
    b[0] = b[4] = 1; 
    b[1] = b[2] = b[3] = 5; 
    vector<bool> hint(0); 
    vector<int> res = solve(a, b, hint); 
    for (int a : res) cout << a << " "; 
}*/