#include "hint.h"
#include <iostream>
#include <vector>
#include <stack>

using namespace std; 

vector<bool> conv(vector<int> & res){
    vector<bool> data; 
    for (int a : res){
        for (int i = 0; i < 18; ++i){
            data.push_back(a >> i); 
        }
    }
    return data; 
}

vector<int> reconv(const vector<bool> & hint){
    vector<int> data; 
    for (int j = 0; j < hint.size(); j += 18){
        int r = 0; 
        for (int i = 0; i < 18; ++i){
            r += hint[i+j] << i; 
        }
        data.push_back(r);
    }
    return data; 
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    //find ind
    vector<int> ind_a, ind_b; 
    int ia = 0, ib = 0;
    for (int c : sol){
        while (a[ia] != c) ia++; 
        while (b[ib] != c) ib++; 
        ind_a.push_back(ia++); 
        ind_b.push_back(ib++); 
    }
    //split to sqrtn segments
    vector<int> res; 
    const int bar = 3000; 
    int now = 0; 
    for (int i = 1; i <= sol.size(); ++i){
        if (i == sol.size() || ind_a[now] + bar < ind_a[i] || ind_b[now] + bar < ind_b[i]){
            res.push_back(ind_a[now]);
            res.push_back(ind_b[now]); 
            res.push_back(ind_a[i-1]);
            res.push_back(ind_b[i-1]); 
            now = i; 
        }
    }
    return conv(res); 
}

vector<int> seg_solve(int s_a, int e_a, int s_b, int e_b, const std::vector<int>& a, const std::vector<int>& b){
int a_s = e_a - s_a + 1, b_s = e_b - s_b + 1; 
    vector<vector<int>> dp(a_s+1, vector<int>(b_s+1, 0)); 
    for (int sum = 2; sum <= a_s + b_s; ++sum){
        for (int i = 1; i <= min(sum, a_s); ++i){
            int j = sum - i; 
            if (j > b_s || j < 1) continue; 
            dp[i][j] = max(dp[i][j-1], dp[i-1][j]); 
            if (a[s_a + i -1] == b[s_b + j -1]) dp[i][j] = max(dp[i][j], dp[i-1][j-1] + 1);  
        }
    }
    int i = a_s, j = b_s; 
    stack<int> st; 
    while (i > 0 && j > 0){
        if (dp[i][j] == dp[i][j-1]){
            j--;
            continue; 
        }
        if (dp[i][j] == dp[i-1][j]){
            i--; 
            continue; 
        }
        st.push(a[i-1]);   
        i--, j--; 
    }

    vector<int> res;
    while (!st.empty()){
        res.push_back(st.top()); st.pop(); 
    }
    return res; 
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    vector<int> ind = reconv(hint), res; 
    for (int j = 0; j < ind.size(); j += 4){
        vector<int> now = seg_solve(ind[j], ind[j+2], ind[j+1], ind[j+3], a, b); 
        for (int a : now) res.push_back(a); 
    }
    return res;
}
