#include <iostream>
#include <vector>

using namespace std; 

vector<int> c_signf(int n, int s, int c){
    vector<int> res;
    int l = 1, r = n, ind = 0; 

    while (l < r){
        if (ind % (s + c) < s){
            res.push_back(r);
            r -= 2; 
            l = max(l-1, 1); 
            if (l >= r) res.push_back(l); 
        }
        else {
            int mid = (l + r) >> 1; 
            res.push_back(mid);
            l++;
            r--; 
            if (l >= r) res.push_back(mid); 
        }
        ind++;
    }
    return res; 
}

vector<int> s_signf(int n, int s, int c){
    vector<int> res;
    int ind = 0, bar = 1; 
    while (bar < n){
        if (ind % (s+c) < s){
            res.push_back(bar);  
            bar += 2; 
        }
        else {
            res.push_back(n); 
            bar++; 
        }
        ind++;
    }
    res.push_back(n); 
    return res; 
}

vector<int> s_very_signf(int n, int s, int c, int st){
    vector<int> res;
    int le = st;
    int rs = st; 
    int ind = 0; 

    while (rs < n){
        if (ind % (s+c) < s){
            res.push_back(rs); 
            le = max(1, le-1); 
            rs += 2; 
        }
        else {
            res.push_back(n); 
            le++;
            rs++; 
        }
        ind++;
    }

    if (ind % (s+c) < s) le = max(1, le-1); 
    else le++; 
    res.push_back(n);
    ind++; 

    while (le > 1){
        if (ind % (s+c) < s){
            res.push_back(le); 
            le -= 2; 
        }
        else {
            res.push_back(1); 
            le--; 
        }
        ind++;
    }
    res.push_back(1); 
    
    return res; 
}

void print(vector<int> & res){
    cout << res.size() << "\n"; 
    for (int a : res) cout << a << " "; 
}

int main(){
    int n,s,c; cin >> n >> s >> c;
    vector<int> one = c_signf(n, s, c); 
    vector<int> two = s_signf(n, s, c);
    vector<int> three = s_very_signf(n, s, c, 1);
    for (int i = 2; i <= n; i += max(1, n/1000)){
        vector<int> now = s_very_signf(n, s, c, i); 
        if (now.size() < three.size()) three = now; 
    }

    int best = one.size(); 
    best = min(best, (int)two.size()); 
    best = min(best, (int)three.size()); 
    
    if (one.size() == best) print(one);
    else if (two.size() == best) print(two); 
    else print(three); 
    
}
