#include <vector>

#include "hint.h"

std::vector <bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	std::vector <bool> hint(sol.size() << 5);
	int val;
	for (int index = 0; index < sol.size(); index++) {
		val = sol[index];
		for (int index2 = 31; index2 >= 0; index2--) {
			hint[index * 32 + index2] = val & 1;
			val >>= 1;
		}
	}
	return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	std::vector <int> sol(hint.size() >> 5);
	for (int index = 0; index < sol.size(); index++) {
		for (int index2 = 31; index2 >= 0; index2--) {
			sol[index] |= hint[index * 32 + index2] << (31 - index2);
		}
	}
	return sol;
}