#ifndef LOCAL
#include "hint.h"
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

vector<int> get_lcs(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 3, vector<int>(b.size() + 3, 0));

    for(int i = 0; i < a.size(); i++)
    for(int j = 0; j < b.size(); j++) {
        if(a[i] == b[j]) {
            dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + 1);
        }
        else {
            dp[i + 1][j + 1] = max(dp[i + 1][j], dp[i][j + 1]);
        }
    }

    vector<int> ret;
    int i = a.size(), j = b.size();
    while(dp[i][j] > 0) {
        if(a[i - 1] == b[j - 1]) {
            ret.push_back(a[i - 1]);
            --i; --j;
        }
        else if(dp[i][j] == dp[i - 1][j]) {
            --i;
        }
        else {
            --j;
        }
    }

    reverse(ret.begin(), ret.end());
    return ret;
}

vector<bool> genHint(const vector<int>&a, const vector<int>& b, const vector<int>& sol) {
    if(sol.size() == 0) {
        return vector<bool>(1, 0);
    }

    vector<int> ind_a;
    {
        ind_a.push_back(0);
        int ptr_sol = 0;
        for(int ptr_a = 0; ptr_a < a.size(); ptr_a++) {
            if(ptr_sol < sol.size() && a[ptr_a] == sol[ptr_sol]) {
                ind_a.push_back(ptr_a + 1);
                ptr_sol++;
            }
        }
        ind_a.push_back(a.size() + 1);
    }

    vector<int> ind_b;
    {
        ind_b.push_back(0);
        int ptr_sol = 0;
        for(int ptr_b = 0; ptr_b < b.size(); ptr_b++) {
            if(ptr_sol < sol.size() && b[ptr_b] == sol[ptr_sol]) {
                ind_b.push_back(ptr_b + 1);
                ptr_sol++;
            }
        }
        ind_b.push_back(b.size() + 1);
    }

#ifdef DEBUG
    cerr << "Inds: " << ind_a.size() << " " << ind_b.size() << endl;
    for(auto e : ind_a)
        cerr << e << " ";
    cerr << endl;
    for(auto e : ind_b)
        cerr << e << " ";
    cerr << endl;
#endif // LOCAL

    const int bulan = 10000;
    const int contrabulan = 800;

    const int max_j = 18;

    int64_t dp[sol.size() + 7][max_j + 2];
    memset(dp, 0x37, sizeof(dp));
    int64_t ret_prev[sol.size() + 7][max_j + 2];

    for(int j = 0; j < max_j; j++) {
        dp[0][j] = 0;
    }
    for(int i = 1; i < ind_a.size(); i++) {
        for(int j = 1; j < max_j; j++) {
            for(int prev = max(0, i - bulan); prev < min(i, max(0, i - bulan) + contrabulan); prev++) {
                if(prev + 1 == i || prev + 2 == i) {
                    if(dp[prev][j - 1] < dp[i][j]) {
                        dp[i][j] = dp[prev][j - 1];
                        ret_prev[i][j] = prev;
                    }
                }
                else {
                    if(dp[prev][j - 1] + (1LL * ind_a[i] - ind_a[prev]) * (1LL * ind_b[i] - ind_b[prev]) < dp[i][j]) {
                        dp[i][j] = dp[prev][j - 1] + (1LL * ind_a[i] - ind_a[prev]) * (1LL * ind_b[i] - ind_b[prev]);
                        ret_prev[i][j] = prev;
                    }
                }
            }
        }
    }

    int j = max_j - 1, i = ind_a.size() - 1;
    for(int minj = max_j - 2; minj >= 1; minj--) {
        if(dp[i][minj] < dp[i][j])
            j = minj;
    }

#ifdef LOCAL
    cerr << "Best dp: " << dp[i][j] << endl;
#endif // LOCAL

    vector<pair<int, int>> bestway;
    while(i > 0) {
        bestway.push_back({i, j});
        i = ret_prev[i][j]; j -= 1;
    }
    reverse(bestway.begin(), bestway.end());

    vector<bool> ret;
    for(int i = 0; i < bestway.size(); i++) {

        // First the bit that does the 'should be computed'
        if(i == 0) {
            if(bestway[i].first <= 2) {
                ret.push_back(0);
            }
            else {
                ret.push_back(1);
            }
        }
        else {
            if(bestway[i - 1].first + 2 >= bestway[i].first)
                ret.push_back(0);
            else
                ret.push_back(1);
        }

        // Next, the indexs
        if(i != bestway.size() - 1) { // EOS
            for(int mask = 1; mask < (int)a.size(); mask *= 2) {
                if(mask & ind_a[bestway[i].first])
                    ret.push_back(1);
                else ret.push_back(0);
            }
            for(int mask = 1; mask < (int)b.size(); mask *= 2) {
                if(mask & ind_b[bestway[i].first])
                    ret.push_back(1);
                else ret.push_back(0);
            }
        }
    }

    return ret;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector<bool> ret = hint;
    if(ret.size() == 1 && ret[0] == 0) {
        return vector<int>(0);
    }

    int maskasz = 0;
    for(int mask = 1; mask < (int)a.size(); mask *= 2)
        maskasz++;
    int maskbsz = 0;
    for(int mask = 1; mask < (int)b.size(); mask *= 2)
        maskbsz++;

    assert((hint.size() - 1) % (maskasz + maskbsz + 1) == 0);
    int nr_indexs = (hint.size() - 1) / (maskasz + maskbsz + 1);

    vector<pair<pair<int, int>, int>> bestway; // <<ind_a, ind_b>, type>
    for(int i = 0; i < nr_indexs + 1; i++) {
        if(i == 0) {
            bestway.push_back({{a.size() + 1, b.size() + 1}, ret.back()});
            ret.pop_back();
        }
        else {
            int ind_a = 0, ind_b = 0;
            for(int mask = 1; mask < (int)b.size(); mask *= 2) {
                ind_b = 2 * ind_b + ret.back();
                ret.pop_back();
            }
            for(int mask = 1; mask < (int)a.size(); mask *= 2) {
                ind_a = 2 * ind_a + ret.back();
                ret.pop_back();
            }

            bestway.push_back({{ind_a, ind_b}, ret.back()});
            ret.pop_back();
        }
    }
    bestway.push_back({{0, 0}, 0});


    reverse(bestway.begin(), bestway.end());
#ifdef DEBUG
    for(auto e : bestway)
        cerr << e.first.first << " " << e.first.second << " " << e.second << endl;
#endif

    vector<int> lcs;

    for(int i = 1; i < bestway.size(); i++) {
        if(bestway[i].second == 0) {
            unordered_set<int> freq;
            for(int ptr_a = bestway[i - 1].first.first + 1; ptr_a < bestway[i].first.first; ptr_a++) {
                freq.insert(a[ptr_a - 1]);
            }
            for(int ptr_b = bestway[i - 1].first.second + 1; ptr_b < bestway[i].first.second; ptr_b++) {
                if(freq.find(b[ptr_b - 1]) != freq.end()) {
                    lcs.push_back(b[ptr_b - 1]); break;
                }
            }
        }
        else {
            // Do lcs for segment
            vector<int> aslice;
            for(int ptr_a = bestway[i - 1].first.first + 1; ptr_a < bestway[i].first.first; ptr_a++) {
                aslice.push_back(a[ptr_a - 1]);
            }
            vector<int> bslice;
            for(int ptr_b = bestway[i - 1].first.second + 1; ptr_b < bestway[i].first.second; ptr_b++) {
                bslice.push_back(b[ptr_b - 1]);
            }

            vector<int> temp_lcs = get_lcs(aslice, bslice);

            for(auto e : temp_lcs) {
                lcs.push_back(e);
            }
        }

        if(i != bestway.size() - 1)
            lcs.push_back(a[bestway[i].first.first - 1]);
    }

    return lcs;
}

#ifdef LOCAL

static int n, m;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        //std::cin >> num;
        num = rand() % 20;
    }

    for (int& num : b)
    {
        //std::cin >> num;
        num = rand() % 20;
    }

    auto sol = get_lcs(a, b);

    /*
    cout << sol.size() << endl;
    for(auto e : sol)
        cout << e << " ";
    cout << endl;
    */

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    //std::cout << maybeSol.size() << std::endl;

    /*
    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;
    */

    assert(sol.size() == maybeSol.size());

    return 0;
}
#endif // LOCAL
