#include <bits/stdc++.h>

using namespace std;

int clip(int x, int l, int r) {
    if(x < l) return l;
    if(x > r) return r;
    return x;
}

vector<int> solve(int n, int s, int c) {
    if(c == 0) {
        vector<int> ans;

        int l = n / 2; int r = l + 1;
        while(l >= 1 && r <= n) {
            if(l - 1 + 1 >= n - r + 1) {
                ans.push_back(l);
                if(r < n)
                    r += 1;
                l -= 1;
                if(l > 1)
                    l -= 1;
            }
            else {
                ans.push_back(r);
                if(l > 1)
                    l -= 1;
                r += 1;
                if(r < n)
                    r += 1;
            }
        }

        if(r == n) {
            ans.push_back(n);
        }
        if(l == 1) {
            ans.push_back(1);
        }

        return ans;
    }

    if(s == 0) {
        double magic = (1.0 * n * (1.0 * s + 1.0 * c)) / (1.0 * s + 2.0 * max(s, c)) + 3.0 * max(1.0 * s, 1.0 * c);
        vector<int> ans(floor(magic), n / 2);
        return ans;
    }

    vector<int> ans;
    {
        int l = 1, r = n;
        int index = 0;

        while(l <= r) {
    #ifdef DEBUG
            cerr << l << " " << r << endl;
    #endif // LOCAL

            if(l == r) {
                ans.push_back(l); break;
            }

            if(index % (s + c) < s) {
                // Scared case, query at L
                ans.push_back(l);
                // restrict [l..r]
                l = clip(l + 2, 1, n);
                r = clip(r + 1, 1, n);
            }
            else {
                // Curious case, query at R - 1
                ans.push_back(r - 1);
                // restrict
                if(l < ans.back())
                    l = clip(l + 1, 1, n);
                if(r > ans.back())
                    r = clip(r - 1, 1, n);
            }


            index++;
        }
    }

    return ans;
}


int main() {
    int n, s, c; cin >> n >> s >> c;
    auto sol = solve(n, s, c);
    cout << sol.size() << endl;
    for(auto e : sol)
        cout << e << " ";
    cout << endl;

    /*
    for(int n = 200; n <= 1e4; n++) {
        cerr << "\t\t\t\t" << n << endl;
        for(int s = 0; s <= 50; s++) {
            for(int c = 0; c <= 50; c++) {
                if(s + c == 0) continue;
                double magic = (1.0 * n * (1.0 * s + 1.0 * c)) / (1.0 * s + 2.0 * max(s, c)) + 3.0 * max(1.0 * s, 1.0 * c);
                auto sol = solve(n, s, c);

                if(sol.size() > magic) {
                    cerr << n << " " << s << " " << c << endl;
                    cerr << "\t" << magic << " " << sol.size() << endl;
                    cerr << endl;
                }
            }
        }
    }*/
}
