#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
const int RADNMAX = 500;
const  int NMAX = 200000;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    //cout << 1;
    vector<bool> hint;
    bool hintA[RADNMAX], hintB[RADNMAX];
    int rada, radb, lena, lenb, i, j, k, nra, nrb, pa, pb, lenc;
    lena = a.size();
    lenb = b.size();
    lenc = sol.size();
    nra = rada = sqrt(lena);
    if (rada * rada != lena)
        nra++;
    nrb = radb = sqrt(lenb);
    if (radb * radb != lenb)
        nrb++;
    pa = pb = 0;
    k = 0;
    j = i = -1;
    for (k = 0; k < lenc; k++)
    {
        do{
            i++;
        }while (a[i] != sol[k]);
        do{
            j++;
        }while (b[j] != sol[k]);

        hintA[i / rada] = 1;
        hintB[j / radb] = 1;
    }
    for (i = 0; i < nra; i++)
        hint.push_back(hintA[i]);
    for (j = 0; j < nrb; j++)
        hint.push_back(hintB[j]);
    while (lenc)
    {
        hint.push_back(lenc & 1);
        lenc >>= 1;
    }
    return hint;


}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    vector<int>sol;
    int lenSol, lenhint, nra, nrb, rada, radb, i, j, lena, lenb, la, lb, ra, rb, pa, pb;
    bool hintA[RADNMAX], hintB[RADNMAX];
    int posA[RADNMAX], posB[RADNMAX];
    for (i = 0; i < RADNMAX; i++)
        posA[i] = posB[i] = -1;
    lena = a.size();
    lenb = b.size();
    lenhint = hint.size();
    rada = sqrt(lena);
    nra = rada;
    if (rada * rada != lena)
        nra++;
    radb = sqrt(lenb);
    nrb = radb;
    if (radb * radb != lenb)
        nrb++;
    for (i = 0; i < nra; i++)
        hintA[i] = hint[i];
    for (j = 0; j < nrb; j++)
        hintB[j] = hint[nra + j];
    lenSol = 0;
    for (i = nra + nrb, j = 0; i < lenhint; i++,  j++)
        lenSol = lenSol + ((int)hint[i] << j);

    for (i = 0; i < nra; i++)
        cout << hintA[i] << " ";
    cout << '\n';
    for (i = 0; i < nrb; i++)
        cout << hintB[i] << " ";
    cout << '\n';
    cout << "^^^  codurile de la hint" << '\n';
    i = -1;
    j = -1;
    while (i < nra && j < nrb)
    {
        do
            i++;
        while (!hintA[i] && i < nra);
        do
            j++;
        while (!hintB[j] && j < nrb);
        cout << i << " " << j << '\n';
        if (i >= nra || j >= nrb)
            break;

        pa = max(la - 1, posA[i]);
        pb = max(lb - 1, posB[j]);
        while (pa < ra && pb < rb)
        {
            for (pa = pa + 1; pa < ra && a[pa] != b[pb]; pa++)
                for (pb = pb + 1; pb < rb && a[pa] != b[pb]; pb++);
            if (pa < ra && pb < rb)
                sol.push_back(a[pa]);
        }
        if (pa < ra)
        {
            posA[i] = pa;
            i--;
        }
        if (pb < rb)
        {
            posB[j] = pb;
            j--;
        }
    }
    return sol;
}
