#include <bits/stdc++.h>
#include "hint.h"

using namespace std;
const int maxn = 15000;
const int mx = 17;
std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    if (a.size() <= maxn && b.size() <= maxn) {
        return {};
    }
    if (a.size() < b.size()) {
        map<int, int> mp;
        for (int j = 0; j < a.size(); ++j) {
            if (mp.count(a[j]))continue;
            mp[a[j]] = j;
        }
        vector<bool> res;
        for (int i = 0; i < sol.size(); ++i) {
            int id = mp[sol[i]];
            for (int j = 0; j < mx; ++j) {
                res.push_back(id % 2);
                id /= 2;
            }
        }
        return res;
    } else {
        map<int, int> mp;
        for (int j = 0; j < b.size(); ++j) {
            if (mp.count(b[j]))continue;
            mp[b[j]] = j;
        }
        vector<bool> res;
        for (int i = 0; i < sol.size(); ++i) {
            int id = mp[sol[i]];
            for (int j = 0; j < mx; ++j) {
                res.push_back(id % 2);
                id /= 2;
            }
        }
        return res;
    }
}


std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b,
                       const std::vector<bool> &hint) {
    if (a.size() <= maxn && b.size() <= maxn) {
        int dp[maxn + 1][maxn + 1];
        for (int i = 0; i < a.size() + 1; ++i) {
            for (int j = 0; j < b.size() + 1; ++j) {
                dp[i][j] = 0;
            }
        }
        for (int k = 1; k < a.size() + 1; ++k) {
            for (int i = 1; i < b.size() + 1; ++i) {
                dp[k][i] = max(dp[k - 1][i], dp[k][i - 1]);
                if (a[k - 1] == b[i - 1]) {
                    dp[k][i] = max(dp[k][i], dp[k - 1][i - 1] + 1);
                }
            }
        }
        vector<int> res;
        int l = a.size();
        int r = b.size();
        while (l != 0 && r != 0) {
            pair<int, int> y = {-1, -1};
            if (dp[l][r] == dp[l - 1][r]) {
                y = {-1, 0};
            } else if (dp[l][r] == dp[l][r - 1]) {
                y = {0, -1};
            }
            if (y == make_pair(-1, -1)) {
                res.push_back(a[l - 1]);
            }
            l += y.first;
            r += y.second;
        }
        reverse(res.begin(), res.end());
        return res;
    }
    if (a.size() < b.size()) {
        vector<int> ans;
        for (int i = 0; i < hint.size() / mx; ++i) {
            int o = 0;
            for (int j = mx - 1; j >= 0; --j) {
                o *= 2;
                o += hint[i * mx + j];
            }
            ans.push_back(a[o]);
        }
        return ans;
    } else {
        vector<int> ans;
        for (int i = 0; i < hint.size() / mx; ++i) {
            int o = 0;
            for (int j = mx - 1; j >= 0; --j) {
                o *= 2;
                o += hint[i * mx + j];
            }
            ans.push_back(b[o]);
        }
        return ans;
    }
}

//signed main() {
//    int n, m;
//    cin >> n;
//    vector<int> a(n);
//    for (int i = 0; i < n; ++i) {
//        cin >> a[i];
//    }
//
//    cin >> m;
//    vector<int> b(m);
//
//    for (int j = 0; j < m; ++j) {
//        cin >> b[j];
//    }
//    vector<int> res = solve(a, b,genHint(a,b,{1,2,3,4}));
//    for (int k = 0; k < res.size(); ++k) {
//        cout << res[k] << " ";
//    }
//}