#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int N = 1000000;
const int INF = 2000000001;

int n, used;

struct MNseg{
    int val[4*N+5], gde[4*N+5];
    void mrg(int node){
        val[node] = min(val[node*2], val[node*2+1]);
        if(val[node*2] < val[node*2+1]) gde[node] = gde[node*2];
        else gde[node] = gde[node*2+1];
    }
    void init(int node, int l, int r){
        if(l == r){
            val[node] = INF, gde[node] = l;
            return;
        }
        int mid = (l+r)/2;
        init(node*2, l, mid);
        init(node*2+1, mid+1, r);
        mrg(node);
    }
    void upd(int node, int l, int r, int x, int vel){
        if(l == r){
            val[node] = vel;
            return;
        }
        int mid = (l+r)/2;
        if(x <= mid) upd(node*2, l, mid, x, vel);
        else upd(node*2+1, mid+1, r, x, vel);
        mrg(node);
    }
    pair <int, int> query(int node, int l, int r, int tl, int tr){
        if(tl > r || l > tr || tl > tr) return {INF, 0};
        if(tl <= l && r <= tr) return {val[node], gde[node]};
        int mid = (l+r)/2;
        pair <int, int> a = query(node*2, l, mid, tl, tr);
        pair <int, int> b = query(node*2+1, mid+1, r, tl, tr);
        if(a.first < b.first) return a;
        return b;
    }
    int last_lesser(int node, int l, int r, int tl, int tr, int vel){
        if(tl > r || l > tr || tl > tr) return -1;
        if(l == r){
            if(val[node] <= vel) return l;
            return -1;
        }
        int mid = (l+r)/2;
        int x = last_lesser(node*2+1, mid+1, r, tl, tr, vel);
        if(x != -1) return x;
        return last_lesser(node*2, l, mid, tl, tr, vel);
    }
    int first_lesser(int node, int l, int r, int tl, int tr, int vel){
        if(tl > r || l > tr || tl > tr) return -1;
        if(l == r){
            if(val[node] <= vel) return l;
            return -1;
        }
        int mid = (l+r)/2;
        int x = first_lesser(node*2, l, mid, tl, tr, vel);
        if(x != -1) return x;
        return first_lesser(node*2+1, mid+1, r, tl, tr, vel);
    }
} Pot_seg, seg;

vector <pair <int, int>> vec;

void Pot_dodaj(int x){
    Pot_seg.upd(1, 1, n, x, (vec[x].first + vec[x].second));
}

void Pot_brisi(int x){
    Pot_seg.upd(1, 1, n, x, INF);
}

set <int> cands;

void Dodaj(int i){
    cands.insert(i);
    seg.upd(1, 1, n, i, vec[i].second - vec[i].first);
}

void Uzimam(int x){
    seg.upd(1, 1, n, x, INF);
    /// dodaj nove kandidate
    used++;
    auto g = cands.lower_bound(x);
    auto d = g;
    int trr = INF;
    d++;
    if(d != cands.end()) trr = *d;
    auto t = g;
    int lb = 1;
    if(t != cands.begin()){
        t--;
        lb = (*t) + 1;
    }
    int rb = *g - 1;
    cands.erase(g);
    for(;;){
        int novi = Pot_seg.last_lesser(1, 1, n, lb, rb, trr);
        if(novi == -1) break;
        Dodaj(novi);
        rb = novi - 1;
        trr = vec[novi].first + vec[novi].second;
    }
}

void uradi(){
    int trr = INF + 1, idx = 0;
    for(;;){
        int tl = idx + 1, tr = n, dokle = -1;
        while(tl <= tr){
            int mid = (tl + tr)/2;
            pair <int, int> g = seg.query(1, 1, n, idx + 1, mid);
            if(g.first <= trr){
                tr = mid - 1;
                dokle = mid;
            }
            else tl = mid + 1;
        }
        if(dokle == -1) break;
        idx = dokle;
        trr = vec[idx].second - vec[idx].first;
        Uzimam(idx);
    }
}

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    cin >> n;
    vec.push_back({0, 0});
    for(int i=1; i<=n; i++){
        /// first - vreme, /// second - mesto
        int t, h;
        cin >> t >> h;
        vec.push_back({t, h});
    }
    sort(vec.begin(), vec.end());
    int trk = INF;
    for(int i=n; i>=1; i--){
        pair <int, int> c = vec[i];
        if(c.first + c.second <= trk){
            Dodaj(i);
            trk = c.first + c.second;
        }
        else{
            Pot_dodaj(i);
        }
    }
    int turns = 0;
    while(used < n) turns++, uradi();
    cout << turns << "\n";
    return 0;
}
