#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll N = 1000000;
const ll INF = 200000000005LL;

ll n, used;

struct MNseg{
    ll val[4*N+5], gde[4*N+5];
    void mrg(ll node){
        val[node] = min(val[node*2], val[node*2+1]);
        if(val[node*2] < val[node*2+1]) gde[node] = gde[node*2];
        else gde[node] = gde[node*2+1];
    }
    void init(ll node, ll l, ll r){
        if(l == r){
            val[node] = INF, gde[node] = l;
            return;
        }
        ll mid = (l+r)/2;
        init(node*2, l, mid);
        init(node*2+1, mid+1, r);
        mrg(node);
    }
    void upd(ll node, ll l, ll r, ll x, ll vel){
        if(l == r){
            val[node] = vel;
            return;
        }
        ll mid = (l+r)/2;
        if(x <= mid) upd(node*2, l, mid, x, vel);
        else upd(node*2+1, mid+1, r, x, vel);
        mrg(node);
    }
    pair <ll, ll> query(ll node, ll l, ll r, ll tl, ll tr){
        if(tl > r || l > tr || tl > tr) return {INF, 0};
        if(tl <= l && r <= tr) return {val[node], gde[node]};
        ll mid = (l+r)/2;
        pair <ll, ll> a = query(node*2, l, mid, tl, tr);
        pair <ll, ll> b = query(node*2+1, mid+1, r, tl, tr);
        if(a.first < b.first) return a;
        return b;
    }
    ll last_lesser(ll node, ll l, ll r, ll tl, ll tr, ll vel){
        if(tl > r || l > tr || tl > tr) return -1;
        if(l == r){
            if(val[node] <= vel) return l;
            return -1;
        }
        ll mid = (l+r)/2;
        ll x = last_lesser(node*2+1, mid+1, r, tl, tr, vel);
        if(x != -1) return x;
        return last_lesser(node*2, l, mid, tl, tr, vel);
    }
    ll first_lesser(ll node, ll l, ll r, ll tl, ll tr, ll vel){
        if(tl > r || l > tr || tl > tr) return -1;
        if(l == r){
            if(val[node] <= vel) return l;
            return -1;
        }
        ll mid = (l+r)/2;
        ll x = first_lesser(node*2, l, mid, tl, tr, vel);
        if(x != -1) return x;
        return first_lesser(node*2+1, mid+1, r, tl, tr, vel);
    }
} Pot_seg, seg;

vector <pair <ll, ll>> vec;

void Pot_dodaj(ll x){
    Pot_seg.upd(1, 1, n, x, (vec[x].first + vec[x].second));
}

void Pot_brisi(ll x){
    Pot_seg.upd(1, 1, n, x, INF);
}

set <ll> cands;

void Dodaj(ll i){
    cands.insert(i);
    seg.upd(1, 1, n, i, vec[i].second - vec[i].first);
}

void Uzimam(ll x){
    seg.upd(1, 1, n, x, INF);
    /// dodaj nove kandidate
    used++;
    auto g = cands.lower_bound(x);
    auto d = g;
    ll trr = INF - 1;
    d++;
    if(d != cands.end()) trr = *d;
    auto t = g;
    ll lb = 1;
    if(t != cands.begin()){
        t--;
        lb = (*t) + 1;
    }
    ll rb = *g - 1;
    cands.erase(g);
    for(;;){
        ll novi = Pot_seg.last_lesser(1, 1, n, lb, rb, trr);
        if(novi == -1) break;
        Dodaj(novi);
        rb = novi - 1;
        trr = vec[novi].first + vec[novi].second;
    }
}

void uradi(){
    ll trr = INF - 1, idx = 0;
    for(;;){
        ll dokle = seg.first_lesser(1, 1, n, idx + 1, n, trr);
        if(dokle == -1) break;
        idx = dokle;
        trr = vec[idx].second - vec[idx].first;
        Uzimam(idx);
    }
}

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    cin >> n;
    vec.push_back({0, 0});
    for(ll i=1; i<=n; i++){
        /// first - vreme, /// second - mesto
        ll t, h;
        cin >> t >> h;
        vec.push_back({t, h});
    }
    sort(vec.begin(), vec.end());
    //for(auto c : vec) cout << c.first << " " << c.second << endl;
    seg.init(1, 1, n);
    Pot_seg.init(1, 1, n);
    ll trk = INF;
    for(ll i=n; i>=1; i--){
        pair <ll, ll> c = vec[i];
        if(c.first + c.second <= trk){
            Dodaj(i);
            //cout << "prvo " << i << endl;
            trk = c.first + c.second;
        }
        else{
            Pot_dodaj(i);
        }
    }
    ll turns = 0;
    while(used < n) turns++, uradi();
    cout << turns << "\n";
    return 0;
}
