#include "hint.h"

#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int lg2(int n) {
	int ret = 0;
	while (n) {
		ret++;
		n /= 2;
	}
	return ret;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& s) {
	vector<bool> h;
	int ln = lg2(min(a.size(), b.size()) - 1);
	for (int i = 0; i < s.size(); i++) {
		for (int j = ln - 1; j >= 0; j--) {
			h.push_back(s[i] & (1 << j));
		}
	}
	return h;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& h) {
	vector<int> s;
	int ln = lg2(min(a.size(), b.size()) - 1);
	for (int i = 0; i * ln < h.size(); i++) {
		s.push_back(0);
		for (int j = 0; j < ln; j++) {
			s[i] *= 2;
			s[i] += h[i * ln + j];
		}
	}
	return s;
}

/*
3 3
1 3 2
3 1 2
2
1 2

8 8
1 2 3 4 5 6 7 8
1 2 3 4 5 6 7 8
8
1 2 3 4 5 6 7 8

*/