#include "hint.h"

#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int lg2(int n) {
	int ret = 0;
	while (n) {
		ret++;
		n /= 2;
	}
	return ret;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& s) {
	vector<bool> hs;
	int ln = lg2(min(a.size(), b.size()) - 1);
	for (int i = 0; i < s.size(); i++) {
		for (int j = ln - 1; j >= 0; j--) {
			hs.push_back(s[i] & (1 << j));
		}
	}
    vector<bool> ha, hb;
    int x = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i] == s[x]) {
            ha.push_back(1);
            x++;
        }
        else ha.push_back(0);
        if (x >= s.size()) break;
    }
    x = 0;
    for (int i = 0; i < b.size(); i++) {
        if (b[i] == s[x]) {
            hb.push_back(1);
            x++;
        }
        else hb.push_back(0);
        if (x >= s.size()) break;
    }
    if (ha.size() <= hb.size()) {
        ha.insert(ha.begin(), 0);
    }
    else {
        ha = hb;
        ha.insert(ha.begin(), 1);
    }
    if (ha.size() <= hs.size()) {
        ha.insert(ha.begin(), 0);
        return ha;
    }
    else {
        hs.insert(hs.begin(), 1);
        return hs;
    }
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& h) {
	vector<int> s;
    if (h[0] == 1) {
        int ln = lg2(min(a.size(), b.size()) - 1);
        for (int i = 0; i * ln < h.size(); i++) {
            s.push_back(0);
            for (int j = 0; j < ln; j++) {
                s[i] *= 2;
                s[i] += h[i * ln + j + 1];
            }
        }
    }
    else {
        if (h[1] == 0) {
            for (int i = 2; i < h.size(); i++) {
                if (h[i]) s.push_back(a[i - 2]);
            }
        }
        else {
            for (int i = 2; i < h.size(); i++) {
                if (h[i]) s.push_back(b[i - 2]);
            }
        }
    }
	return s;
}

/*
3 3
1 3 2
3 1 2
2
1 2

8 8
1 2 3 4 5 6 7 8
1 2 3 4 5 6 7 8
8
1 2 3 4 5 6 7 8

*/