#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

const int maxN = 100005;

bool vectorCompare( const vector <int> &p, const vector <int> &q ){
    if( p.size() != q.size() ) return p.size() < q.size();
    int SIZE = p.size();
    for( int i = 0 ; i < SIZE ; i++ ){
        if( p[i] == q[i] ) continue;
        return p[i] < q[i];
    }
}

bool vectorCompare( const vector <bool> &p, const vector <bool> &q ){
    if( p.size() != q.size() ) return p.size() < q.size();
    int SIZE = p.size();
    for( int i = 0 ; i < SIZE ; i++ ){
        if( p[i] == q[i] ) continue;
        return p[i] < q[i];
    }
}

bool checkLCS( const vector <int> &p, const vector <int> &q ){

    int j = 0;
    for( int i = 0 ; i < q.size() && j < p.size() ; i++ ){
        if( q[i] == p[j] ) j++;
    }

    return j == p.size();

}

vector <bool> genHint( const vector <int> &A, const vector <int> &B, const vector <int> &S ){
    
    vector <bool> rv1, rv2;

    for( int i = 0, j = 0 ; i < A.size() && j < S.size() ; i++ ){
        if( A[i] == S[j] ){ rv1.push_back(1); j++; }
        else rv1.push_back(0);
    }
    
    for( int i = 0, j = 0 ; i < B.size() && j < S.size() ; i++ ){
        if( B[i] == S[j] ){ rv2.push_back(1); j++; }
        else rv2.push_back(0);
    }

    return ( vectorCompare(rv1,rv2) ? rv1 : rv2 );

}

vector <int> solve( const vector <int> &A, const vector <int> &B, const vector <bool> &H ){

    vector <int> rv1, rv2;
    bool valid1 = true, valid2 = true;

    for( int i = 0 ; i < H.size() ; i++ ){
        if( !H[i] ) continue;
        if( i < A.size() ) rv1.push_back(A[i]);
        else valid1 = false;
        if( i < B.size() ) rv2.push_back(B[i]);
        else valid2 = false;
    }

    valid1 &= checkLCS( rv1, B );
    valid2 &= checkLCS( rv2, A );

    return ( valid1 ? rv1 : rv2 );

} 