#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

struct place{
    int T, H, idx;
    place(){}
    place( int _t, int _h ) : T(_t), H(_h) {}
    const bool operator < ( const place &o ) const{
        if( T != o.T ) return T < o.T;
        return H < o.H;
    }
};

bool hasRoute( place, place );
int minTrucks();

const int maxN = 1005;
int N;
vector <int> ADJ[maxN];
place A[maxN];
int indegree[maxN] = {};
int truckIdx[maxN], nextTruckIdx = 0;

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    memset( truckIdx, -1, sizeof truckIdx );

    cin >> N;
    for( int i = 0 ; i < N ; i++ ) { cin >> A[i].T >> A[i].H; }

    sort( A, A+N );

    for( int i = 0 ; i < N ; i++ ) A[i].idx = i;

    for( int i = 0 ; i < N ; i++ ) for( int j = i+1 ; j < N ; j++ ){
        if( hasRoute(A[i],A[j]) ){ ADJ[i].push_back(j); indegree[j]++; }
    }

    cout << minTrucks() << endl;

}

int minTrucks(){

    queue <place> q;

    for( int i = 0 ; i < N ; i++ ) if( !indegree[i] ) q.push(A[i]);

    while( !q.empty() ){

        place p = q.front();
        q.pop();

        indegree[p.idx] = INF;
        if( truckIdx[p.idx] == -1 ) truckIdx[p.idx] = nextTruckIdx++;

        if( ADJ[p.idx].empty() ) continue;

        int minIndegree = INF;
        for( int _p : ADJ[p.idx] ){ if( truckIdx[_p] != -1 ) continue;
            minIndegree = min( minIndegree, indegree[_p] ); 
        }

        for( int _p : ADJ[p.idx] ){ if( truckIdx[_p] != -1 ) continue;
            if( indegree[_p] != minIndegree ) continue;
            truckIdx[_p] = truckIdx[p.idx];
            indegree[_p] = INF;
            q.push(A[_p]);
            break;
        }

        for( int _p : ADJ[p.idx] ) { if( truckIdx[_p] != -1 ) continue;
            indegree[_p]--;
            if( !indegree[_p] ) q.push(A[_p]);
        }

    }

    return nextTruckIdx;

}

bool hasRoute( place p, place q ){
    return abs(p.H-q.H) <= q.T-p.T;
}