#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

int N, S, C;
vector <int> moves;

void strategy1();
void strategy2();
void strategy3();
void generalStrategy();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N >> S >> C;

    if( S == 0 ) strategy1();
    else if( C == 0 ) strategy2();
    else if( S == 1 && C == 1 ) strategy3();
    else generalStrategy();

    cout << moves.size() << endl;
    for( int m : moves ) cout << m << ' '; cout << endl;

}

void strategy1(){ // Keep checking the same cell in the middle in the hopes that the rabbit eventually visits

    int mid = (N+1)/2;
    for( int i = 0 ; i <= mid ; i++ ) moves.push_back(mid); 

}

void strategy2(){ // Chase the rabbit away into one of the corners

    int mid = (N+1)/2;
    moves.push_back(mid);
    int L = mid-2, R = mid+3;
    while( L >= 1 || R <= N ){
        if( L >= 1 ){ moves.push_back(L); L -= 3; }
        if( R <= N ){ moves.push_back(R); R += 3; }
    }

    moves.push_back(1); moves.push_back(N);

}

void strategy3(){ // Bait the rabbit into the left corner

    for( int i = N ; i >= 1 ; i -= 3 ){
        moves.push_back(i);
        moves.push_back(1);
    }

}

void generalStrategy(){

    int L = 1, R = N;
    // L = leftmost possible rabbit position
    // R = rightmost possible rabbit position

    int K = -1;
    while( L < R ){ K++;

        if( K < S ){ // Scare mood

            moves.push_back(R);
            R -= 2;
            L = max( 1, L-1 );

        }else{ // Curious mood

            moves.push_back(R-1);
            R--;
            L++;

        }

        K %= (S+C);

    }

    if( L == R ) moves.push_back(L);

}