#include "hint.h"
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
//#define int long long
vector <bool> ans;

void add(bool a)
{
	ans.push_back(a);
}

void add(ll a, int bit)
{
	for (int i = 0; i < bit; ++i)
	{
		add((a >> i) & 1);
	}
}

const int N = 200010;
const int BITS = 36;

void add(ll a, ll b, bool once)
{
	ll f = a + b * N;
	add(f, BITS);
	add(once);
}

vector <int> x, y;
const int L = 1000;

std::vector<bool> genHint(const std::vector<signed>& a, const std::vector<signed>& b, const std::vector<signed>& sol)
{
	int f = 0;
	int i = 0; 
	x.push_back(-1);
	y.push_back(-1);
	while (f < sol.size())
	{
		if (a[i] == sol[f])
		{
			x.push_back(i);
			++f;
			++i;
		}
		else
		{
			++i;
		}
	}

	f = 0, i = 0;

	while (f < sol.size())
	{
		if (b[i] == sol[f])
		{
			y.push_back(i);
			++f;
			++i;
		}
		else
		{
			++i;
		}
	}

	int dn = 0;
	while (true)
	{
		if (dn == x.size() - 1) break;
		int i = dn + 1;
		if (x[i] - x[dn] >= L || y[i] - y[dn] >= L)
		{
			add(x[i], y[i], 1);
			dn = i;
			continue;
		}

		while (true)
		{
			if (i == x.size() - 1)
			{
				add(x[i], y[i], 0);
				dn = i;
				break;
			}
			++i;
			if (x[i] - x[dn] >= L && x[i] - x[dn] <= 2 * L && y[i] - y[dn] >= L && y[i] - y[dn] <= 2 * L)
			{
				add(x[i], y[i], 0);
				dn = i;
				break;
			}
			else if (x[i] - x[dn] > 2 * L || y[i] - y[dn] > 2 * L)
			{
				add(x[i - 1], y[i - 1], 0);
				add(x[i], y[i], 1);
				dn = i;
				break;
			}
		}
	}

	return ans;
}

vector <int> stupid(vector <int> a, vector <int> b)
{
	vector <vector <int>> dp(a.size() + 1, vector <int>(b.size() + 1));

	for (int i = 1; i <= a.size(); ++i)
	{
		for (int j = 1; j <= b.size(); ++j)
		{
			dp[i][j] = a[i - 1] == b[j - 1] ? max({ dp[i - 1][j - 1] + 1, dp[i - 1][j], dp[i][j - 1] }) : max(dp[i - 1][j], dp[i][j - 1]);
		}
	}

	vector <int> ans;
	int x = a.size(), y = b.size();	
	while (dp[x][y] >= 1)
	{
		if (dp[x - 1][y] == dp[x][y])
		{
			--x;
			continue;
		}

		if (dp[x][y - 1] == dp[x][y])
		{
			--y;
			continue;
		}

		
		ans.push_back(a[x - 1]);
		--x;
		--y;
	}

	reverse(ans.begin(), ans.end());
	return ans;
}

int I = 0;
void get(bool& a)
{
	a = ans[I++];
}

void get(ll& a, int bit)
{
	a = 0;
	for (int i = 0; i < bit; ++i)
	{
		bool got;
		get(got);
		a |= (ll)got << i;
	}
}

void get(int& a, int& b, bool& once)
{
	ll f;
	get(f, BITS);
	a = f % N;
	b = f / N;

	get(once);
}

std::vector<signed> solve(const std::vector<signed>& a, const std::vector<signed>& b, const std::vector<bool>& hint)
{
	ans = hint;
	vector <pair <pair <int, int>, bool>> f;
	vector <signed> ans;
	while (I < hint.size())
	{
		int a, b;
		bool once;
		get(a, b, once);

		f.push_back({ {a, b}, once });
	}

	int lstx = -1, lsty = -1;

	for (auto i : f)
	{
		int x = i.first.first, y = i.first.second;
		bool once = i.second;
		
		if (once)
		{
			ans.push_back(a[x]);
			lstx = x;
			lsty = y;
		}
		else
		{
			vector <int> toa, tob;
			for (int j = lstx + 1; j <= x; ++j) toa.push_back(a[j]);
			for (int j = lsty + 1; j <= y; ++j) tob.push_back(b[j]);
			auto got = stupid(toa, tob);
			ans.insert(ans.end(), got.begin(), got.end());
			lstx = x;
			lsty = y;
		}
	}

	return ans;
}
