//bs:sanitizers,opt:O0
#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol);
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint);

int main()
{
	int n, m, k;
	vector<int> a, b, sol, maybeSol;
	vector<bool> hint;
    cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        cin >> num;
    }

    for (int& num : b)
    {
        cin >> num;
    }

    cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    cout << hint.size() << endl;
    cout << maybeSol.size() << endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) cout << " ";
        cout << maybeSol[i];
    }
    cout << endl;

    return 0;
}
#else
#include "hint.h"
#endif

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int BITS = 18, C = 6e3, N = 3e4 + 10;

vector<bool> genHint(const vector<int> &a_raw, const vector<int> &b_raw, const vector<int> &sol) {
	vector<bool> hint1, hint2;
	vector<int> const *pa = &a_raw, *pb = &b_raw;
	auto solve = [&](vector<bool> &hint) {
		const vector<int> &a = *pa, &b = *pb;
		int ita = 0, itb = 0;
		auto write_int = [&](int x) {
			for (int i = 0; i < BITS; ++i) {
				hint.push_back(bool(x >> i & 1));
			}
		};
		for (int i = 0; i < sz(sol); ++i) {
			while (a[ita] != sol[i]) {
				++ita;
				if (ita % C == 0) {
					write_int(itb);
				}
			}
			while (b[itb] != sol[i]) {
				++itb;
			}
			++ita, ++itb;
			if (ita % C == 0) {
				write_int(itb);
			}
		}
		write_int(itb);
	};
	solve(hint1);
	swap(pa, pb);
	solve(hint2);
	vector<bool> hint = {sz(hint1) > sz(hint2)};
	if (sz(hint1) <= sz(hint2)) {
		hint.insert(end(hint), all(hint1));
	} else {
		hint.insert(end(hint), all(hint2));
	}
	return hint;
}

int dp[C + 1][N];

vector<int> solve(const vector<int> &a_raw, const vector<int> &b_raw, const vector<bool> &hint) {
	vector<int> const *pa = &a_raw, *pb = &b_raw;
	vector<int> pos;
	if (hint[0]) {
		swap(pa, pb);
	}
	const vector<int> &a = *pa, &b = *pb;
	for (int i = 1; i < sz(hint); i += BITS) {
		int curr = 0;
		for (int j = 0; j < BITS; ++j) {
			curr |= int(hint[i + j]) << j;
		}
		pos.push_back(curr);
	}
	int prev = 0;
	vector<int> ans;
	for (int i = 0; i < sz(pos); ++i) {
		int lef = i * C, rig = min((i + 1) * C, sz(a));
		for (int j = 0; j < rig - lef; ++j) {
			for (int h = 0; h < pos[i] - prev; ++h) {
				if (a[j + lef] == b[h + prev]) {
					dp[j + 1][h + 1] = dp[j][h] + 1;
				} else if (dp[j][h + 1] < dp[j + 1][h]) {
					dp[j + 1][h + 1] = dp[j + 1][h];
				} else {
					dp[j + 1][h + 1] = dp[j][h + 1];
				}
			}
		}
		int currj = rig - lef, currh = pos[i] - prev;
		int pans = sz(ans);
		while (currj && currh) {
			if (a[currj + lef - 1] == b[currh + prev - 1]) {
				ans.push_back(a[currj + lef - 1]);
				--currj, --currh;
			} else if (dp[currj - 1][currh] > dp[currj][currh - 1]) {
				--currj;
			} else {
				--currh;
			}
		}
		reverse(begin(ans) + pans, end(ans));
		prev = pos[i];
	}
	return ans;
}