#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol);
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint);

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	int n, m, k;
	vector<int> a, b, sol, maybeSol;
	vector<bool> hint;
    cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        cin >> num;
    }

    for (int& num : b)
    {
        cin >> num;
    }

    cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    cout << hint.size() << endl;
    cout << maybeSol.size() << endl;

    // for (int i = 0; i < (int) maybeSol.size(); ++i)
    // {
    //     if (i > 0) cout << " ";
    //     cout << maybeSol[i];
    // }
    // cout << endl;
    cout << clock() << endl;
    return 0;
}
#else
#include "hint.h"
#endif

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int BITS = 18, C1 = 2.5e3, C2 = 3.55e3, IHINTS_BITS = 18, N = 2e5 + 10;

// void encode(const vector<int> &ihints, vector<bool> &hint, int cl, int cr, int vl, int vr) {
// 	if (cr <= cl) {
// 		return;
// 	}
// 	int mid = (cl + cr) / 2;
// 	int bits = 32 - __builtin_clz(vr - vl + 1);
// 	for (int i = 0; i < bits; ++i) {
// 		hint.push_back((ihints[mid] - vl) >> i & 1);
// 	}
// 	encode(ihints, hint, cl, mid, vl, ihints[mid]);
// 	encode(ihints, hint, mid + 1, cr, ihints[mid], vr);
// }

// void decode(vector<int> &ihints, const vector<bool> &hint, int &gpos, int cl, int cr, int vl, int vr) {
// 	if (cr <= cl) {
// 		return;
// 	}
// 	// cout << cl << " " << cr << " " << vl << " " << vr << endl;
// 	int mid = (cl + cr) / 2;
// 	int bits = 32 - __builtin_clz(vr - vl + 1);
// 	int midval = 0;
// 	for (int i = 0; i < bits; ++i) {
// 		midval |= int(hint[gpos++]) << i;
// 	}
// 	midval += vl;
// 	decode(ihints, hint, gpos, cl, mid, vl, midval);
// 	ihints.push_back(midval);
// 	decode(ihints, hint, gpos, mid + 1, cr, midval, vr);
// }

int get_fitness(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
	int prev = 0;
	int fitness = 0;
	int ita = 0, itb = 0;
	auto write_int = [&](int x) {
		fitness = max(fitness, x - prev);
		prev = x;
	};
	for (int i = 0; i < sz(sol); ++i) {
		while (a[ita] != sol[i]) {
			++ita;
			if (ita % C1 == 0) {
				write_int(itb);
			}
		}
		while (b[itb] != sol[i]) {
			++itb;
		}
		++ita, ++itb;
		if (ita % C1 == 0) {
			write_int(itb);
		}
	}
	write_int(itb);
	return fitness;
}

vector<bool> genHint(const vector<int> &a_raw, const vector<int> &b_raw, const vector<int> &sol) {
	vector<bool> hint1, hint2;
	vector<int> const *pa = &a_raw, *pb = &b_raw;
	auto solve = [&](vector<bool> &hint) {
		const vector<int> &a = *pa, &b = *pb;
		int fitness = get_fitness(a, b, sol);
		int C = C1;
		if (fitness < 5000) {
			C = C2;
		}
		int ita = 0, itb = 0;
		vector<int> ihints;
		for (int i = 0; i < sz(sol); ++i) {
			while (a[ita] != sol[i]) {
				++ita;
				if (ita % C == 0) {
					ihints.push_back(itb);
				}
			}
			while (b[itb] != sol[i]) {
				++itb;
			}
			++ita, ++itb;
			if (ita % C == 0) {
				ihints.push_back(itb);
			}
		}
		ihints.push_back(itb);
		int required = 0;
		for (int i = 0; i < sz(ihints); ++i) {
			required = max(required, ihints[i] - (i ? ihints[i - 1] : 0));
		}
		int bits = 32 - __builtin_clz(required + 1);
		hint.push_back(fitness < 5000);
		for (int i = 0; i < 7; ++i) {
			hint.push_back(bits >> i & 1);
		}
		for (int i = 0; i < sz(ihints); ++i) {
			int x = ihints[i] - (i ? ihints[i - 1] : 0);
			for (int j = 0; j < bits; ++j) {
				hint.push_back(x >> j & 1);
			}
		}
		// cout << "encode " << sz(ihints) << " " << sz(b) << ": ";
		// for (int u : ihints) {
		// 	cout << u << " ";
		// }
		// cout << endl;
		// encode(ihints, hint, 0, sz(ihints), 0, sz(b));
	};
	solve(hint1);
	swap(pa, pb);
	solve(hint2);
	vector<bool> hint = {sz(hint1) > sz(hint2)};
	if (sz(hint1) <= sz(hint2)) {
		hint.insert(end(hint), all(hint1));
	} else {
		hint.insert(end(hint), all(hint2));
	}
	return hint;
}

int loc_n;

unsigned short mem[N * (C1 + 1)];

struct {
	unsigned short *operator[](int i) {
		return mem + (i * loc_n);
	}
} dp;

vector<int> solve(const vector<int> &a_raw, const vector<int> &b_raw, const vector<bool> &hint) {
	vector<int> const *pa = &a_raw, *pb = &b_raw;
	vector<int> pos;
	loc_n = N;
	if (hint[0]) {
		swap(pa, pb);
	}
	int C = C1;
	if (hint[1]) {
		loc_n = 1e5 + 10;
		C = C2;
	}
	const vector<int> &a = *pa, &b = *pb;
	int bits = 0;
	for (int i = 0; i < 7; ++i) {
		bits |= int(hint[i + 2]) << i;
	}
	for (int i = 9; i < sz(hint); i += bits) {
		int x = 0;
		for (int j = 0; j < bits; ++j) {
			x |= int(hint[j + i]) << j;
		}
		pos.push_back(x);
	}
	for (int i = 1; i < sz(pos); ++i) {
		pos[i] += pos[i - 1];
	}
	// cout << "decode " << ihints_sz << ": " << sz(b) << endl;
	// decode(pos, hint, gpos, 0, ihints_sz, 0, sz(b));
	// for (int u : pos) {
	// 	cout << u << " ";
	// }
	// cout << endl;
	int prev = 0;
	vector<int> ans;
	for (int i = 0; i < sz(pos); ++i) {
		int lef = i * C, rig = min((i + 1) * C, sz(a));
		int ln = rig - lef, lm = pos[i] - prev;
		for (int j = 0; j < ln; ++j) {
			for (int h = 0; h < lm; ++h) {
				if (a[j + lef] == b[h + prev]) {
					dp[j + 1][h + 1] = dp[j][h] + 1;
				} else {
					dp[j + 1][h + 1] = max(dp[j + 1][h], dp[j][h + 1]);
				}
			}
		}
		int currj = rig - lef, currh = pos[i] - prev;
		int pans = sz(ans);
		while (currj && currh) {
			if (a[currj + lef - 1] == b[currh + prev - 1]) {
				ans.push_back(a[currj + lef - 1]);
				--currj, --currh;
			} else if (dp[currj - 1][currh] > dp[currj][currh - 1]) {
				--currj;
			} else {
				--currh;
			}
		}
		reverse(begin(ans) + pans, end(ans));
		prev = pos[i];
	}
	return ans;
}