#include "hint.h"

#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;

template<class X, class Y>
istream& operator>>(istream& s, pair<X, Y>& p) {
  s >> p.first >> p.second;
  return s;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }
  return s;
}

//auto solve() -> void;
//
//int main() {
//  ios_base::sync_with_stdio(false);
//  cin.tie(nullptr);
//  cout.setf(ios::fixed);
//  cout.precision(20);
//
//  solve();
//}

//auto solve() -> void {
//
//}

// -----

std::vector<bool> genHint(const std::vector<int>& a1, const std::vector<int>& b1,
                          const std::vector<int>& sol) {
  auto& a = const_cast<vector<int>&>(a1);
  auto& b = const_cast<vector<int>&>(b1);
  if (a.size() > b.size()) swap(a, b);
  vector<bool> hint;
  if (a.size() == b.size()) {
    int i = 0;
    for (; i < a.size() and a[i] == b[i]; ++i) {}
    if (i < a.size()) {
      for (int j = 0; j < 16; ++j) {
        hint.push_back((bool) (a[i] & (1 << j)));
      }
    }
  }
  for (int i = 0, s = 0; i < a.size() and s < sol.size(); ++s, ++i) {
    while (a[i] != sol[s]) {
      ++i;
      hint.push_back(false);
    }
    hint.push_back(true);
  }
  return hint;
}

std::vector<int> solve(const std::vector<int>& a1, const std::vector<int>& b1,
                       const std::vector<bool>& hint) {
  auto& a = const_cast<vector<int>&>(a1);
  auto& b = const_cast<vector<int>&>(b1);
  ll offset = 0;
  if (a.size() == b.size()) {
    int i = 0;
    for (; i < a.size() and a[i] == b[i]; ++i) {}
    if (i < a.size()) {
      int q = 0;
      for (int j = 0; j < 16; ++j) {
        q += ((int) hint[j] << j);
      }
      offset = 16;
      if (b[i] == q) swap(a, b);
      assert(a[i] == q);
    }
  } else if (a.size() != hint.size()) swap(a, b);
  vector<int> res;
  for (int i = 0; i < a.size(); ++i) {
    if (hint[i + offset]) res.push_back(a[i]);
  }
  return res;
}
