#include "hint.h"
#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#ifndef DEBUG
#define endl '\n'
#endif
using namespace std;
using ll = int;
using vi = vector<short>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
template<class X, class Y>
istream& operator>>(istream& s, pair<X, Y>& p) {
  s >> p.first >> p.second;
  return s;
}
template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }
  return s;
}
template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }
  return s;
}
//auto solve() -> void;
//
//int main() {
//  ios_base::sync_with_stdio(false);
//  cin.tie(nullptr);
//  cout.setf(ios::fixed);
//  cout.precision(20);
//
//  solve();
//}
//auto solve() -> void {
//
//}
// -----
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
                          const std::vector<int>& sol) {
  vb hint;
  for (int i = 0; i < 17; ++i) {
    hint.push_back(sol.size() & (1 << i));
  }
  for (auto e: sol) {
    for (int i = 0; i < 17; ++i) {
      hint.push_back(e & (1 << i));
    }
  }
  return hint;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
                       const std::vector<bool>& hint) {
  vector<int> res;
  ll n = min(a.size(), 10'000ul);
  ll m = min(b.size(), 10'000ul);
  vvi dp(n + 1, vi(m + 1));
  vvii p(n + 1, vii(m + 1, {-1, -1}));
  for (int i = 1; i <= a.size(); ++i) {
    for (int j = 1; j <= b.size(); ++j) {
      if (dp[i - 1][j] > dp[i][j]) {
        dp[i][j] = dp[i - 1][j];
        p[i][j] = p[i - 1][j];
      }
      if (dp[i][j - 1] > dp[i][j]) {
        dp[i][j] = dp[i][j - 1];
        p[i][j] = p[i][j - 1];
      }
      if (a[i - 1] == b[j - 1] and dp[i - 1][j - 1] + 1 > dp[i][j]) {
        dp[i][j] = dp[i - 1][j - 1] + 1;
        p[i][j] = {i - 1, j - 1};
      }
    }
  }
  vii trace;
  {
    ll i = n, j = m;
    while (p[i][j] != ii{-1, -1}) {
      auto[i1, j1] = p[i][j];
      i = i1, j = j1;
      trace.push_back({i, j});
    }
  }

  reverse(trace.begin(), trace.end());
  for (auto[i, j]: trace) {
    assert(a[i] == b[j]);
    res.push_back(a[i]);
  }

  ll offset = 17;
  ll len = 0;
  for (int j = 0; j < 17; ++j) {
    len += (int) hint[offset + j] << j;
  }
  for (int i = 17 * res.size(); i + offset < hint.size(); i += 17) {
    int q = 0;
    for (int j = 0; j < 17; ++j) {
      q += (int) hint[offset + i + j] << j;
    }
    res.push_back(q);
  }
  return res;
}