#include "hint.h"
#include <bits/stdc++.h>
#ifndef DEBUG
#define endl '\n'
#endif
using namespace std;
using ll = int;
using vi = vector<short>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
template<class X, class Y>
istream& operator>>(istream& s, pair<X, Y>& p) {
  s >> p.first >> p.second;
  return s;
}
template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }
  return s;
}
template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }
  return s;
}
//auto solve() -> void;
//
//int main() {
//  ios_base::sync_with_stdio(false);
//  cin.tie(nullptr);
//  cout.setf(ios::fixed);
//  cout.precision(20);
//
//  solve();
//}
//auto solve() -> void {
//
//}
// -----

const size_t LIMIT = 5'000;

std::vector<bool> genHint(const std::vector<int>& a1, const std::vector<int>& b1,
                          const std::vector<int>& sol) {
  auto& a = const_cast<std::vector<int>&>(a1);
  auto& b = const_cast<std::vector<int>&>(b1);
  vb hint;
  ll offset = 0;
  {
    ll n = min(a.size(), LIMIT);
    ll m = min(b.size(), LIMIT);
    vvi dp(n + 1, vi(m + 1));
    for (int i = 1; i <= n; ++i) {
      for (int j = 1; j <= m; ++j) {
        if (dp[i - 1][j] > dp[i][j]) {
          dp[i][j] = dp[i - 1][j];
        }
        if (dp[i][j - 1] > dp[i][j]) {
          dp[i][j] = dp[i][j - 1];
        }
        if (a[i - 1] == b[j - 1] and dp[i - 1][j - 1] + 1 > dp[i][j]) {
          dp[i][j] = dp[i - 1][j - 1] + 1;
        }
      }
    }
    offset = max((ll) offset, (ll) dp[n][m]);
  }
  {
    swap(a, b);
    ll n = min(a.size(), LIMIT);
    ll m = min(b.size(), LIMIT);
    vvi dp(n + 1, vi(m + 1));
    vvii p(n + 1, vii(m + 1, {-1, -1}));
    for (int i = 1; i <= n; ++i) {
      for (int j = 1; j <= m; ++j) {
        if (dp[i - 1][j] > dp[i][j]) {
          dp[i][j] = dp[i - 1][j];
        }
        if (dp[i][j - 1] > dp[i][j]) {
          dp[i][j] = dp[i][j - 1];
        }
        if (a[i - 1] == b[j - 1] and dp[i - 1][j - 1] + 1 > dp[i][j]) {
          dp[i][j] = dp[i - 1][j - 1] + 1;
        }
      }
    }
    offset = max((ll) offset, (ll) dp[n][m]);
    swap(a, b);
  }
//  for (int i = 0; i < 17; ++i) {
//    hint.push_back(sol.size() & (1 << i));
//  }
  for (ll ei = offset; ei < sol.size(); ++ei) {
    auto e = sol[ei];
    for (int i = 0; i < 17; ++i) {
      hint.push_back(e & (1 << i));
    }
  }
  return hint;
}
std::vector<int> solve(const std::vector<int>& a1, const std::vector<int>& b1,
                       const std::vector<bool>& hint) {
  auto& a = const_cast<std::vector<int>&>(a1);
  auto& b = const_cast<std::vector<int>&>(b1);
  vector<int> res, res1;
  {
    ll n = min(a.size(), LIMIT);
    ll m = min(b.size(), LIMIT);
    vvi dp(n + 1, vi(m + 1));
    vvii p(n + 1, vii(m + 1, {-1, -1}));
    for (int i = 1; i <= n; ++i) {
      for (int j = 1; j <= m; ++j) {
        if (dp[i - 1][j] > dp[i][j]) {
          dp[i][j] = dp[i - 1][j];
          p[i][j] = p[i - 1][j];
        }
        if (dp[i][j - 1] > dp[i][j]) {
          dp[i][j] = dp[i][j - 1];
          p[i][j] = p[i][j - 1];
        }
        if (a[i - 1] == b[j - 1] and dp[i - 1][j - 1] + 1 > dp[i][j]) {
          dp[i][j] = dp[i - 1][j - 1] + 1;
          p[i][j] = {i - 1, j - 1};
        }
      }
    }
    vii trace;
    {
      ll i = n, j = m;
      while (p[i][j] != ii{-1, -1}) {
        auto[i1, j1] = p[i][j];
        i = i1, j = j1;
        trace.push_back({i, j});
      }
    }
    reverse(trace.begin(), trace.end());
    for (auto[i, j]: trace) {
      assert(a[i] == b[j]);
      res.push_back(a[i]);
    }
  }
  {
    swap(a, b);
    ll n = min(a.size(), LIMIT);
    ll m = min(b.size(), LIMIT);
    vvi dp(n + 1, vi(m + 1));
    vvii p(n + 1, vii(m + 1, {-1, -1}));
    for (int i = 1; i <= n; ++i) {
      for (int j = 1; j <= m; ++j) {
        if (dp[i - 1][j] > dp[i][j]) {
          dp[i][j] = dp[i - 1][j];
          p[i][j] = p[i - 1][j];
        }
        if (dp[i][j - 1] > dp[i][j]) {
          dp[i][j] = dp[i][j - 1];
          p[i][j] = p[i][j - 1];
        }
        if (a[i - 1] == b[j - 1] and dp[i - 1][j - 1] + 1 > dp[i][j]) {
          dp[i][j] = dp[i - 1][j - 1] + 1;
          p[i][j] = {i - 1, j - 1};
        }
      }
    }
    vii trace;
    {
      ll i = n, j = m;
      while (p[i][j] != ii{-1, -1}) {
        auto[i1, j1] = p[i][j];
        i = i1, j = j1;
        trace.push_back({i, j});
      }
    }
    reverse(trace.begin(), trace.end());
    for (auto[i, j]: trace) {
      assert(a[i] == b[j]);
      res1.push_back(a[i]);
    }
    swap(a, b);
  }
  if (res1.size() > res.size()) res = res1;
  ll offset = 0;
  ll len = 0;
//  offset = 17;
//  for (int j = 0; j < 17; ++j) {
//    len += (int) hint[offset + j] << j;
//  }
  for (int i = 0; i + offset < hint.size(); i += 17) {
    int q = 0;
    for (int j = 0; j < 17; ++j) {
      q += (int) hint[offset + i + j] << j;
    }
    res.push_back(q);
  }
  return res;
}