#include <bits/stdc++.h>

using namespace std;

const int K = 20, CNT = 30, U = 1e7;

bool bit(int a, int n) {
    return (a >> n) & 1;
}

void write(vector<bool> v, int pos, int val) {
    for (int i = 0; i < K; i++) {
        v[pos + i] = bit(val, i);
    }
}

int read(vector<bool> v, int pos) {
    int res = 0;
    for (int i = 0; i < K; i++) {
        res += v[pos + i] * (1 << i);
    }
    return res;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<int> f, s;
    int gi = 0;
    for (int i = 0; i < a.size(); i++) {
        if (gi < sol.size() && a[i] == sol[gi]) {
            f.push_back(i);
            gi++;
        }
    }
    gi = 0;
    for (int i = 0; i < b.size(); i++) {
        if (gi < sol.size() && b[i] == sol[gi]) {
            s.push_back(i);
            gi++;
        }
    }
    vector<bool> hint(100000);
    if (!sol.empty()) {
        int len = 2 * K + 1;
        write(hint, 0, f[0]);
        write(hint, K, f[0]);
        int l = 0;
        for (int i = 1; i < f.size(); i++) {
            if (i + 1 == f.size() || 1ll * (f[i] - f[l]) * (s[i] - s[l]) > U) {
                write(hint, len, f[i]);
                write(hint, len + K, s[i]);
                if (l + 1 < i) {
                    hint[len + 2 * K] = true;
                }
                len += 2 * K + 1;
                l = i;
            }
        }
        hint.resize(len);
    }
    return hint;
}


vector<int> sl(const vector<int>& a, const vector<int>& b, int l1, int r1, int l2, int r2) {
    if (l1 > r1 || l2 > r2) return {};
    vector<int> seq;
    int n = r1 - l1 + 1;
    int m = r2 - l2 + 1;
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    vector<vector<int>> p(n + 1, vector<int>(m + 1, -1));
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[l1 + i - 1] == b[l2 + j - 1]) {
                dp[i][j] = dp[i - 1][j - 1] + 1;
                p[i][j] = 0;
            } else {
                if (dp[i][j] < dp[i - 1][j]) {
                    dp[i][j] = dp[i - 1][j];
                    p[i][j] = -1;
                }
                if (dp[i][j] < dp[i][j - 1]) {
                    dp[i][j] = dp[i][j - 1];
                    p[i][j] = 1;
                }
            }
        }
    }
    int q = n, w = m;
    while (q != 0) {
        if (p[q][w] == 0) {
            seq.push_back(a[l1 + q - 1]);
            q--;
            w--;
        } else if (p[q][w] == -1) {
            q--;
        } else {
            w--;
        }
    }
    reverse(seq.begin(), seq.end());
    return seq;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector<int> ans;
    int l1 = -1, l2 = -1;
    for (int i = 0; i < hint.size(); i += 2 * K + 1) {
        int f = read(hint, i);
        int s = read(hint, i + K);
        bool e = hint[i + 2 * K];
        if (e) {
            vector<int> v = sl(a, b, l1 + 1, f - 1, l2 + 1, s - 1);
            for (int x : v) {
                ans.push_back(x);
            }
        }
        ans.push_back(a[f]);
        l1 = f;
        l2 = s;
    }
    return sl(a, b, 0, (int)a.size() - 1, 0, (int)b.size() - 1);
}
