#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 1e6 + 1;

int N;
int T[NMAX], H[NMAX];

vector < int > G[NMAX];

bool Sel[NMAX];
vector < int > V;

int Where[NMAX];
int In[NMAX];

int dp[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

static inline void Build_Graph ()
{
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(i != j)
                if(T[j] >= T[i])
                    if(my_abs(H[i] - H[j]) <= (T[j] - T[i]))
                        G[i].push_back(j), ++In[j];

    return;
}

static inline void DFS (int Node)
{
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    V.push_back(Node);

    return;
}

auto cmp = [] (int A, int B)
{
    if(Where[A] < Where[B])
        return 1;

    return 0;
};

static inline void TopoSort ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            DFS(i);

    reverse(V.begin(), V.end());

    for(int i = 0; i < N; ++i)
        Where[V[i]] = i;

    for(int i = 1; i <= N; ++i)
        sort(G[i].begin(), G[i].end(), cmp);

    return;
}

static inline void Go (int Node)
{
    Sel[Node] = 1;

    if((int)G[Node].size() == 0)
        dp[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            Go(it), dp[Node] += dp[it];

    return;
}

static inline void Solve ()
{
    for(int i = 1; i <= N; ++i)
        Sel[i] = 0;

    for(auto it : V)
        if(!Sel[it])
            Go(it);

    int ans = 0;

    for(int i = 1; i <= N; ++i)
        if(In[i] == 0)
            ans += dp[i];

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Build_Graph();

    TopoSort();

    Solve();

    return 0;
}
