#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e3 + 1;

int N;
int T[NMAX], H[NMAX];

vector < int > G[NMAX];

bool Sel[NMAX];
vector < int > List;

int Where[NMAX];

bool used[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

static inline void Build_Graph ()
{
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(i != j)
                if(T[j] >= T[i])
                    if(my_abs(H[i] - H[j]) <= (T[j] - T[i]))
                        G[i].push_back(j);

    return;
}

static inline void DFS (int Node)
{
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    List.push_back(Node);
}

auto cmp = [] (int A, int B)
{
    if(Where[A] < Where[B])
        return 1;

    return 0;
};

static inline void TopoSort ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            DFS(i);

    reverse(List.begin(), List.end());

    for(int i = 0; i < N; ++i)
        Where[List[i]] = i;

    for(int i = 1; i <= N; ++i)
        sort(G[i].begin(), G[i].end(), cmp);

    return;
}

int Max[NMAX], Next[NMAX];
bool viz[NMAX];

static inline void Reset ()
{
    for(int i = 1; i <= N; ++i)
        Max[i] = Next[i] = 0, viz[i] = 0;

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Go (int Node)
{
    Max[Node] = 1;
    viz[Node] = 1;

    for(auto it : G[Node])
        if(!viz[it] && !used[it])
        {
            Go(it);

            if(Max[it] + 1 > Max[Node])
                Max[Node] = Max[it] + 1, Next[Node] = it;
        }

    return;
}

static inline void Solve ()
{
    int cnt = N;

    int ans = 0;

    while(cnt)
    {
        for(int i = 1; i <= N; ++i)
            if(!used[i])
            {
                ++ans;

                Reset();

                Go(i);

                cnt -= Max[i];

                int Node = i;

                while(Node)
                {
                    used[Node] = 1;

                    Node = Next[Node];
                }

                break;
            }
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Build_Graph();

    TopoSort();

    Solve();

    return 0;
}
