#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 1e3 + 1;

int N;
int T[NMAX], H[NMAX];

vector < int > G[NMAX];

bool Sel[NMAX];
vector < int > V;

int dp[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

static inline bool Ok (int X, int Y)
{
    if(X == Y)
        return 0;

    if(T[Y] >= T[X] && (T[Y] - T[X]) >= my_abs(H[X] - H[Y]))
        return 1;

    return 0;
}

static inline void Build_Graph ()
{
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(Ok(i, j))
                G[i].push_back(j);

    return;
}

static inline void DFS (int Node)
{
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    V.push_back(Node);

    return;
}

static inline void TopoSort ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            DFS(i);

    reverse(V.begin(), V.end());

    return;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

auto cmp = [] (int X, int Y)
{
    if(T[X] < T[Y])
        return 1;

    return 0;
};

static inline void Solve ()
{
    V.clear();
    for(int i = 1; i <= N; ++i)
        V.push_back(i);
    sort(V.begin(), V.end(), cmp);

    dp[0] = 1;
    int ans = 1;

    for(int i = 1; i < N; ++i)
    {
        dp[i] = 1;

        for(int j = 0; j < i; ++j)
            if(!Ok(V[j], V[i]) && !Ok(V[i], V[j]))
                dp[i] = my_max(dp[i], dp[j] + 1);

        ans = my_max(ans, dp[i]);
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Build_Graph();

    TopoSort();

    Solve();

    return 0;
}
