#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 1e3 + 1;

int N;
int T[NMAX], H[NMAX];

bool Active[NMAX];
int In[NMAX], Out[NMAX];
vector < int > G[NMAX], Tr[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

static inline void Build_Graph ()
{
    for(int i = 1; i <= N; ++i)
        Active[i] = 1;

    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(i != j)
                if(T[j] >= T[i] && my_abs(H[i] - H[j]) <= (T[j] - T[i]))
                    G[i].push_back(j), ++In[j], Tr[j].push_back(i), ++Out[i];

    return;
}

int TAKEN = 0;

static inline void DFS (int Node)
{
    Active[Node] = 0, ++TAKEN;

    int keep = 0;
    for(auto it : Tr[Node])
        if(Active[it])
        {
            keep = it;

            --Out[it];
        }

    if(keep)
        DFS(keep);

    return;
}

static inline void Solve ()
{
    Build_Graph();

    int cnt = N;
    int ans = 0;

    while(cnt > 0)
    {
        ++ans;

        for(int i = 1; i <= N; ++i)
            if(Active[i] == 1 && Out[i] == 0)
            {
                TAKEN = 0, DFS(i);

                cnt -= TAKEN;

                break;
            }
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
