#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 1e3 + 1;

int N;
int T[NMAX], H[NMAX];

bool Sel[NMAX];
vector < int > G[NMAX];

vector < int > List;
int Where[NMAX];

bool used[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}
static inline void Build_Graph ()
{
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= N; ++j)
            if(i != j)
                if(T[j] >= T[i] && my_abs(H[i] - H[j]) <= (T[j] - T[i]))
                    G[i].push_back(j);

    return;
}

static inline void DFS (int Node)
{
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    List.push_back(Node);

    return;
}

auto cmp = [] (int A, int B)
{
    if(Where[A] < Where[B])
        return 1;

    return 0;
};

int TOTAL;

static inline void Go (int Node)
{
    used[Node] = 1, ++TOTAL;

    for(auto it : G[Node])
        if(!used[it])
        {
            Go(it);

            return;
        }

    return;
}

static inline void Solve ()
{
    Build_Graph();

    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            DFS(i);

    reverse(List.begin(), List.end());

    for(int i = 0; i < N; ++i)
        Where[List[i]] = i;

    for(int i = 1; i <= N; ++i)
        sort(G[i].begin(), G[i].end(), cmp);

    int cnt = N;
    int ans = 0;

    while(cnt > 0)
    {
        ++ans;

        for(int i = 1; i <= N; ++i)
            if(!used[i])
            {
                TOTAL = 0, Go(i), cnt -= TOTAL;

                break;
            }
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
