#pragma GCC optimization("O3")
#include <cstdio>
#include <vector>
#include <algorithm>

struct state {
    short len, prevk;
    state() {
        len = prevk = 0;
    }
};

bool operator<(state a, state b)
{
    return a.len < b.len;
}

const int N = 200000;
const int K = 750;
int cnt[N];
state dp[N][K + 1];

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol)
{
    for (int i = 0, j = 0, k = 0; i < (int)sol.size(); ++i, ++j, ++k) {
        while (a[j] != sol[i]) ++j;
        while (b[k] != sol[i]) ++k;
        ++cnt[j / K];
    }
    std::vector<bool> res;
    for (int i = 0; i * K < (int)a.size(); ++i) {
        for (int j = 0; 1 << j <= K; ++j) res.push_back(cnt[i] >> j & 1);
    }
    return res;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint)
{
    std::vector<int> ans;
    int l;
    for (l = 0; 1 << l <= K; ++l);
    for (int i = 0, j = 0; i * K < a.size(); ++i) {
        int prod = i * K, until = std::min((int)a.size() - i * K, K);
        int cnt = 0;
        for (int j = 0; 1 << j <= K; ++j) cnt |= hint[l * i + j] << j;
        int mx = 0, lastk = 0;
        std::fill(dp[j], dp[j] + K + 1, state());
        while (mx < cnt) {
            ++j;
            for (int k = 1; k <= until; ++k) {
                if (a[prod + k - 1] == b[j - 1]) {
                    dp[j][k].len = dp[j - 1][k - 1].len + 1;
                    if (mx < dp[j][k].len) {
                        mx = dp[j][k].len;
                        lastk = k;
                    }
                    dp[j][k].prevk = k - 1;
                } else {
                    dp[j][k] = std::max(dp[j - 1][k], dp[j][k - 1]);
                }
            }
        }
        int l = j, k = lastk;
        std::vector<int> cur;
        while (cnt--) {
            k = dp[l][k].prevk;
            while (a[i * K + k] != b[l - 1]) --l;
            cur.push_back(b[l - 1]);
            --l;
        }
        for (int i = 0; i < (int)cur.size(); ++i) ans.push_back(cur[(int)cur.size() - i - 1]);
    }
    return ans;
}

/*
5 10
1 3 1 4 5
7 6 3 4 1 3 1 2 2 5
4
1 3 1 5
*/
