#include <cstdio>
#include <algorithm>

const int N = 1000000;
int n, pos[N], m;
std::pair<int, int> a[N], ord[N], t[N << 1];

void build()
{
    for (int i = 0; i < n; ++i) {
        t[i + n] = std::make_pair(a[ord[i].second].first + a[ord[i].second].second, ord[i].second);
        pos[ord[i].second] = i;
    }
    for (int i = n - 1; i > 0; --i) t[i] = std::min(t[i << 1], t[i << 1 | 1]);
}

void upd(int i, std::pair<int, int> x)
{
    for (i += n, t[i] = x; i > 1; i >>= 1) t[i >> 1] = std::min(t[i], t[i ^ 1]);
}

std::pair<int, int> get(int l, int r)
{
    std::pair<int, int> ans(~(1 << 31), 0);
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) ans = std::min(ans, t[l++]);
        if (r & 1) ans = std::min(ans, t[--r]);
    }
    return ans;
}

int main()
{
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) scanf("%d%d", &a[i].first, &a[i].second);
    std::sort(a, a + n);
    for (int i = 0; i < n; ++i) ord[i] = std::make_pair(a[i].first - a[i].second, i);
    std::sort(ord, ord + n);
    build();
    int ans, cnt;
    for (ans = 0, cnt = n; cnt; ++ans) {
        int cur = 1 << 31;
        while (true) {
            std::pair<int, int> next = get(std::lower_bound(ord, ord + n, std::make_pair(cur, 0)) - ord, n);
            if (next.first < ~(1 << 31)) {
                upd(pos[next.second], std::make_pair(~(1 << 31), 0));
                --cnt;
                cur = a[next.second].first - a[next.second].second;
            }
            else break;
        }
    }
    printf("%d\n", ans);
    return 0;
}
/*
6
1 1
2 3
3 2
5 4
4 1
4 3

*/
