#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<ll> tp;

void dfs(ll k, vector<vector<ll>> &dp, vector<bool> &visited){
	if(visited[k]){
		return;
	}
	visited[k]=true;
	for(ll i:dp[k]){
		dfs(i, dp, visited);
	}
}

void TopoSort(ll n, vector<ll> &degree, vector<vector<ll>> &dp){
	queue<ll> q;
	for(ll i=0; i<n; i++){
		if(degree[i]==0){
			q.push(i);
		}
	}
	while(!q.empty()){
		ll k=q.front();
		q.pop();
		tp.push_back(k);
		for(ll i:dp[k]){
			degree[i]--;
		}
		for(ll i=0; i<n; i++){
			if(degree[i]==0){
				q.push(i);
			}
		}
	}
}

int main(){
	
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	ll n, i, maxi=0, s=0, maxin1, maxin2, j;
	cin>>n;
	
	vector<pair<ll, ll>> v;
	
	for(i=0; i<n; i++){
		ll t, h;
		cin>>t>>h;
		h--;
		v.push_back({t, h});
	}
	
	sort(v.begin(), v.end());
	
	vector<vector<ll>> dp(n);
	
	vector<ll> in(n, 0);
	
	for(j=1; j<n; j++){
		for(i=0; i<j; i++){
			if(v[i].first>v[j].first && v[i].first-v[j].first>=abs(v[i].second-v[j].second)){
				dp[j].push_back(i);
				in[i]++;
				s++;
			}
		}
	}
	
	//node=query
	//in is the answer of from how many nodes can we go directly(with only 1 edge) to the given node
	//out is the answer of to how many nodes can we go directly from the given node
	//how many tree "lines" are in this graph
	//saying "lines" I mean a tree with exactly 1 leaf, each parent has 1 child
	
	//if (t1, h1)-->(t2, h2) and (t2, h2)-->(t3, h3)
	//then (t1, h1)-->(t3, h3)
	
	//to solve this problem for each edge
	//if we will use this make minimum of number of cars that we will use
	
	TopoSort(n, in, dp);
	
}
