#include "hint.h"
#include <algorithm>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    /*vector<bool> res(a.size());
    for (int i = 0, j = 0; i < a.size() && j < sol.size(); ++i)
    {
        if (a[i] == sol[j])
        {
            res[i] = true;
            ++j;
        }
    }
    return res;*/
    return vector<bool>();
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    pair<int, int> maxInd{0, 0};
    int maxRes = 0;
    for (int i = 0; i < a.size(); ++i)
    {
        for (int j = 0; j < b.size(); ++j)
        {
            dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            if (a[i] == b[j]) dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + 1);
            if (dp[i + 1][j + 1] > maxRes)
            {
                maxInd = {i + 1, j + 1};
                maxRes = dp[i + 1][j + 1];
            }
        }
    }
    vector<int> sol;
    auto [i, j] = maxInd;
    while (i != 0 && j != 0)
    {
        if (a[i - 1] == b[j - 1])
        {
            if (dp[i - 1][j - 1] == dp[i][j] - 1)
            {
                sol.push_back(a[i - 1]);
                --i;
                --j;
            }
            else if (dp[i - 1][j] == dp[i][j]) --i;
            else --j;
        }
        else
        {
            if (dp[i - 1][j] == dp[i][j]) --i;
            else --j;
        }
    }
    reverse(sol.begin(), sol.end());
    return sol;
}