#include "hint.h"
#include <iostream>

using namespace std;

void convert(int n, vector<bool> &res)
{
    for (int i = 0; i <= 17; ++i) res.push_back((n >> i) & 1);
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    if (18 * sol.size() < min(a.size(), b.size()))
    {
        vector<bool> res;
        for (int i : sol) convert(i, res);
        return res;
    }
    vector<int> dod = a;
    if (a.size() > b.size())
    {
        dod = b;
    }
    vector<bool> res(dod.size());
    for (int i = 0, j = 0; i < dod.size() && j < sol.size(); ++i)
    {
        if (dod[i] == sol[j])
        {
            res[i] = true;
            ++j;
        }
    }
    return res;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    if (hint.size() < min(a.size(), b.size()))
    {
        vector<int> sol;
        for (int i = 0; i < hint.size(); i += 18)
        {
            int n = 0;
            for (int j = 0; j < 18; ++j) n += (1 << j) * hint[i + j];
            sol.push_back(n);
        }
        return sol;
    }
    vector<int> sol;
    vector<int> dod = a;
    if (hint.size() < a.size()) dod = b;
    //for (bool i : hint) cout << i << ' ';
    for (int i = 0; i < dod.size(); ++i) if (hint[i]) sol.push_back(dod[i]);
    return sol;
}

/*
5 4
1 2 3 4 7
1 3 7 2
3
1 3 7
 */