#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1000;
vector <int> gr[1 + MAX_N];
int used[1 + MAX_N];
const int INF = 1e9;
int nxt[1 + MAX_N];
int dist[1 + MAX_N];
int N;
void add_edge(int x, int y) {
    gr[x].push_back(y);
}
int mom;
int source, sink;
bool bfs() {
    mom++;
    queue <int> q;
    for (int i = 0; i < N; i++) {
        dist[i] = 0;
        if (not used[i])
            q.push(i);
    }
    while (q.size()) {
        int node = q.front();
        q.pop();
        for (int vec : gr[node])
            if (dist[vec] < dist[node] + 1 && not used[vec]) {
                nxt[vec] = node;
                dist[vec] = dist[node] + 1;
                q.push(vec);
            }
    }
    return true;
}
int dfs() {
    int now = -1;
    for (int i = 0; i < N; i++)
        if (not used[i] && (now == -1 || dist[i] > dist[now]))
            now = i;
    if (now == -1)
        return 0;
    while (dist[now] > 0) {
        used[now] = true;
        now = nxt[now];
    }
    used[now] = true;
    return 1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> N;
    vector <pair <int, int>> deliv;
    for (int i = 1; i <= N; i++) {
        int t, h;
        cin >> t >> h;
        deliv.push_back({t, h});
    }
    sort(deliv.begin(), deliv.end());
    for (int i = 0; i < N; i++)
        for (int j = i + 1; j < N; j++) {
            if (abs(deliv[i].second - deliv[j].second) <= deliv[j].first - deliv[i].first) {
                add_edge(i, j);
            }
        }
    int ans = 0;
    while (bfs()) {
        if (not dfs())
            break;
        ans++;
    }
    cout << ans << "\n";
    return 0;
}
/**
6
1 1
2 3
3 2
5 4
4 1
4 3
**/
