#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 1000;
vector <int> gr[1 + 2 * MAX_N + 1];
int used[1 + 2 * MAX_N + 1];
const int INF = 1e9;
int nxt[1 + 2 * MAX_N + 1];
int dist[1 + 2 * MAX_N + 1];
int cap[1 + 2 * MAX_N + 1][1 + 2 * MAX_N + 1];
int N;
void add_edge(int x, int y, int c) {
    gr[x].push_back(y);
    cap[x][y] += c;
}
int mom;
int source, sink;
bool bfs() {
    mom++;
    queue <int> q;
    q.push(source);
    dist[source] = 0;
    while (q.size()) {
        int node = q.front();
        q.pop();
        for (int vec : gr[node])
            if (used[vec] != mom && cap[node][vec] > 0) {
                nxt[vec] = node;
                used[vec] = mom;
                q.push(vec);
            }
    }
    return used[sink] == mom;
}
int dfs() {
    int now = sink;
    int flow = INF;
    while (now != source) {
        flow = min(flow, cap[nxt[now]][now]);
        now = nxt[now];
    }
    now = sink;
    while (now != source) {
        cap[nxt[now]][now] -= flow;
        cap[now][nxt[now]] += flow;
        now = nxt[now];
    }
    return flow;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> N;
    vector <pair <int, int>> deliv;
    for (int i = 1; i <= N; i++) {
        int t, h;
        cin >> t >> h;
        deliv.push_back({t, h});
    }
    sort(deliv.begin(), deliv.end());
    source = 2 * N, sink = 2 * N + 1;
    for (int i = 0; i < N; i++)
        add_edge(source, i, 1);
    for (int i = 0; i < N; i++)
        add_edge(i + N, sink, INF);
    for (int i = 0; i < N; i++)
        for (int j = i + 1; j < N; j++) {
            if (abs(deliv[i].second - deliv[j].second) <= deliv[j].first - deliv[i].first) {
                add_edge(i, j + N, INF);
            }
        }
    int ans = 0;
    while (bfs())
        ans += dfs();
    cout << N - ans << "\n";
    return 0;
}
