#include<bits/stdc++.h>
using namespace std;
const int N = 1e4 + 5;
int cap[N][N];
int source, sink;
int n;
int getFlow() {
	queue<int> q;
	vector<int> up(n + 2);
	vector<bool> vis(n + 2);
	q.push(source);
	while (!q.empty()) {
		int x = q.front(); q.pop();
		vis[x] = 1;
		for (int i = 0; i < n + 2; ++i) {
			if (cap[x][i] > 0 && !vis[i]) {
				up[i] = x;
				q.push(i);
			}
		}
	}
	if (!vis[sink]) {
		return 0;
	}
	int ptr = sink, flow = 1e9;
	while (ptr != source) {
		flow = min(flow, cap[up[ptr]][ptr]);
		ptr = up[ptr];
	}
	ptr = sink;
	while (ptr != source) {
		cap[up[ptr]][ptr] -= flow;
		cap[ptr][up[ptr]] += flow;
		ptr = up[ptr];
	}
	return flow;
}
int maxFlow() {
	int ans = 0, rep = 100;
	while (true) {
		int cur = getFlow();
		if (cur == 0) break;
		ans += cur;
	}
	return ans;
}
int main() {
	cin >> n;
	vector<array<int, 2>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i][0] >> a[i][1];
	}
	source = n, sink = n + 1;
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		bool pos0 = true, pos1 = true;
		for (int j = i + 1; j < n; ++j) {
			cap[i][j] = (a[j][0] - a[i][0] >= abs(a[j][1] - a[i][1]));
			if (cap[i][j]) pos1 = false;
		}
		for (int j = 0; j < i; ++j) {
			if (cap[j][i]) pos0 = false;
		}
		if (pos0) {
			cap[source][i] = 1;
		}
		if (pos1) {
			cap[i][sink] = 1;
		}
	}
	cout << maxFlow() << endl;
}