#include "hint.h"

#include <iostream>
#include <limits>
#include <algorithm>

#define F first
#define S second

const int MAXLEN = 130; // 18
const int W = 18;
const int Q = 1e8;

using namespace std;
using pi = pair<int, int>;
using ll = long long;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<int> pos_a, pos_b;

    int ptr = 0;
    for (int x : sol) {
        while (a[ptr] != x) ++ptr;
        pos_a.push_back(ptr++);
    }

    ptr = 0;
    for (int x : sol) {
        while (b[ptr] != x) ++ptr;
        pos_b.push_back(ptr++);
    }

    int s = 1, deg = 0;
    vector<pi> help;

    const int k = sol.size();

    if (k < MAXLEN) {
        vector<bool> res(W*k);
        for (int i = 0; i < k; ++i) {
            for (int j = W*i, x = sol[i]; x != 0; x >>= 1, ++j) res[j] = x & 1;
        }
        return res;
    } else {
        int pos = 0, t = 0;
        vector<bool> res(W*MAXLEN);
        for (int i = MAXLEN; i > 0; i--) {
            while (pos_a[t] < pos) ++t;
            for (int j = W*(i-1), x = pos_b[t]; x != 0; x >>= 1, ++j) res[j] = x & 1;
            // cout << pos << " " << " " << pos_b[t] << endl;
            pos += (a.size() - pos) / i;
        }
        return res;
    }
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector<int> res;

    auto read_int = [&hint] (int pos) {
        int res = 0; pos *= W;
        for (int i = 0; i < W; ++i) {
            if (hint[pos+i]) res += 1 << i;
        }
        return res;
    };

    if (hint.size() < W * MAXLEN) {
        for (int j = 0; j < hint.size()/W; ++j) res.push_back(read_int(j));
        return res;
    }

    vector<pi> help;

    int pos = 0, j = 0;
    for (int i = MAXLEN; i > 0; i--) {
        int j = read_int(i-1);
        help.emplace_back(pos, j);
        pos += (a.size() - pos) / i;
    }

    help.emplace_back((int)a.size(), (int)b.size());

/*
    cout << "got!" << endl;
    for (auto [x, y] : help) cout << x << " " << y << endl;
*/

/*
    cerr << "s = " << s << endl;
    cerr << "help: ";
    for (auto [a, b] : help) cerr << " [" << a << ":" << b << "]";
    cerr << endl;
//*/

    for (int i = 0; i < MAXLEN; ++i) {
        int dx = help[i].F;
        int dy = help[i].S;

        int nx = help[i+1].F - dx;
        int ny = help[i+1].S - dy;

        vector dp(nx, vector<int>(ny));

        for (int x = dx; x < help[i+1].F; ++x) {
            for (int y = dy; y < help[i+1].S; ++y) {
                int cx = x - dx, cy = y - dy;
                if (cx != 0) dp[cx][cy] = max(dp[cx][cy], dp[cx-1][cy]);
                if (cy != 0) dp[cx][cy] = max(dp[cx][cy], dp[cx][cy-1]);

                if (a[x] == b[y]) {
                    if (cx && cy) dp[cx][cy] = max(dp[cx][cy], 1 + dp[cx-1][cy-1]);
                    else dp[cx][cy] = 1;
                }
            }
        }

        vector<int> seq;

        int px = help[i+1].F - dx - 1, py = help[i+1].S - dy - 1;
        while (px >= 0 && py >= 0 && dp[px][py] != 0) {
            if (a[px+dx] == b[py+dy]) {
                seq.push_back(a[px+dx]);
                px--;
                py--;
            } else {
                if (!px) py--;
                else if (!py) px--;
                else if (dp[px-1][py] > dp[px][py-1]) --px;
                else --py;
            }
        }

        reverse(seq.begin(), seq.end());
        for (int x : seq) res.push_back(x);
    }

    return res;
}