#include "hint.h"
#include <vector>

//#pragma GCC optimize ("Ofast", "O3", "-O3", "fast-math")

using namespace std;

//#define int long long
#define pii pair<int, int>

//const int inf = 4e18;
const int mod = 1e9 + 7;
const int near = 1e2;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    if (sol.empty()) {
        vector<bool> hint(1, false);
        return hint;
    }
    if (b.size() > a.size()) {
        vector<bool> hint(b.size());
        for (int i = 0, j = 0; i < b.size(); ++i) {
            hint[i] = b[i] == sol[j];
            if (b[i] == sol[j]) j++;
        }
        return hint;
    }
    vector<bool> hint(a.size());
    for (int i = 0, j = 0; i < a.size(); ++i) {
        hint[i] = a[i] == sol[j];
        if (a[i] == sol[j]) j++;
    }
    return hint;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    vector<int> c;
    if (hint.size() > a.size()) {
        for (int i = 0; i < hint.size(); ++i) {
            if (!hint[i]) continue;
            c.push_back(b[i]);
        }
        return c;
    }
    for (int i = 0; i < hint.size(); ++i) {
        if (!hint[i]) continue;
        c.push_back(a[i]);
    }
    return c;
}