#include <bits/stdc++.h>

//#pragma GCC optimize ("Ofast", "O3", "-O3", "fast-math")

using namespace std;

#define int long long
#define pii pair<int, int>
#define null NULL

const int inf = 2e9;
const int mod = 1e9 + 7;
const int near = 1e2;

static minstd_rand gen;

class Treap {
public:
    int x, y, size = 1, t;
    Treap *l = null, *r = null;

    Treap(int x, int t) {
        this->x = x;
        this->t = t;
        this->y = gen();
    }
};

int getSize(Treap *a) {
    return a ? a->size : 0;
}

void update(Treap *&a) {
    if (!a) return;
    a->size = getSize(a->l) + getSize(a->r) + 1;
}

Treap *merge(Treap *l, Treap *r) {
    if (!l || !r) return l ? l : r;
    if (l->y > r->y) {
        l->r = merge(l->r, r);
        update(l);
        return l;
    }
    r->l = merge(r->l, l);
    update(r);
    return r;
}

void split(Treap *a, int x, Treap *&l, Treap *&r) {
    if (!a) {
        l = r = null;
        return;
    }
    if (a->x < x) {
        split(a->r, x, a->r, r);
        update(a);
        l = a;
        return;
    }
    split(a->l, x, l, a->l);
    update(a);
    r = a;
}

bool contains(Treap *&a, int x) {
    Treap *l, *m, *r;
    split(a, x, l, r);
    split(r, x + 1, m, r);
    bool res = m;
    a = merge(l, merge(m, r));
    return res;
}

void erase(Treap *&a, int x) {
    Treap *l, *m, *r;
    split(a, x, l, r);
    split(r, x + 1, m, r);
    a = merge(l, r);
}

void insert(Treap *&a, int x, int t) {
    if (!a) {
        a = new Treap(x, t);
        return;
    }
    Treap *l, *r;
    split(a, x, l, r);
    a = merge(merge(l, new Treap(x, t)), r);
}

int getPos(Treap *&a, int x) {
    if (!a) return 0;
    if (a->x == x)
        return getSize(a->l);
    if (a->x < x)
        return getPos(a->l, x);
    return getSize(a->l) + 1 + getPos(a->r, x);
}

Treap *get(Treap *&a, int x) {
    if (!a) return null;
    if (getSize(a->l) == x)
        return a;
    if (getSize(a->l) > x)
        return get(a->l, x);
    return get(a->r, x - getSize(a->l) - 1);
}

int getBest(Treap *&a, int x, int t) {
    for (int i = 0; i < getSize(a); ++i) {
        auto car = get(a, i);
        int d = t - car->t;
        if (car->x - d <= x && x <= car->x + d)
            return car->x;
    }
    return -1;
}

signed main() {
    int n;
    cin >> n;
    map<int, vector<int>> schedule;
    for (int i = 0; i < n; ++i) {
        int t, s;
        cin >> t >> s;
        if (!schedule.count(t)) {
            vector<int> buf;
            schedule[t] = buf;
        }
        schedule[t].push_back(s);
    }
    for (auto time: schedule)
        sort(time.second.begin(), time.second.end());

    Treap *treap = null;
    for (auto time: schedule) {
        vector<int> add;

        for (auto house: time.second) {
            int best = getBest(treap, house, time.first);
            if (best != -1)
                erase(treap, best);
            add.push_back(house);
        }

        for (auto car: add)
            insert(treap, car, time.first);
    }


    cout << getSize(treap);
}