#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 1000000;
const int Y_MAX = 1000000000;
const ll S_MAX = (ll) Y_MAX * 3;

struct Point {
    int x, y;
};

bool operator < (const Point &a, const Point &b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y < b.y;
}

int N;

Point Q[N_MAX + 2];

unordered_map <ll, int> maxSmaller, maxLarger;

void updateLarger (ll pos, int val) {
    pos += Y_MAX;
    for (ll i = pos; i >= 1; i -= i & -i) {
        maxLarger[i] = max(maxLarger[i], val);
    }
}
void updateSmaller (ll pos, int val) {
    pos += Y_MAX;
    for (ll i = pos; i <= S_MAX; i += i & -i) {
        maxSmaller[i] = max(maxSmaller[i], val);
    }
}

int queryLarger (ll pos) {
    pos += Y_MAX;
    int val = 0;
    for (ll i = pos; i <= S_MAX; i += i & -i) {
        val = max(val, maxLarger[i]);
    }
    return val;
}
int querySmaller (ll pos) {
    pos += Y_MAX;
    int val = 0;
    for (ll i = pos; i >= 1; i -= i & -i) {
        val = max(val, maxSmaller[i]);
    }
    return val;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N; i++) {
        cin >> Q[i].x >> Q[i].y;
    }

    sort(Q + 1, Q + N + 1);

    int answer = 0;
    for (int i = 1; i <= N; i++) {
        int maxAntichain = max(queryLarger(Q[i].y + Q[i].x + 1),
                               querySmaller(Q[i].y - Q[i].x + 1)) + 1;
        updateLarger(Q[i].y - Q[i].x, maxAntichain);
        updateSmaller(Q[i].y + Q[i].x, maxAntichain);
        answer = max(answer, maxAntichain);
    }

    cout << answer << "\n";

    return 0;
}
