#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 1000000;
const int XY_MAX = 1000000000;
const ll S_MAX = (ll) XY_MAX * 3;

struct Point {
    int x, y;
};

bool operator < (const Point &a, const Point &b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y < b.y;
}

int N;

Point Q[N_MAX + 2];

unordered_map <int, int> Fen;

void update (ll pos, int val) {
    pos += XY_MAX;
    for (ll i = pos; i >= 1; i -= i & -i) {
        Fen[i] = max(Fen[i], val);
    }
}
int query (ll pos) {
    pos += XY_MAX;
    int val = 0;
    for (ll i = pos; i <= S_MAX; i += i & -i) {
        val = max(val, Fen[i]);
    }
    return val;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N; i++) {
        cin >> Q[i].x >> Q[i].y;
        Q[i] = Point{Q[i].y + Q[i].x, Q[i].y - Q[i].x};
    }

    sort(Q + 1, Q + N + 1);

    int answer = 0;
    for (int i = 1; i <= N; i++) {
        int maxAntichain = query(Q[i].y + 1) + 1;
        answer = max(answer, maxAntichain);
        update(Q[i].y, maxAntichain);
    }

    cout << answer << "\n";

    return 0;
}
