#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 1000000;

struct Point {
    int x, y;
};

bool operator < (const Point &a, const Point &b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y > b.y;
}

int N;

Point Q[N_MAX + 2];

int Fen[N_MAX + 2];

void update (int pos, int val) {
    for (int i = pos; i <= N_MAX; i += i & -i) {
        Fen[i] = max(Fen[i], val);
    }
}
int query (int pos) {
    int val = 0;
    for (int i = pos; i >= 1; i -= i & -i) {
        val = max(val, Fen[i]);
    }
    return val;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N; i++) {
        cin >> Q[i].x >> Q[i].y;
        Q[i] = Point{Q[i].y - Q[i].x, Q[i].y + Q[i].x};
    }

    sort(Q + 1, Q + N + 1);

    {
        vector <pair <int, int>> aux;
        for (int i = 1; i <= N; i++) {
            aux.push_back(make_pair(Q[i].y, i));
        }
        sort(aux.begin(), aux.end());
        int curr = 0;
        for (int i = 0; i < N; i++) {
            if (i == 0 || aux[i].first > aux[i - 1].first) {
                curr++;
            }
            Q[aux[i].second].y = curr;
        }
    }

    int answer = 0;
    for (int i = 1; i <= N; i++) {
        int maxAntichain = query(Q[i].y - 1) + 1;
        answer = max(answer, maxAntichain);
        update(Q[i].y, maxAntichain);
    }

    cout << answer << "\n";

    return 0;
}
