#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

const int K = 1500;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
	int n = a.size();
	int m = b.size();

	vector<int> p = {0};
	while (p.back() < n) {
		p.push_back(min(p.back() + K, n));
	}

	int k = p.size();

	vector<int> in_sol(n);
	vector<int> pr(n);
	int ind_a = 0, ind_b = 0;
	for (int i = 0; i < (int)sol.size(); ++i) {
		while (a[ind_a] != sol[i]) {
			++ind_a;
		}
		while (b[ind_b] != sol[i]) {
			++ind_b;
		}
		in_sol[ind_a] = 1;
		pr[ind_a] = ind_b;
		++ind_a;
		++ind_b;
	}

	vector<int> q = {0};
	for (int i = 0; i + 1 < k; ++i) {
		int last_a = -1;
		for (int j = p[i]; j < p[i + 1]; ++j) {
			if (in_sol[j]) {
				last_a = j;
			}
		}
		if (last_a == -1) {
			q.push_back(q.back()); 
		} else {
			q.push_back(pr[last_a] + 1);
		}
	}

	vector<bool> hint;
	for (int i = 1; i < k; ++i) {
		for (int j = 17; j >= 0; --j) {
			if ((q[i] >> j) & 1) {
				hint.push_back(true);
			} else {
				hint.push_back(false);
			}
		}
	}
	return hint;
}

const int N = 200001;

bitset<N> par[2001];
bitset<N> par1[2001];

vector<int> lcs(const vector<int> &a, const vector<int> &b) {
	int n = a.size();
	int m = b.size();
	vector<int> dp(m + 1, 0);
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (dp[j] > dp[j + 1]) {
				dp[j + 1] = dp[j];
				par[i][j + 1] = 1; 
				par1[i + 1][j + 1] = 0;
			}
		}
		if (i < n) {
			auto ndp = dp;
			for (int j = 0; j < m; ++j) {
				if (i < n && j < m && a[i] == b[j] && dp[j] + 1 > ndp[j + 1]) {
					ndp[j + 1] = dp[j] + 1;
					par[i + 1][j + 1] = 1;
					par1[i + 1][j + 1] = 1;

				}
			}
			swap(dp, ndp);
		}
	}
	vector<int> res;
	int i = n, j = m;
	while (i > 0 && j > 0) {
		if (par[i][j] && par1[i][j]) {
			res.push_back(a[i - 1]);
			--i;
			--j;
		} else {
			if (par[i][j]) {
				--j;
			} else {
				--i;
			}
		}
	}
	reverse(res.begin(), res.end());
	return res;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
	int n = a.size();
	int m = b.size();

	vector<int> p = {0};
	while (p.back() < n) {
		p.push_back(min(p.back() + K, n));
	}
	
	int k = p.size();

	vector<int> q = {0};
	for (int i = 0; i < (int)hint.size() / 18; ++i) {
		q.push_back(0);
		for (int j = i * 18; j < (i + 1) * 18; ++j) {
			q.back() *= 2;
			if (hint[j]) {
				++q.back();
			}
		}
	}

	vector<int> res;
	for (int i = 0; i + 1 < k; ++i) {
		vector<int> aa, bb;
		for (int j = p[i]; j < p[i + 1]; ++j) {
			aa.push_back(a[j]);
		}
		for (int j = q[i]; j < q[i + 1]; ++j) {
			bb.push_back(b[j]);
		}
		auto c = lcs(aa, bb);
		for (int x : c) {
			res.push_back(x);
		}
	}

	return res;
}
