#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

const int K = 2600;
const int N = 200000;
const int L = 18;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    int n = a.size();
    int m = b.size();
    vector<int> p = {0};
    while (p.back() < n) {
        p.push_back(min(p.back() + K, n));
    }
    int k = p.size();
    vector<int> in_sol(n);
    vector<int> pr(n);
    int ind_a = 0, ind_b = 0;
    for (int i = 0; i < (int)sol.size(); ++i) {
        while (a[ind_a] != sol[i]) {
            ++ind_a;
        }
        while (b[ind_b] != sol[i]) {
            ++ind_b;
        }
        in_sol[ind_a] = 1;
        pr[ind_a] = ind_b;
        ++ind_a;
        ++ind_b;
    }
    vector<int> q = {0};
    for (int i = 0; i + 1 < k; ++i) {
        int last_a = -1;
        for (int j = p[i]; j < p[i + 1]; ++j) {
            if (in_sol[j]) {
                last_a = j;
            }
        }
        if (last_a == -1) {
            q.push_back(q.back()); 
        } else {
            q.push_back(pr[last_a] + 1);
        }
    }
    vector<bool> hint;
    for (int i = 1; i < k; ++i) {
        for (int j = L - 1; j >= 0; --j) {
            if ((q[i] >> j) & 1) {
                hint.push_back(true);
            } else {
                hint.push_back(false);
            }
        }
    }
    return hint;
}

char dp[K + 1][N + 1];

vector<int> lcs(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    for (int i = 1; i <= n; ++i) {
    	for (int j = 1; j <= m; ++j) {
    		dp[i][j] = dp[i - 1][j];
    		if (dp[i][j - 1] > dp[i][j]) {
    			dp[i][j] = dp[i][j - 1];
    		}
    		if (a[i - 1] == b[j - 1] && dp[i - 1][j - 1] + 1 > dp[i][j]) {
    			dp[i][j] = dp[i - 1][j - 1] + 1;
    		}
    	}
    }
    vector<int> res;
    for (int i = n, j = m; i > 0 && j > 0; --i) {
    	while (j > 0 && dp[i][j] == dp[i][j - 1]) {
    		--j;
    	}
    	if (dp[i][j] != dp[i - 1][j]) {
    		res.push_back(a[i - 1]);
    		--j;
    	}
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    int n = a.size();
    int m = b.size();
    vector<int> p = {0};
    while (p.back() < n) {
        p.push_back(min(p.back() + K, n));
    }


    int k = p.size();
    vector<int> q = {0};
    for (int i = 0; i + 1 < k; ++i) {
        q.push_back(0);
        for (int j = i * L; j < (i + 1) * L; ++j) {
            q.back() *= 2;
            if (hint[j]) {
                ++q.back();
            }
        }
    }
    vector<int> res;
    for (int i = 0; i + 1 < k; ++i) {
        vector<int> aa, bb;
        for (int j = p[i]; j < p[i + 1]; ++j) {
            aa.push_back(a[j]);
        }
        for (int j = q[i]; j < q[i + 1]; ++j) {
            bb.push_back(b[j]);
        }
        auto c = lcs(aa, bb);
        for (int x : c) {
            res.push_back(x);
        }
    }
    return res;
}
