#include "hint.h"
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
	vector<bool> hint(min(a.size(), b.size()), false);
	if (a.size() < b.size())
	{
		ll ind = 0;
		for (ll i = 0; i < a.size(); i++)
		{
			if (ind < sol.size() && sol[ind] == a[i])
				hint[i] = true, ind++;
		}
	}
	else
	{
		ll ind = 0;
		for (ll i = 0; i < b.size(); i++)
		{
			if (ind < sol.size() && sol[ind] == b[i])
				hint[i] = true, ind++;
		}
	}
	return hint;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
	vector<int> ans;
	if (a.size() < b.size())
		for (ll i = 0; i < a.size(); i++)
		{
			if (hint[i])
				ans.push_back(a[i]);
		}
	else
		for (ll i = 0; i < b.size(); i++)
			if (hint[i])
				ans.push_back(b[i]);
	return ans;
}
/*
6 4
1 3 4 5 3 1
1 5 4 3
3
1 4 3

*/