#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 1 << 20;
int tree[2 * N + 228];

void upd(int i, int x) {
  int v = N + i;
  tree[v] = max(tree[v], x);
  while (v) {
    v >>= 1;
    tree[v] = max(tree[2 * v + 0], tree[2 * v + 1]);
  }
}

int get(int l, int r) {
  l += N, r += N;
  int ans = 0;
  while (l <= r) {
    ans = max(ans, tree[l]);
    ans = max(ans, tree[r]);
    l = (l + 1) / 2;
    r = (r - 1) / 2;
  }
  return ans;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  // from i to j
  // abs(h_i - hj) <= ti - tj
  // hj - tj >= hi - ti
  // hj + tj <= ti + hi
  vector<pair<int, int>> points(n);
  vector<int> all_y(n);
  vector<int> all_x(n);
  for (int i = 0; i < n; ++i) {
    int h, t;
    cin >> h >> t;
    points[i] = make_pair(h + t, h - t);
    all_x[i] = h + t;
    all_y[i] = h - t;
  }
  sort(all_x.begin(), all_x.end());
  all_x.resize(unique(all_x.begin(), all_x.end()) - all_x.begin());
  sort(all_y.begin(), all_y.end());
  all_y.resize(unique(all_y.begin(), all_y.end()) - all_y.begin());
  for (int i = 0; i < n; ++i)
    points[i] = make_pair(lower_bound(all_x.begin(), all_x.end(), points[i].first) - all_x.begin(),
                          lower_bound(all_y.begin(), all_y.end(), points[i].second) - all_y.begin());
  sort(points.begin(), points.end(), [](const pair<int, int> &a, const pair<int, int> &b) {
    if (a.second == b.second)
      return a.first < b.first;
    return a.second > b.second;
  });
  int ans = 0;
  for (int i = 0; i < n; ++i) {
    int dp = get(points[i].first + 1, N - 1) + 1;
    ans = max(ans, dp);
    upd(points[i].first, dp);
  }
  cout << ans << '\n';
  return 0;
}