#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

/*const int N = 1 << 20;
int tree[2 * N + 228];

void upd(int i, int x) {
  int v = N + i;
  tree[v] = max(tree[v], x);
  v >>= 1;
  while (v) {
    tree[v] = max(tree[2 * v + 0], tree[2 * v + 1]);
    v >>= 1;
  }
}

int get(int l, int r) {
  l += N, r += N;
  int ans = 0;
  while (l <= r) {
    ans = max(ans, tree[l]);
    ans = max(ans, tree[r]);
    cout << l << ' ' << r << '\n';
    l = (l + 1) / 2;
    r = (r - 1) / 2;
  }
  return ans;
} */

const int MAXN = 10000;
vector<int> G[MAXN];
int used[MAXN];
int couple[MAXN];

bool kun(int v, int c) {
  if (used[v] == c)
    return false;
  used[v] = c;
  for (int u : G[v]) {
    if (couple[u] == -1) {
      couple[u] = v;
      return true;
    }
  }
  for (int u : G[v]) {
    if (kun(couple[u], c)) {
      couple[u] = v;
      return true;
    }
  }
  return false;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  // from i to j
  // abs(h_i - hj) <= ti - tj
  // hj - tj >= hi - ti
  // hj + tj <= ti + hi
  vector<pair<int, int>> points(n);
  vector<int> all_x(n);
  vector<int> all_y(n);
  for (int i = 0; i < n; ++i) {
    int h, t;
    cin >> h >> t;
    points[i] = make_pair(h + t, h - t);
    all_x[i] = h + t;
    all_y[i] = h - t;
  }
  sort(all_x.begin(), all_x.end());
  all_x.resize(unique(all_x.begin(), all_x.end()) - all_x.begin());
  sort(all_y.begin(), all_y.end());
  all_y.resize(unique(all_y.begin(), all_y.end()) - all_y.begin());
  for (int i = 0; i < n; ++i)
    points[i] = make_pair(lower_bound(all_x.begin(), all_x.end(), points[i].first) - all_x.begin(),
                          lower_bound(all_y.begin(), all_y.end(), points[i].second) - all_y.begin());
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i == j)
        continue;
      if (points[j].first <= points[i].first && points[j].second >= points[i].second)
        G[i].emplace_back(j);
    }
  }
  fill(used, used + n, -1);
  fill(couple, couple + n, -1);
  int ans = n;
  for (int i = 0; i < n; ++i)
    ans -= kun(i, i);
  cout << ans << '\n';
  /*sort(points.begin(), points.end(), [](const pair<int, int> &a, const pair<int, int> &b) {
    if (a.second == b.second)
      return a.first < b.first;
    return a.second > b.second;
  });
  int ans = 0;
  for (int i = 0; i < n; ++i) {
    int dp = get(points[i].first + 1, N - 1) + 1;
    ans = max(ans, dp);
    upd(points[i].first, dp);
  }
  cout << ans << '\n';*/

  return 0;
}