#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

double need(int n, int s, int c) {
  return n * 1.0 * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
}

vector<int> solve(int n, int s, int c) {
  if (c == 0) {
    int k = n / 3;
    vector<int> ans;
    for (int i = 0; i < k; ++i)
      ans.emplace_back(k + 1 + 2 * i);
    ans.emplace_back(0);
    ans.emplace_back(n - 2);
    ans.emplace_back(n - 1);
    return ans;
  }
  if (n == 2 && s)
    return {0, 1};
  if (s >= c) {
    int k = n / 3;
    vector<int> ans;
    int l = k, r = k - 1;
    int tt = 1;
    for (int i = 0; i < (n / (3 * s)) * (s + c); ++i) {
      if (i % (s + c) < s) {
        ans.emplace_back(r + 1);
        r = min(n - 2, r + 2);
        l = max(1, l - 1);
      } else {
        if (tt) {
          ans.emplace_back(n - 1);
          ++l;
          ++r;
        } else {
          ans.emplace_back(0);
          --l;
          --r;
        }
        tt = 1 - tt;
      }
    }
    while (r - l + 1 < n - 3) {
      ans.emplace_back(r + 1);
      r = min(n - 2, r + 2);
      l = max(1, l - 1);
    }
    int cur = ans.size();
    while (l > 0 || r < n - 1) {
      if (cur % (s + c) < s) {
        if (l) {
          ans.emplace_back(l - 1);
          --l;
          if (r == n - 1);
          else
            r = min(r + 1, n - 2);
        } else {
          ans.emplace_back(r + 1);
          ++r;
        }
      } else {
        if (l) {
          ans.emplace_back(0);
          --l;
          if (r != n - 1)
            --r;
        } else {
          ans.emplace_back(n - 1);
          ++r;
        }
      }
      ++cur;
    }
    return ans;
  }
  int r = n - 1;
  vector<int> ans1;
  int cur = 0;
  while (r >= 0) {
    if (cur % (s + c) < s) {
      ans1.emplace_back(r);
      r -= 2;
      if (r == -1)
        ++r;
    } else {
      ans1.emplace_back(0);
      r -= 1;
    }
    ++cur;
  }
  vector<int> ans2;
  cur = 0;
  int l = 0;
  r = n - 1;
  while (l <= r) {
    if (cur % (s + c) < s) {
      if (l == r) {
        ans2.emplace_back(r);
        --r;
        continue;
      }
      ans2.emplace_back(r);
      if (r == 1)
        --r;
      else
        r -= 2;
      l = max(l - 1, 0);
    } else {
      if (l + 1 == r) {
        ans2.emplace_back(l);
        --r;
      } else {
        ans2.emplace_back((l + r) / 2);
        ++l;
        --r;
      }
    }
    ++cur;
  }
  if (ans1.size() < ans2.size())
    return ans1;
  return ans2;
}

bool checker(int n, int s, int c, vector<int> to_do) {
  vector<bool> where(n, true);
  for (int t = 0; t < (int) to_do.size(); ++t) {
    vector<bool> where2(n, false);
    if (t % (s + c) < s) {
      for (int i = 0; i < to_do[t]; ++i) {
        if (where[i])
          where2[max(0, i - 1)] = true;
      }
      for (int i = to_do[t] + 1; i < n; ++i) {
        if (where[i])
          where2[min(i + 1, n - 1)] = true;
      }
    } else {
      for (int i = 0; i < to_do[t]; ++i) {
        if (where[i])
          where2[min(n - 1, i + 1)] = true;
      }
      for (int i = to_do[t] + 1; i < n; ++i) {
        if (where[i])
          where2[max(i - 1, 0)] = true;
      }
    }
    swap(where, where2);
  }
  bool ok = true;
  for (int i = 0; i < n; ++i)
    ok = ok && !where[i];
  return ok;
}

//#define STRESS

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

#ifdef STRESS
  for (int n = 2; n <= 30; ++n) {
    for (int s = 0; s < 5; ++s) {
      for (int c = 0; c < 5; ++c) {
        if (s == 0 && c == 0)
          continue;
        auto tmp = solve(n, s, c);
        if (!checker(n, s, c, tmp))
          cout << n << ' ' << s << ' ' << c << '\n';
        if (tmp.size() > need(n, s, c))
          cout << n << ' ' << s << ' ' << c << ' ' << need(n, s, c) << ' ' << tmp.size() << '\n';
      }
    }
  }
#else
  int n, s, c;
  cin >> n >> s >> c;
  vector<int> ans = solve(n, s, c);
  cout << ans.size() << '\n';
  for (int x : ans)
    cout << x + 1 << '\n';
#endif
  return 0;
}