#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

#define size(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define pb emplace_back

const int bit_num = 18, bl_sz = 2021;
const int N = 2e5 + 3;

vector<int> megastupid(vector<int>& a, vector<int>& b) {
    vector<int> res;
    int id = 0;
    for (int i = 0; i < size(b); ++i) {
        if (id < size(a) && a[id] == b[i]) res.pb(b[i]), ++id;
    }
    return res;
}

vector<int> kaka(vector<int>& a, vector<int>& b) {
    vector<int> r1 = megastupid(a, b);
    vector<int> r2 = megastupid(b, a);
    return (size(r1) > size(r2) ? r1 : r2);
}

vector<int> lcs(vector<int>& a, vector<int>& b) {
    int n = size(a), m = size(b);
    vector<int> pot = kaka(a, b);
    if (a.empty() || b.empty()) return {};
    set<int> ki;
    for (int i : b)
        ki.emplace(i);
    int po = 0;
    bool bad = false;
    for (int i = 0; i < n; ++i) {
        if (po == size(pot) || pot[po] != a[i]) {
            if (ki.count(a[i])) bad = true;
        }
        if (po < size(pot) && pot[po] == a[i]) ++po;
    }
    if (!bad) return pot;

    vector<vector<short>> dp(n, vector<short>(m));

    dp[0][0] = (a[0] == b[0]);
    for (int j = 1; j < m; ++j)
        if (dp[0][j - 1] || a[0] == b[j]) dp[0][j] = 1;

    for (int i = 1; i < n; ++i) {
        copy(all(dp[i - 1]), dp[i].begin());
        if (a[i] == b[0]) dp[i][0] = 1;

        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j])
                dp[i][j] = dp[i - 1][j - 1] + 1;
            else if (dp[i][j - 1] > dp[i][j])
                dp[i][j] = dp[i][j - 1];
        }
    }


    auto f = [&](int x, int y) { return x < 0 || y < 0 ? 0 : dp[x][y]; };
    int x = n - 1, y = m - 1;
    vector<int> res;
    while (x >= 0 && y >= 0) {
        if (a[x] == b[y])
            res.pb(a[x]), --x, --y;
        else if (f(x - 1, y) == dp[x][y])
            --x;
        else
            --y;
    }
    dp.clear();
    reverse(all(res));
    return res;
}



vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    int n = size(a), m = size(b), k = size(sol);
    vector<int> id1, id2;
    int t = 0;
    for (int i = 0; i < n && t < k; ++i) {
        if (a[i] == sol[t])
            id1.pb(i), ++t;
    }
    t = 0;
    for (int i = 0; i < m && t < k; ++i) {
        if (b[i] == sol[t])
            id2.pb(i), ++t;
    }

    vector<bool> res;
    t = 0;
    for (int i = 0; i < n; i += bl_sz) {
        while (t < k && id1[t] < i + bl_sz) ++t;

        for (int j = bit_num - 1; j >= 0; --j) {
            res.pb(id2[t - 1] >> j & 1);
        }
    }
    return res;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int n = size(a), m = size(b);
    vector<int> res;

    int hid = 0, st = 0;
    for (int i = 0; i < n; i += bl_sz) {
        int id = 0;
        for (int j = 0; j < bit_num; ++j) {
            id = id * 2 + hint[hid++];
        }
        vector<int> A, B;
        for (int j = i; j < n && j < i + bl_sz; ++j)
            A.pb(a[j]);
        for (int j = st; j <= id; ++j)
            B.pb(b[j]);
        /*for (int j : A)
            cout << j << " ";
        cout << endl;
        for (int j : B)
            cout << j << " ";
        cout << endl;*/
        
        vector<int> adder = lcs(A, B);
        copy(all(adder), back_inserter(res));

        st = id + 1;
    }
    return res;
}