#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

const int N = 1e4 + 5;

struct delivery {
  int t, x;
  bool operator<(const delivery& D) const {
    if (t != D.t) return t < D.t;
    return x < D.x;
  }
};

delivery d[N];
int col[N];
bool used[N][N], viz[N];
vector<int> gr[N];

void dfs(int nod) {
  col[nod] = 1;
  while (used[nod][col[nod]])
    ++col[nod];
  for (auto vec: gr[nod]) {
    if (col[vec] > 0) continue;
    used[vec][col[nod]] = true;
    dfs(vec);
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n; ++i)
    cin >> d[i].t >> d[i].x;
  sort(d, d + n);
  for (int i = 0; i < n - 1; ++i)
    for (int j = i + 1; j < n; ++j)
      if (i != j && abs(d[j].x - d[i].x) > abs(d[j].t - d[i].t))
        gr[i].push_back(j);
  for (int i = 0; i < n; ++i)
    if (col[i] == 0)
      dfs(i);
  int ans = 0;
  for (int i = 0; i < n; ++i)
    ans = max(ans, col[i]);
  cout << ans << "\n";
  return 0;
}