#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
int l, r;

bool scared(vector<int>& game, int s, int n)
{
    for(int i = 0; i < s; i++)
    {
        game.push_back(1);
        l++; r = min(r + 1, n);
        if (l == r)
        {
            game.push_back(l);
            return true;
        }
    }
    return false;
}

bool curious(vector<int>& game, int c)
{
    int m = (l + r) / 2;
    for (int i = 0; i < c; i++)
    {
        game.push_back(m);
        l = min(l + 1, m);
        r = max(m, r - 1);
        if (l == r)
        {
            game.push_back(l);
            return true;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, s, c; cin >> n >> s >> c;
   vector<int> game;
    n >> s >> c;
    l = 1; r = n;
    bool done = false;
    bool turn = true;
    while (!done)
    {
        done = turn ? scared(game, s, n) : curious(game, c);
        turn = !turn;

    }
    if (game.size() < n)
    {
        cout << game.size() << endl;
        for (int i : game) cout << i << endl;
    }
    else
    {
        cout << n << endl;
        for (int i = 0; i < n - 1; i++)
        {
            if (i % ((long long)s + c) < s) cout << 1 << endl;
            else cout << n << endl;
        }
        cout << n << endl;
    }
}
