#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
typedef pair<int, int> pii;

vector<pii> seg;


bool scared(vector<int>& game, int s, int n)
{
    for(int i = 0; i < s; i++)
    {
        if (seg.empty()) return true;
        pii p = { -1, -1 };
        while (!seg.empty() && p.first == -1 && p.second == -1) p = seg.back();
        if (seg.empty() && p.first == -1 && p.second == -1) return true;
        seg.pop_back();
        
        int m = (p.first + p.second) / 2;
        game.push_back(m);

        int inN = -1; int inNm1 = -1;
        int in0 = -1; int in1 = -1;
        for (int j = 0; j < seg.size(); j++)
        {
            if (seg[j].first > m)
            {
                seg[j].first = min(seg[j].first + 1, n);
                seg[j].second = min(seg[j].second+1,n);
                if (seg[j].second == n - 1)
                {
                    if (inN != -1)
                    {
                        seg[inN] = { -1, -1 };
                        seg[j].second = n;
                    }
                    else inNm1 = i;
                }
                if (seg[j].second == n)
                {
                    if (inNm1 != -1)
                    {
                        seg[inNm1].second = n;
                        seg[j] = { -1, -1 };
                    }
                    else inN = i;
                }
            }
            else
            {
                seg[j].second = max(1, seg[j].second - 1);
                seg[j].first = max(1, seg[j].first - 1);
                if (seg[j].first == 2)
                {
                    if (in0 != -1)
                    {
                        seg[j].first = 1;
                        seg[in0] = { -1, -1 };
                    }
                    else in1 = j;
                }
                if (seg[j].first == 1)
                {
                    if (in1 != -1)
                    {
                        seg[in1].first = 1;
                        seg[j] = { -1, -1 };
                    }
                    else in0 = j;
                }
            }
        }
        if (p.first != p.second)
        {
            if (p.first < m) seg.push_back({ max(p.first-1, 1), max(1, m - 2) });
            seg.push_back({ min(n, m + 2), min(p.second+1, n) });
        }
    }
    return seg.empty();
}

bool curious(vector<int>& game, int c)
{
    if (seg.empty()) return true;
    pii p = { -1, -1 };
    while (!seg.empty() && p.first == -1 && p.second == -1) p = seg.back();
    if (seg.empty() && p.first == -1 && p.second == -1) return true;
    seg.pop_back();
    int m = (p.first + p.second) / 2;
    for (int i = 0; i < c; i++)
    {
        if (p.first == p.second)
        {
            game.push_back(p.first);
            int l = p.first, r = p.second;
            for (int j = 0; j < seg.size(); j++)
            {
                if (seg[j].second < m)
                {
                    seg[j].first = min(seg[j].first + i+1, m);
                    seg[j].second = min(seg[j].second + i+1, m);
                    if (seg[j].second == m)
                    {
                        l = min(l, seg[j].first);
                        seg[j] = { -1, -1 };
                    }
                }
                else
                {
                    seg[j].first = max(seg[j].first - i - 1, m);
                    seg[j].second = max(seg[j].second - i - 1, m);
                    if (seg[j].first == m)
                    {
                        r = max(l, seg[j].second);
                        seg[j] = { -1, -1 };
                    }
                }
            }
            if(l != r) seg.push_back({ l, r });
            return curious(game, c - i - 1);
        }
        game.push_back(m);
        p.first = min(p.first + 1, m);
        p.second = max(p.second - 1, m);
    }
    int l = p.first, r = p.second;
    for (int i = 0; i < seg.size(); i++)
    {
        if (seg[i].second < m)
        {
            seg[i].first = min(seg[i].first + c, m);
            seg[i].second = min(seg[i].second + c, m);
            if (seg[i].second == m)
            {
                l = min(l, seg[i].first);
                seg[i] = { -1, -1 };
            }
        }
        else
        {
            seg[i].first = max(seg[i].first - c, m);
            seg[i].second = max(seg[i].second - c, m);
            if (seg[i].first == m)
            {
                r = max(l, seg[i].second);
                seg[i] = { -1, -1 };
            }
        }
    }
    seg.push_back({ l, r });
    return seg.empty();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, s, c; cin >> n >> s >> c;
   vector<int> game;
    n >> s >> c;
    seg.push_back({ 1, n });
    bool done = false;
    bool turn = true;
    while (!done)
    {
        done = turn ? scared(game, s, n) : curious(game, c);
        turn = !turn;

    }
    if (game.size() < n)
    {
        cout << game.size() << endl;
        for (int i : game) cout << i << endl;
    }
    else
    {
        cout << n << endl;
        for (int i = 0; i < n - 1; i++)
        {
            if (i % ((long long)s + c) < s) cout << 1 << endl;
            else cout << n << endl;
        }
        cout << n << endl;
    }
}
