#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
using namespace std;
typedef pair<int, int> pii;
vector<pair<int,pii>> seg;

bool scared(vector<int>& game, int s, int n)
{
    for (int i = 0; i < s; i++)
    {
        if (seg.empty()) return true;
        pii p = { -1, -1 };
        while (!seg.empty() && p.first == -1 && p.second == -1) p = seg.back().second;
        if (seg.empty() && p.first == -1 && p.second == -1) return true;
        seg.pop_back();

        int m = (p.first + p.second) / 2;
        game.push_back(m);
        int inN = -1; int inNm1 = -1;
        int in0 = -1; int in1 = -1;
        for (int j = 0; j < seg.size(); j++)
        {
            if (seg[j].first > m)
            {
                seg[j].second.first = min(seg[j].second.first + 1, n);
                seg[j].second.second = min(seg[j].second.second + 1, n);
                seg[j].first = seg[j].second.second - seg[j].second.first + 1;
                if (seg[j].second.second == n - 1)
                {
                    if (inN != -1)
                    {
                        seg[inN] = { 0, { -1, -1 } };
                        seg[j].second.second = n;
                        seg[j].first = seg[j].second.second - seg[j].second.first + 1;
                    }
                    else inNm1 = j;
                }
                if (seg[j].second.second == n)
                {
                    if (inNm1 != -1)
                    {
                        seg[inNm1].second.second = n;
                        seg[inNm1].first = seg[inNm1].second.second - seg[inNm1].second.first + 1;
                        seg[j] = { 0, { -1, -1 } };
                    }
                    else inN = j;
                }
            }
            else
            {
                seg[j].second.second = max(1, seg[j].second.second - 1);
                seg[j].second.first = max(1, seg[j].second.first - 1);
                seg[j].first = seg[j].second.second - seg[j].second.first + 1;
                if (seg[j].first == 2)
                {
                    if (in0 != -1)
                    {
                        seg[j].second.first = 1;
                        seg[in0] = { 0, { -1, -1 } };
                        seg[j].first = seg[j].second.second - seg[j].second.first + 1;
                    }
                    else in1 = j;
                }
                if (seg[j].first == 1)
                {
                    if (in1 != -1)
                    {
                        seg[in1].second.first = 1;
                        seg[in1].first = seg[in1].second.second - seg[in1].second.first + 1;
                        seg[j] = { 0, { -1, -1 } };
                    }
                    else in0 = j;
                }
            }
        }
        if (p.first != p.second)
        {
            if (p.first < m) seg.push_back({ max(1, m - 2) - max(p.first - 1, 1) , { max(p.first - 1, 1), max(1, m - 2) } });
            seg.push_back({ min(p.second + 1, n)  - min(n, m + 2), { min(n, m + 2), min(p.second + 1, n) } });
        }
    }
    return seg.empty();
}
bool curious(vector<int>& game, int c)
{
    if (seg.empty()) return true;
    pii p = { -1, -1 };
    while (!seg.empty() && p.first == -1 && p.second == -1) p = seg.back().second;
    if (seg.empty() && p.first == -1 && p.second == -1) return true;
    seg.pop_back();
    int m = (p.first + p.second) / 2;
    for (int i = 0; i < c; i++)
    {
        if (p.first == p.second)
        {
            game.push_back(p.first);
            int l = p.first, r = p.second;
            for (int j = 0; j < seg.size(); j++)
            {
                if (seg[j].second.second < m)
                {
                    seg[j].second.first = min(seg[j].second.first + i + 1, m);
                    seg[j].second.second = min(seg[j].second.second + i + 1, m);
                    seg[j].first = seg[j].second.second - seg[j].second.first + 1;

                    if (seg[j].second.second == m)
                    {
                        l = min(l, seg[j].second.first);
                        seg[j] = { 0, { -1, -1 } };
                    }
                }
                else
                {
                    seg[j].second.first = max(seg[j].second.first - i - 1, m);
                    seg[j].second.second = max(seg[j].second.second - i - 1, m);
                    seg[j].first = seg[j].second.second - seg[j].second.first + 1;

                    if (seg[j].second.first == m)
                    {
                        r = max(l, seg[j].second.second);
                        seg[j] = { 0, { -1, -1 } };
                    }
                }
            }
            if (l != r) seg.push_back({ r - l + 1,{ l, r } });
            return curious(game, c - i - 1);
        }
        game.push_back(m);
        p.first = min(p.first + 1, m);
        p.second = max(p.second - 1, m);
    }
    int l = p.first, r = p.second;
    for (int j = 0; j < seg.size(); j++)
    {
        if (seg[j].second.second < m)
        {
            seg[j].second.first = min(seg[j].second.first + c, m);
            seg[j].second.second = min(seg[j].second.second + c, m);
            seg[j].first = seg[j].second.second - seg[j].second.first + 1;

            if (seg[j].second.second == m)
            {
                l = min(l, seg[j].second.first);
                seg[j] = { 0, { -1, -1 } };
            }
        }
        else
        {
            seg[j].second.first = max(seg[j].second.first - c, m);
            seg[j].second.second = max(seg[j].second.second - c, m);
            seg[j].first = seg[j].second.second - seg[j].second.first + 1;

            if (seg[j].second.first == m)
            {
                r = max(l, seg[j].second.second);
                seg[j] = { 0, { -1, -1 } };
            }
        }
    }
    if (l != r) seg.push_back({ r - l + 1,{ l, r } });
    return seg.empty();
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, s, c; cin >> n >> s >> c;
    vector<int> game;
    n >> s >> c;
    seg.push_back({ n, { 1, n } });
    bool done = false;
    bool turn = true;
    while (!done)
    {
        done = turn ? scared(game, s, n) : curious(game, c);
        sort(seg.begin(), seg.end());
        turn = !turn;
    }
    cout << game.size() << endl;
    for (int i : game) cout << i << endl;

}
