#include "hint.h"
#include "bitset"
#include <algorithm>
#include <vector>
//#include <bits/stdc++.h>


using namespace std;

const int BUBEN = 700;
const int B = 10;


bitset<B> to_bin(int x) {
    bitset<B> res;
    for (int i = 0; i < B; ++i) {
        res[i] = x & 1;
        x = x >> 1;
    }
    return res;
}

int from_bin(bitset<B> &b) {
    int res = 0;
    for (int i = 0; i < B; ++i) {
        res += (1 << i) * b[i];
    }
    return res;
}

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    vector<int> cnt((a.size() + BUBEN - 1) / BUBEN);
    int p = 0;
    for (int i = 0; i < a.size() && p < sol.size(); ++i) {
        if (a[i] == sol[p]) {
            cnt[i / BUBEN]++;
            ++p;
        }
    }
    vector<bool> res;
    for (int i = 0; i < cnt.size(); ++i) {
        auto bit = to_bin(cnt[i]);
        for (int j = 0; j < B; ++j) {
            res.push_back(bit[j]);
        }
    }
    return res;
}

int dp[BUBEN + 1][BUBEN + 1];
int from[BUBEN + 1][BUBEN + 1];


vector<int> calc(int b1, int b2, const vector<int> &a, const vector<int> &b) {
    int l1 = BUBEN * b1, l2 = BUBEN * b2;
    int r1 = min((int) a.size(), l1 + BUBEN), r2 = min((int) b.size(), l2 + BUBEN);
    int len1 = r1 - l1, len2 = r2 - l2;
    for (int i = 0; i < len1; ++i) {
        for (int j = 0; j < len2; ++j) {
            int mx = 0;
            from[i][j] = -1;
            if (j != 0 && dp[i][j - 1] > mx) {
                mx = dp[i][j - 1];
                from[i][j] = 1;
            }
            if (i != 0 && dp[i - 1][j] > mx) {
                mx = dp[i - 1][j];
                from[i][j] = 2;
            }
            if (a[l1 + i] == b[l2 + j] && dp[i - 1][j - 1] + 1 > mx) {
                mx = dp[i - 1][j - 1] + 1;
                from[i][j] = 3;
            }
            dp[i][j] = mx;
        }
    }
    vector<int> res;
    int x = len1 - 1, y = len2 - 1;
    while (x != -1 && y != -1) {
        if (from[x][y] == -1) break;
        if (from[x][y] == 1) {
            y--;
        }
        if (from[x][y] == 2) {
            x--;
        }
        if (from[x][y] == 3) {
            res.push_back(a[l1 + x]);
            x--, y--;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}


std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> cnt((a.size() + BUBEN - 1) / BUBEN);
    for (int i = 0; i < hint.size(); i += B) {
        auto bin = bitset<B>();
        for (int j = i; j < i + B; ++j) {
            bin[j - i] = hint[j];
        }
        cnt[i / B] = from_bin(bin);
    }
    vector<int> res;
    int b1_len = ((int) a.size() + BUBEN - 1) / BUBEN;
    int b2_len = ((int) b.size() + BUBEN - 1) / BUBEN;
    for (int b1 = 0, b2 = 0; b1 < b1_len && b2 < b2_len; ++b1) {
        int was = 0;
        while (was < cnt[b1]) {
            vector<int> part_res = calc(b1, b2, a, b);
            was += (int) part_res.size();
            res.insert(res.end(), part_res.begin(), part_res.end());
            b2++;
        }
    }
    return res;
}
