#include "hint.h"
#include "bitset"
#include <algorithm>
#include <vector>
//#include <bits/stdc++.h>


using namespace std;

const int BUBEN = 3;
const int B = 10;


bitset<B> to_bin(int x) {
    bitset<B> res;
    for (int i = 0; i < B; ++i) {
        res[i] = x & 1;
        x = x >> 1;
    }
    return res;
}

int from_bin(bitset<B> &b) {
    int res = 0;
    for (int i = 0; i < B; ++i) {
        res += (1 << i) * b[i];
    }
    return res;
}

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    vector<int> cnt((a.size() + BUBEN - 1) / BUBEN);
    int p = ((int) sol.size()) - 1;
    for (int i = ((int) a.size()) - 1; i >= 0 && p >= 0; --i) {
        if (a[i] == sol[p]) {
            cnt[i / BUBEN]++;
            --p;
        }
    }
    vector<bool> res;
    for (int i = 0; i < cnt.size(); ++i) {
        auto bit = to_bin(cnt[i]);
        for (int j = 0; j < B; ++j) {
            res.push_back(bit[j]);
        }
    }
    return res;
}

int dp[BUBEN + 1][BUBEN + 1];
int from[BUBEN + 1][BUBEN + 1];


vector<pair<int, int>> calc(int l1, int r1, int l2, int r2, const vector<int> &a, const vector<int> &b) {
    int len1 = r1 - l1, len2 = r2 - l2;
    for (int i = 0; i < len1; ++i) {
        for (int j = 0; j < len2; ++j) {
            int mx = i == 0 || j == 0 ? 0 : -1;
            from[i][j] = -1;
            if (j != 0 && dp[i][j - 1] >= mx) {
                mx = dp[i][j - 1];
                from[i][j] = 1;
            }
            if (i != 0 && dp[i - 1][j] >= mx) {
                mx = dp[i - 1][j];
                from[i][j] = 2;
            }
            if (a[l1 + i] == b[l2 + j] && dp[i - 1][j - 1] + 1 > mx) {
                mx = dp[i - 1][j - 1] + 1;
                from[i][j] = 3;
            }
            dp[i][j] = mx;
        }
    }
    vector<pair<int, int>> res;
    int x = len1 - 1, y = len2 - 1;
    while (x != -1 && y != -1) {
        if (from[x][y] == -1) break;
        if (from[x][y] == 1) {
            y--;
        }
        if (from[x][y] == 2) {
            x--;
        }
        if (from[x][y] == 3) {
            res.emplace_back(l1 + x, l2 + y);
            x--, y--;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}


std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> cnt((a.size() + BUBEN - 1) / BUBEN);
    for (int i = 0; i < hint.size(); i += B) {
        auto bin = bitset<B>();
        for (int j = i; j < i + B; ++j) {
            bin[j - i] = hint[j];
        }
        cnt[i / B] = from_bin(bin);
    }
    vector<pair<int, int>> res;
    int b1_len = ((int) a.size() + BUBEN - 1) / BUBEN;
    int b2_len = ((int) b.size() + BUBEN - 1) / BUBEN;
    int mx_b2 = 0;
    for (int b1 = 0, b2 = 0; b1 < b1_len && b2 < b2_len; ++b1) {
        int was = 0;
        int mx_b1 = b1 * BUBEN;
        while (was < cnt[b1]) {
            vector<pair<int, int>> part_res = calc(mx_b1, min((int) a.size(), (b1 + 1) * BUBEN), mx_b2,
                                                   min((int) b.size(), (b2 + 1) * BUBEN), a, b);
            int need = cnt[b1] - was;
            int to_use = min(need, (int) part_res.size());
            was += to_use;
            res.insert(res.end(), part_res.begin(), part_res.begin() + to_use);
            if (to_use != 0) {
                mx_b1 = part_res[to_use - 1].first + 1;
                mx_b2 = part_res[to_use - 1].second + 1;
            }
            if (was < cnt[b1]) {
                b2++;
                mx_b2 = b2 * BUBEN;
            }
        }
    }
    vector<int> ans;
    for (auto&[i, _]: res) {
        ans.push_back(a[i]);
    }
    return ans;
}
