#include "hint.h"
#include "bitset"
#include <algorithm>
#include <vector>
//#include <bits/stdc++.h>


using namespace std;

const int BUBEN = 1e4;
const int B = 10;


bitset<B> to_bin(int x) {
    bitset<B> res;
    for (int i = 0; i < B; ++i) {
        res[i] = x & 1;
        x = x >> 1;
    }
    return res;
}

int from_bin(bitset<B> &b) {
    int res = 0;
    for (int i = 0; i < B; ++i) {
        res += (1 << i) * b[i];
    }
    return res;
}

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    return {};
}

int dp[BUBEN + 1][BUBEN + 1];
int from[BUBEN + 1][BUBEN + 1];


vector<pair<int, int>> calc(int l1, int r1, int l2, int r2, const vector<int> &a, const vector<int> &b) {
    int len1 = r1 - l1, len2 = r2 - l2;
    for (int i = 0; i < len1; ++i) {
        for (int j = 0; j < len2; ++j) {
            int mx = i == 0 || j == 0 ? 0 : -1;
            from[i][j] = -1;
            if (j != 0 && dp[i][j - 1] >= mx) {
                mx = dp[i][j - 1];
                from[i][j] = 1;
            }
            if (i != 0 && dp[i - 1][j] >= mx) {
                mx = dp[i - 1][j];
                from[i][j] = 2;
            }
            if (a[l1 + i] == b[l2 + j] && dp[i - 1][j - 1] + 1 > mx) {
                mx = dp[i - 1][j - 1] + 1;
                from[i][j] = 3;
            }
            dp[i][j] = mx;
        }
    }
    vector<pair<int, int>> res;
    int x = len1 - 1, y = len2 - 1;
    while (x != -1 && y != -1) {
        if (from[x][y] == -1) break;
        if (from[x][y] == 1) {
            y--;
        }
        if (from[x][y] == 2) {
            x--;
        }
        if (from[x][y] == 3) {
            res.emplace_back(l1 + x, l2 + y);
            x--, y--;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}


std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<pair<int, int>> res = calc(0, a.size(), 0, b.size(), a, b);
    vector<int> ans;
    ans.reserve(res.size());
    for (auto x: res) {
        ans.emplace_back(a[x.first]);
    }
    return ans;
}
