#include <bits/stdc++.h>
#include "hint.h"

#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
using namespace std;

const int MX = 1e4;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    int n = a.size(), m = b.size();
    if (n <= MX && m <= MX) {
        vector <bool> hint{0};
        return hint;
    }

    vector <bool> hint;

    if (n < m) {
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
            if (ptr == sol.size()) break;
            bool cur = (sol[ptr] == a[i]);
            if (cur) ++ptr;

            hint.push_back(cur);
        }
        while (!hint.back()) hint.pop_back();
        return hint;
    }
    else {
        int ptr = 0;
        for (int i = 0; i < m; ++i) {
            if (ptr == sol.size()) break;
            bool cur = (sol[ptr] == b[i]);
            if (cur) ++ptr;

            hint.push_back(cur);
        }
        while (!hint.back()) hint.pop_back();
        return hint;
    }
}

template<typename T>
inline bool chmax(T& a, T b) {
    if (a < b) { a = b; return 1; }
    return 0;
}
#define pii pair<short,short>

vector <int> solve(const vector <int> &a, const vector <int> &b, const vector <bool> &hint) {
    if (hint.size() == 1 && hint[0] == 0) {
        int n = a.size(), m = b.size();
        vector < vector <short> > dp(n + 1, vector <short> (m + 1));
        vector < vector <pii> > p(n + 1, vector <pii> (m + 1));

        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                if (a[i - 1] == b[j - 1]) {
                    if (chmax(dp[i][j], (short)((short)dp[i - 1][j - 1] + (short)1))) {
                        p[i][j] = {i - 1, j - 1};
                    }
                }
                else {
                    if (chmax(dp[i][j], dp[i - 1][j])) p[i][j] = {i - 1, j};
                    if (chmax(dp[i][j], dp[i][j - 1])) p[i][j] = {i, j - 1};
                }
            }
        }

        int x = n, y = m;
        vector <int> ans;

        while (x && y) {
            int xx, yy;
            tie(xx, yy) = p[x][y];
            if (xx == x - 1 && yy == y - 1) {
                ans.push_back(a[xx]);
            }
            tie(x, y) = p[x][y];
        }
        reverse(all(ans));
        return ans;
    }
    else {
        vector <int> ans;
        if (a.size() < b.size()) {
            for (int i = 0; i < hint.size(); ++i) {
                if (hint[i]) ans.push_back(a[i]);
            }
        }
        else {
            for (int i = 0; i < hint.size(); ++i) {
                if (hint[i]) ans.push_back(b[i]);
            }
        }
        return ans;
    }
}

//signed main() {
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//
//    int n;
//    cin >> n;
//    vector <int> a(n);
//    for (auto &i : a) cin >> i;
//
//    int m;
//    cin >> m;
//    vector <int> b(m);
//    for (auto &i : b) cin >> i;
//
//    int k;
//    cin >> k;
//    vector <int> c(k);
//    for (auto &i : c) cin >> i;
//
//    auto x = genHint(a, b, c);
//    auto ans = solve(a, b, x);
//
//    cout << ans.size() << '\n';
//    for (auto i : ans) cout << i << " ";
//}
