#include <bits/stdc++.h>
#include "hint.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
const int LG = 17;
const int N = 1 << LG;
const int MAX = 100;
const ll MXS = 1e7;

vector<bool> genHint(const vi& a, const vi& b, const vi& sol) {
    if (sol.empty()) {
        vector<bool> h;
        return h;
    }
    vi A, B;
    A.push_back(-1);
    B.push_back(-1);
    {
        int i = 0;
        for(auto &x : sol) {
            while(a[i] != x) i++;
            A.push_back(i++);
        }
    }
    {
        int i = 0;
        for(auto &x : sol) {
            while(b[i] != x) i++;
            B.push_back(i++);
        }
    }
    A.push_back((int)a.size());
    B.push_back((int)b.size());
    assert((int)max(a.size(), b.size()) < N);
    int sz = A.size();
    const ll INF = 2e18;
    vector<vector<ll>> dp(sz, vector<ll>(MAX, INF));
    vector<vi> opt(sz, vi(MAX, 0));
    dp[0][0] = 0;
    for(int i = 1; i < sz; ++i) {
        for(int j = 1; j < MAX; ++j) {
            auto check = [&] (int e) {
                if (e >= i) return false;
                if (e < 0) return false;
                if (dp[e][j - 1] == INF) return false;
                ll kek = 1ll * (A[i] - A[e] - 1) * (B[i] - B[e] - 1);
                if (kek > MXS && e != i - 1) return false;
                ll value = dp[e][j - 1] + 1ll * (A[i] - A[e] - 1) * (B[i] - B[e] - 1);
                if (value < dp[i][j]) {
                    dp[i][j] = value;
                    opt[i][j] = e;
                    return true;
                }
                return false;
            };
            opt[i][j] = opt[i - 1][j];
            while(opt[i][j] < i && check(opt[i][j])) {
                opt[i][j]++;
            }
            opt[i][j]--;
            const int T = 40;
            int w1 = opt[i][j];
            int w2 = i;
            for(int k = -T; k <= T; ++k) {
                int c1 = w1 + k;
                int c2 = w2 + k;
                check(c1);
                check(c2);
            }
        }
    }
    vector<int> res;
    int i = sz - 1;
    int j = MAX - 1;
    while(j >= 0 && dp[i][j] == INF) j--;
    while(j > 0) {
        res.push_back(i);
        i = opt[i][j];
        j--;
    }
    reverse(all(res));
    res.pop_back();
    vector<bool> ans;
    auto add = [&] (int x) {
        rep(i, LG) {
            if ((1 << i) & x) {
                ans.push_back(true);
            } else {
                ans.push_back(false);
            }
        }
    };
    for(auto &e : res) {
        add(A[e]);
        add(B[e]);
    }
    return ans;
}

vi solve(const vi& a, const vi& b, const vector<bool>& hint) {
    vi A, B;
    A.push_back(-1);
    B.push_back(-1);
    int cur = 0;
    auto read = [&] () {
        int x = 0;
        rep(i, LG) {
            if (hint[cur]) {
                x |= (1 << i);
            }
            cur++;
        }
        return x;
    };
    while(cur < (int)hint.size()) {
        A.push_back(read());
        B.push_back(read());
    }
    assert(cur == (int)hint.size());
    A.push_back((int)a.size());
    B.push_back((int)b.size());
    vector<int> ans;
    auto solve = [&] (int l1, int r1, int l2, int r2) {
        if (l1 >= r1 || l2 >= r2) return;
        int n = r1 - l1 + 1;
        int m = r2 - l2 + 1;
        if (1ll * n * m > MXS) return;
        vector<vector<int>> dp(n + 1, vector<int> (m + 1, 0));
        vector<vector<int>> pred(n + 1, vector<int> (m + 1, -1));
        rep(i, n + 1) {
            rep(j, m + 1) {
                if (i < n && j < m && a[l1 + i] == b[l2 + j]) {
                    dp[i + 1][j + 1] = dp[i][j] + 1;
                    pred[i + 1][j + 1] = 0;
                }
                if (i < n && dp[i + 1][j] < dp[i][j]) {
                    dp[i + 1][j] = dp[i][j];
                    pred[i + 1][j] = 1;
                }
                if (j < m && dp[i][j + 1] < dp[i][j]) {
                    dp[i][j + 1] = dp[i][j];
                    pred[i][j + 1] = 2;
                }
            }
        }
        vi cur;
        while(pred[n][m] != -1) {
            if (pred[n][m] == 0) {
                cur.push_back(a[l1 + n - 1]);
                n--;
                m--;
            } else if (pred[n][m] == 1) {
                n--;
            } else {
                m--;
            }
        }
        reverse(all(cur));
        for(auto &x : cur) ans.push_back(x);
    };
    bool need = (int)A.size() == MAX;
    for(int i = 1; i < (int)A.size(); ++i) {
        if (need) solve(A[i - 1] + 1, A[i] - 1, B[i - 1] + 1, B[i] - 1);
        if (i + 1 != (int)A.size()) {
            ans.push_back(a[A[i]]);
        }
    }
    return ans;
}
