#include "hint.h"

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

const int NMAX = 200'005;
const int P2 = 20;

vector < bool > getBinary(int nr) {
    vector < bool > ret(P2);

    int k = 0;
    while(nr) {
        ret[k++] = nr % 2;
        nr /= 2;
    }

    return ret;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector < bool > ret;
    ret.reserve(P2 * sol.size());

    for(auto& it : sol) {
        auto b2 = getBinary(it);

        for(int i = 0;i < P2; ++i)
            ret.push_back(b2[i]);
    }

    return ret;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    const int hintSize = (int)hint.size() / P2;
    vector < int > ret(hintSize);

    for(int i = 0;i < hintSize;++i) {
        
        int nr{};
        for(int j = 0;j < P2;++j) {
            if(hint[P2 * i + j])
                nr += (1 << j);
        }

        ret[i] = nr;
    }

    return ret;
}   