#include "hint.h"

#include <bits/stdc++.h>

using namespace std;


vector<bool> rle_encode(const vector<bool>& in) {
	if(in.empty()) {
		return in;
	}

	vector<bool> out;
	out.push_back(in[0]);

	int l = 0;
	while(l < in.size()) {
		int r = l;
		while(r < in.size() && in[r] == in[l]) {
			r++;
		}
		int c = r - l;
		if(c == 1) {
			out.push_back(0);
		} else if(c == 2) {
			out.push_back(1);
			out.push_back(0);
		} else {
			out.push_back(1);
			out.push_back(1);
			for(int j = 0; j < 18; j++) {
				out.push_back((c >> j) & 1);
			}
		}
		l = r;
	}

	return out;
}


vector<bool> rle_decode(const vector<bool>& in) {
	if(in.empty()) {
		return in;
	}

	vector<bool> out;
	bool cur_val = in[0];

	int i = 1;
	while(i < in.size()) {
		int c;
		if(in[i++] == 0) {
			c = 1;
		} else {
			if(in[i++] == 0) {
				c = 2;
			} else {
				c = 0;
				for(int j = 0; j < 18; j++) {
					c |= (int)in[i++] << j;
				}
			}
		}
		for(int j = 0; j < c; j++) {
			out.push_back(cur_val);
		}
		cur_val = !cur_val;
	}

	return out;
}


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	vector<bool> hint(a.size());
	int i = 0;
	for(int x: sol) {
		while(a[i] != x) {
			i++;
		}
		hint[i] = 1;
		i++;
	}
	return rle_encode(hint);
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	auto dec_hint = rle_decode(hint);
	vector<int> sol;
	for(int i = 0; i < dec_hint.size(); i++) {
		if(dec_hint[i]) {
			sol.push_back(a[i]);
		}
	}
	return sol;
}


void unit_test() {
	vector<bool> vec{1, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1};
	assert(rle_decode(rle_encode(vec)) == vec);
}
