#include "hint.h"

#include <bits/stdc++.h>

using namespace std;


void genHint(const vector<int>& a, const vector<int>& b, int al, int ar, int bl, int br, int depth, vector<int>& hint_ints, const vector<pair<int, int>>& sol_idxes) {
	if(depth == 0) {
		return;
	}

	int am = (al + ar) / 2;

	auto it = lower_bound(sol_idxes.begin(), sol_idxes.end(), make_pair(am, 0));
	int bm = it != sol_idxes.end() && it->first < ar && it->second < br ? it->second : br;

	hint_ints.push_back(bm);
	genHint(a, b, al, am, bl, bm, depth - 1, hint_ints, sol_idxes);
	genHint(a, b, am, ar, bm, br, depth - 1, hint_ints, sol_idxes);
}


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	int i = 0;
	int j = 0;
	vector<pair<int, int>> sol_idxes;
	for(int x: sol) {
		while(a[i] != x) {
			i++;
		}
		while(b[j] != x) {
			j++;
		}
		sol_idxes.emplace_back(i, j);
		i++;
		j++;
	}

	vector<int> hint_ints;
	genHint(a, b, 0, a.size(), 0, b.size(), 5, hint_ints, sol_idxes);

	vector<bool> hint;
	for(int x: hint_ints) {
		for(int j = 0; j < 18; j++) {
			hint.push_back((x >> j) & 1);
		}
	}

	return hint;
}


void solve(const vector<int>& a, const vector<int>& b, int al, int ar, int bl, int br, int depth, vector<int>& hint_ints, vector<int>& sol) {
	if(depth == 0) {
		if(al == ar || bl == br) {
			return;
		}

		vector<vector<int>> dp(ar - al, vector<int>(br - bl));
		for(int i = 0; i < ar - al; i++) {
			for(int j = 0; j < br - bl; j++) {
				if(a[al + i] == b[bl + j]) {
					dp[i][j] = (i == 0 || j == 0 ? 0 : dp[i - 1][j - 1]) + 1;
				} else {
					dp[i][j] = max(i == 0 ? 0 : dp[i - 1][j], j == 0 ? 0 : dp[i][j - 1]);
				}
			}
		}

		int i = ar - al - 1;
		int j = br - bl - 1;

		if(dp[i][j] > 0) {
			sol.resize(sol.size() + dp[i][j]);
			int pos = sol.size();

			while(i >= 0 && j >= 0 && dp[i][j] > 0) {
				if(a[al + i] == b[bl + j]) {
					sol[--pos] = a[al + i];
					i--;
					j--;
				} else {
					if(i > 0 && dp[i - 1][j] == dp[i][j]) {
						i--;
					} else {
						j--;
					}
				}
			}
		}

		return;
	}

	int am = (al + ar) / 2;

	int bm = hint_ints.back();
	hint_ints.pop_back();

	solve(a, b, al, am, bl, bm, depth - 1, hint_ints, sol);
	solve(a, b, am, ar, bm, br, depth - 1, hint_ints, sol);
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	vector<int> hint_ints;
	for(int i = 0; i < hint.size(); i += 18) {
		int x = 0;
		for(int j = 0; j < 18; j++) {
			x |= (int)hint[i + j] << j;
		}
		hint_ints.push_back(x);
	}

	reverse(hint_ints.begin(), hint_ints.end());
	vector<int> sol;
	solve(a, b, 0, a.size(), 0, b.size(), 5, hint_ints, sol);

	return sol;
}


void unit_test() {
}
