#include "hint.h"

#include <bits/stdc++.h>

using namespace std;


// const int K = 5715;
const int K = 2000;


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	int i = 0;
	int j = 0;
	vector<pair<int, int>> sol_idxes;
	for(int x: sol) {
		while(a[i] != x) {
			i++;
		}
		while(b[j] != x) {
			j++;
		}
		sol_idxes.emplace_back(i, j);
		i++;
		j++;
	}

	vector<int> separators;
	for(int i = K; i < a.size(); i += K) {
		auto it = lower_bound(sol_idxes.begin(), sol_idxes.end(), make_pair(i, 0));
		separators.push_back(it == sol_idxes.end() ? b.size() : it->second);
	}

	vector<bool> hint;
	for(int x: separators) {
		for(int j = 0; j < 18; j++) {
			hint.push_back((x >> j) & 1);
		}
	}

	return hint;
}


vector<int> dp[K];


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	vector<int> separators;
	for(int i = 0; i < hint.size(); i += 18) {
		int x = 0;
		for(int j = 0; j < 18; j++) {
			x |= (int)hint[i + j] << j;
		}
		separators.push_back(x);
	}


	vector<int> sol;

	for(int i = 0; i < a.size(); i += K) {
		int al = i;
		int ar = min(i + K, (int)a.size());
		int bl = i == 0 ? 0 : separators[i / K - 1];
		int br = i / K == separators.size() ? b.size() : separators[i / K];

		// cerr << al << ".." << ar << " " << bl << ".." << br << " | " << ar - al << " " << br - bl << endl;

		if(bl < br) {
			for(int i = 0; i < ar - al; i++) {
				dp[i].resize(br - bl);
				for(int j = 0; j < br - bl; j++) {
					if(a[al + i] == b[bl + j]) {
						dp[i][j] = (i == 0 || j == 0 ? 0 : dp[i - 1][j - 1]) + 1;
					} else {
						dp[i][j] = max(i == 0 ? 0 : dp[i - 1][j], j == 0 ? 0 : dp[i][j - 1]);
					}
				}
			}

			int ai = ar - al - 1;
			int bi = br - bl - 1;

			if(dp[ai][bi] > 0) {
				sol.resize(sol.size() + dp[ai][bi]);
				int pos = sol.size();

				while(ai >= 0 && bi >= 0 && dp[ai][bi] > 0) {
					if(a[al + ai] == b[bl + bi]) {
						sol[--pos] = a[al + ai];
						ai--;
						bi--;
					} else {
						if(ai > 0 && dp[ai - 1][bi] == dp[ai][bi]) {
							ai--;
						} else {
							bi--;
						}
					}
				}
			}
		}
	}

	return sol;
}


void unit_test() {
}
