#include <bits/stdc++.h>

using namespace std;


int n, s, c;

struct rabbit_state {
	bitset<10001> possible_positions;
	int cycle;
};


void make_move(const rabbit_state& prev_state, int pos, rabbit_state& new_state) {
	bitset<10001> pos_mask{};
	for(int i = 0; i < pos; i++) {
		pos_mask[i] = 1;
	}

	if(prev_state.cycle < s) {
		// Scared
		new_state.possible_positions = (prev_state.possible_positions & pos_mask) >> 1;
		if(prev_state.possible_positions[0] && 0 < pos) {
			new_state.possible_positions[0] = 1;
		}
		pos_mask[pos] = 1;
		new_state.possible_positions |= (prev_state.possible_positions & ~pos_mask) << 1;
		if(pos < n - 1 && (prev_state.possible_positions & ~pos_mask)[n - 1]) {
			new_state.possible_positions[n - 1] = 1;
		}
		new_state.possible_positions[n] = 0;
	} else {
		// Curious
		new_state.possible_positions = (prev_state.possible_positions & pos_mask) << 1;
		pos_mask[pos] = 1;
		new_state.possible_positions |= (prev_state.possible_positions & ~pos_mask) >> 1;
	}

	new_state.cycle = (prev_state.cycle + 1) % (s + c);
}


int measure(const rabbit_state& state) {
	int metric = n;
	for(int i = 0; i < n; i++) {
		metric -= state.possible_positions[i];
	}
	return metric;
}


void log(const rabbit_state& state) {
	for(int i = 0; i < n; i++) {
		cerr << state.possible_positions[i] ? '-' : 'x';
	}
	cerr << " | " << state.cycle << " (" << measure(state) << ")" << endl;
}

vector<int> ans;


void go(const rabbit_state& state) {
	// log(state);

	if(state.possible_positions == bitset<10001>{}) {
		return;
	}

	rabbit_state best_next_state;
	int best_measure = -1;
	int best_pos = -1;

	rabbit_state next_state;
	for(int pos = 0; pos < n; pos++) {
		make_move(state, pos, next_state);
		int cur_measure = measure(next_state);
		if(cur_measure > best_measure) {
			best_measure = cur_measure;
			best_next_state = next_state;
			best_pos = pos;
		}
	}

	// cerr << "move " << best_pos << endl;
	ans.push_back(best_pos);

	go(best_next_state);
}



signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> s >> c;

	rabbit_state state{};
	for(int i = 0; i < n; i++) {
		state.possible_positions[i] = 1;
	}
	state.cycle = 0;

	go(state);

	cout << ans.size() << endl;

	for(int i: ans) {
		cout << i + 1 << " ";
	}
	cout << endl;

	return 0;
}
