#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "map"
#include "hint.h"
//#include "Lgrader.cpp"
using namespace std;

#define all(x) (x).begin(), (x).end()
int K = 18;
int HELP = 100;
int readnum(vector<bool> &nums, int ind) {
    ind *= K;
    int res = 0;
    for (int i = 0; i < K; ++i) {
        res += nums[ind + i] * (1 << i);
    }
    return res;
}
void writenum(vector<bool> &nums, int res) {
    for (int i = 0; i < K; ++i) {
        nums.push_back(res % 2);
        res /= 2;
    }
}
vector<int> obsh(vector<int> a, vector<int> b) {
    int n = a.size(), m = b.size();
    vector<vector<short>> dp(n + 2, vector<short>(m + 2));
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            if (i != n and j != m) {
                if (a[i] == b[j]) {
                    dp[i + 1][j + 1] = max(short(dp[i][j] + 1), dp[i + 1][j + 1]);
                }
            }
            dp[i + 1][j] = max(dp[i][j], dp[i + 1][j]);
            dp[i][j + 1] = max(dp[i][j], dp[i][j + 1]);
        }
    }
    vector<int> res;
    while (n != 0 and m != 0) {
        if (dp[n-1][m] == dp[n][m]) {
            n--;
        } else if (dp[n][m-1] == dp[n][m]) {
            m--;
        } else {
            res.push_back(a[n-1]);
            n--;m--;
        }
    }
    reverse(all(res));
    return res;
}
vector<int> getind(vector<int> a, vector<int> sol) {
    vector<int> aind(sol.size());
    int indik = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] == sol[indik]) {
            aind[indik] = i;
            indik++;
            if (indik == sol.size())
                return aind;
        }
    }
    return aind;
}

pair<vector<int>, vector<int>> readpos(vector<bool> hp) {
    vector<int> a(HELP + 1), b(HELP + 1);
    b[0] = 0;
    a[0] = 0;
    for (int i = 1; i < HELP + 1; ++i) {
        a[i] = readnum(hp, 2 * (i - 1));
        b[i] = readnum(hp, 2 * (i - 1) + 1);
    }
    return {a, b};
}
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<int> aind = getind(a, sol);
    vector<int> bind = getind(b, sol);
    vector<int> del(HELP);
    vector<int> ap(HELP + 1), bp(HELP + 1);
    int indik = 0;
    int apos = 0;
    int cnt = (a.size() + b.size() + HELP - 1) / HELP;
    for (int i = 1; i <= HELP; ++i) {
        while (indik != aind.size() and aind[indik] - ap[i-1] + bind[indik] - bp[i - 1] <= cnt)
            indik++;
        indik--;
        ap[i] = aind[indik] + 1;
        bp[i] = bind[indik] + 1;
        int have = max(0, cnt - (aind[indik] - ap[i-1] + bind[indik] - bp[i - 1] + 2));
        if (indik + 1 != aind.size()) {
            int addto;
            if (ap[i] - ap[i - 1] > bp[i] - bp[i - 1]) {
                addto = min(have, aind[indik + 1] - aind[indik] - 1);
                ap[i] += addto;
                have -= addto;
                addto = min(have, bind[indik + 1] - bind[indik] - 1);
                bp[i] += addto;
            } else {
                addto = min(have, bind[indik + 1] - bind[indik] - 1);
                bp[i] += addto;
                have -= addto;
                addto = min(have, aind[indik + 1] - aind[indik] - 1);
                ap[i] += addto;
            }
        }
    }
    vector<bool> hlp;
    for (int i = 0; i < HELP; ++i) {
        writenum(hlp, ap[i + 1]);
        writenum(hlp, bp[i + 1]);
    }
    return hlp;
}
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    //vector<bool> chk;
    //writenum(chk, 1e5);
    //cerr << readnum(chk, 0);
    auto [ap, bp] = readpos(hint);
    vector<int> ans;
    for (int i = 0; i + 1 < ap.size(); ++i) {
        //cerr << ap[i] << ' ' << bp[i] << endl;
        vector<int> tempa;
        vector<int> tempb;
        for (int j = ap[i]; j < ap[i + 1]; ++j) {
            tempa.push_back(a[j]);
        }
        for (int j = bp[i]; j < bp[i + 1]; ++j) {
            tempb.push_back(b[j]);
        }
        for (auto t : obsh(tempa, tempb))
            ans.push_back(t);
    }
    //cerr << ap.back() << ' ' << bp.back() << endl;
    return ans;
}
