#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
struct segtree{
    int sz = 1;
    vector<int> tree;
    segtree(int n) {
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, 0);
    }
    void ch(int v, int x) {
        v += sz;
        if (tree[v] >= x)
            return;
        tree[v] = x;
        while (v != 1) {
            v /= 2;
            tree[v] = max(tree[v * 2 + 1], tree[v * 2]);
        }
    }
    int get(int l, int r) {
        int res = 0;
        l += sz;r += sz;
        while (l <= r) {
            if (l & 1) {
                res = max(res, tree[l++]);
            }
            if ((r & 1) == 0) {
                res = max(res, tree[r--]);
            }
            l /= 2;
            r /= 2;
        }
        return res;
    }
};
int main() {
    ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> crd(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        crd[i] = {x + y, x - y};
    }
    sort(all(crd));
    vector<int> a;
    for (int i = 0; i < n; ++i) {
        a.push_back(crd[i].second);
    }
    sort(all(a));
    a.erase(unique(all(a)), a.end());
    int t = a.size();
    for (int i = 0; i < n; ++i) {
        crd[i].second = lower_bound(all(a), crd[i].second) - a.begin();
    }
    segtree sg(t);
    for (int i = 0; i < n; ++i) {
        sg.ch(crd[i].second, 1 + sg.get(crd[i].second + 1, t - 1));
    }
    cout << sg.get(0, t-1);
}
