#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if(a.size() * b.size() <= 100000000) {
        return vector<bool>();
    }

    int mn = min(a.size(), b.size()), int_sz = 0;
    while((1 << int_sz) < mn) int_sz++;
    vector<bool> ans, found(mn);
    int ptr = 0, cnt = 0;
    for(int i = 0; i < sol.size(); i++) {
        while((a.size() < b.size() ? a : b)[ptr] != sol[i]) ptr++;
        found[ptr++] = 1;
    }

    if(int_sz * sol.size() + 1 < mn) {
        for(int i = 0; i < mn; i++) {
            if(!found[i]) continue;
            for(int j = 0; j < int_sz; j++) {
                ans.push_back((i >> j) & 1);
            }
        }
        ans.push_back(0);
        return ans;
    }

    if(int_sz * (mn - sol.size()) + 1 < mn) {
        for(int i = 0; i < mn; i++) {
            if(found[i]) continue;
            for(int j = 0; j < int_sz; j++) {
                ans.push_back((i >> j) & 1);
            }
        }
        ans.push_back(1);
        return ans;
    }

    return found;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> ans;
    int mn = min(a.size(), b.size()), int_sz = 0;
    while((1 << int_sz) < mn) int_sz++;
    if(hint.size() == 0) {
        vector<vector<int>> dp(a.size(), vector<int>(b.size()));
        vector<vector<int>> rest(a.size(), vector<int>(b.size()));
        for(int i = 0; i < a.size(); i++) {
            for(int j = 0; j < b.size(); j++) {
                if(a[i] == b[j]) {
                    rest[i][j] = 0;
                    dp[i][j] = (i && j ? dp[i - 1][j - 1] : 0) + 1;
                }
                else {
                    if(min(i, j) == 0) {
                        if(i == 0 && j == 0) {
                            dp[i][j] = 0;
                            rest[i][j] = -2;
                        }
                        else if(i == 0) {
                            dp[i][j] = dp[i][j - 1];
                            rest[i][j] = 1;
                        }
                        else {
                            dp[i][j] = dp[i - 1][j];
                            rest[i][j] = -1;
                        }
                        continue;
                    }
                    if(dp[i - 1][j] > dp[i][j - 1]) {
                        dp[i][j] = dp[i - 1][j];
                        rest[i][j] = -1;
                    }
                    else {
                        dp[i][j] = dp[i][j - 1];
                        rest[i][j] = 1;
                    }
                }
            }
        }


        int i = a.size() - 1, j = b.size() - 1;
        while(i >= 0 && j >= 0) {
            if(rest[i][j]) {
                if(rest[i][j] == -2) {
                    break;
                }
                if(rest[i][j] > 0) {
                    j--;
                }
                else {
                    i--;
                }
            }
            else {
                ans.push_back(a[i]);
                i--, j--;
            }
        }
        reverse(ans.begin(), ans.end());
        return ans;
    }

    if(hint.size() < mn) {
        if(ans.back()) {
            vector<bool> bad(mn, 0);
            for(int i = 0; i < hint.size() - 1; i += int_sz) {
                int cur = 0;
                for(int j = 0; j < int_sz; j++) {
                    if(hint[i + j]) {
                        cur |= 1 << j;
                    }
                }
                bad[cur] = 1;
            }

            for(int i = 0; i < mn; i++) {
                if(!bad[i]) ans.push_back((a.size() < b.size() ? a : b)[i]);
            }

            return ans;
        }

        for(int i = 0; i < hint.size() - 1; i += int_sz) {
            int cur = 0;
            for(int j = 0; j < int_sz; j++) {
                if(hint[i + j]) {
                    cur |= 1 << j;
                }
            }
            ans.push_back((a.size() < b.size() ? a : b)[cur]);
        }
        return ans;
    }

    for(int i = 0; i < hint.size(); i++) {
        if(!hint[i]) continue;
        if(a.size() < b.size()) {
            ans.push_back(a[i]);
        }
        else {
            ans.push_back(b[i]);
        }
    }

    return ans;
}
