#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

void write_to(vector<bool> &v, int num) {
    for(int j = 0; j < 7; j++) {
        v.push_back((num >> j) & 1);
    }
}

int get_from(const vector<bool> &v, int pos) {
    int cur = 0;
    for(int j =0 ; j < 7; j++) {
        cur |= int(v[pos + j]) << j;
    }
    return cur;
}

vector<bool> code(const vector<bool> &v) {
    vector<bool> ans;
    for(int i = 0; i < v.size(); ) {
        int j = i;
        while(j < v.size() && v[i] == v[j] && j - i < 127) {
            j++;
        }
        if(i + 1 == j) {
            ans.push_back(0);
            write_to(ans, j - i);
            while(i < j) {
                ans.push_back(v[i]);
                i++;
            }
        }
        else {
            ans.push_back(1);
            write_to(ans, j - i);
            ans.push_back(v[i]);
        }
        i = j;
    }

    return ans;
}

vector<bool> decode(const vector<bool> &v) {
    vector<bool> ans;

    for(int i = 0; i < v.size(); ) {
        i++;
        int cnt = get_from(v, i);
        i += 7;
        if(v[i - 8]) {
            for(int j = 0; j < cnt; j++) ans.push_back(v[i]);
            i++;
        }
        else {
            for(int j = 0; j < cnt; j++) {
                ans.push_back(v[i]);
                i++;
            }
        }
    }

    return ans;
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if(a.size() * b.size() <= 100000000) {
        return vector<bool>();
    }

    int mn = min(a.size(), b.size()), int_sz = 0;
    while((1 << int_sz) < mn) int_sz++;
    vector<bool> ans, found(mn);
    int ptr = 0, cnt = 0;
    for(int i = 0; i < sol.size(); i++) {
        while((a.size() < b.size() ? a : b)[ptr] != sol[i]) ptr++;
        found[ptr++] = 1;
    }

    return code(found);
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> ans;
    int mn = min(a.size(), b.size());
    vector<bool> decoded = decode(hint);

    for(int i = 0; i < decoded.size(); i++) {
        if(!decoded[i]) continue;
        if(a.size() < b.size()) {
            ans.push_back(a[i]);
        }
        else {
            ans.push_back(b[i]);
        }
    }

    return ans;
}
