#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

void write_to(vector<bool> &v, int num) {
    for(int j = 0; j < 7; j++) {
        v.push_back((num >> j) & 1);
    }
}

int get_from(const vector<bool> &v, int pos) {
    int cur = 0;
    for(int j =0 ; j < 7; j++) {
        cur |= int(v[pos + j]) << j;
    }
    return cur;
}

vector<bool> code(const vector<bool> &v) {
    vector<bool> ans;
    for(int i = 0; i < v.size(); ) {
        int j = i;
        while(j < v.size() && v[i] == v[j] && j - i < 127) {
            j++;
        }
        if(i + 1 == j) {
            ans.push_back(0);
            write_to(ans, j - i);
            while(i < j) {
                ans.push_back(v[i]);
                i++;
            }
        }
        else {
            ans.push_back(1);
            write_to(ans, j - i);
            ans.push_back(v[i]);
        }
        i = j;
    }

    return ans;
}

vector<bool> decode(const vector<bool> &v) {
    vector<bool> ans;

    for(int i = 0; i < v.size(); ) {
        i++;
        int cnt = get_from(v, i);
        i += 7;
        if(v[i - 8]) {
            for(int j = 0; j < cnt; j++) ans.push_back(v[i]);
            i++;
        }
        else {
            for(int j = 0; j < cnt; j++) {
                ans.push_back(v[i]);
                i++;
            }
        }
    }

    return ans;
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if(a.size() * b.size() <= 100000000) {
        return vector<bool>();
    }

    int mn = min(a.size(), b.size()), int_sz = 0;
    while((1 << int_sz) < mn) int_sz++;
    vector<bool> ans, found(mn);
    int ptr = 0, cnt = 0;
    for(int i = 0; i < sol.size(); i++) {
        while((a.size() < b.size() ? a : b)[ptr] != sol[i]) ptr++;
        found[ptr++] = 1;
    }

    vector<bool> coded = code(found);

    if(coded.size() < mn) {
        return coded;
    }

    return found;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> ans;
    int mn = min(a.size(), b.size());

    if(hint.size() == 0) {
        vector<vector<int>> dp(a.size(), vector<int>(b.size()));
        vector<vector<int>> rest(a.size(), vector<int>(b.size()));
        for(int i = 0; i < a.size(); i++) {
            for(int j = 0; j < b.size(); j++) {
                if(a[i] == b[j]) {
                    rest[i][j] = 0;
                    dp[i][j] = (i && j ? dp[i - 1][j - 1] : 0) + 1;
                }
                else {
                    if(min(i, j) == 0) {
                        if(i == 0 && j == 0) {
                            dp[i][j] = 0;
                            rest[i][j] = -2;
                        }
                        else if(i == 0) {
                            dp[i][j] = dp[i][j - 1];
                            rest[i][j] = 1;
                        }
                        else {
                            dp[i][j] = dp[i - 1][j];
                            rest[i][j] = -1;
                        }
                        continue;
                    }
                    if(dp[i - 1][j] > dp[i][j - 1]) {
                        dp[i][j] = dp[i - 1][j];
                        rest[i][j] = -1;
                    }
                    else {
                        dp[i][j] = dp[i][j - 1];
                        rest[i][j] = 1;
                    }
                }
            }
        }


        int i = a.size() - 1, j = b.size() - 1;
        while(i >= 0 && j >= 0) {
            if(rest[i][j]) {
                if(rest[i][j] == -2) {
                    break;
                }
                if(rest[i][j] > 0) {
                    j--;
                }
                else {
                    i--;
                }
            }
            else {
                ans.push_back(a[i]);
                i--, j--;
            }
        }
        reverse(ans.begin(), ans.end());
        return ans;
    }

    vector<bool> decoded = hint.size() < mn ? decode(hint) : hint;

    for(int i = 0; i < decoded.size(); i++) {
        if(!decoded[i]) continue;
        if(a.size() < b.size()) {
            ans.push_back(a[i]);
        }
        else {
            ans.push_back(b[i]);
        }
    }

    return ans;
}
