#include <bits/stdc++.h>

using namespace std;

struct edge;

typedef pair<int, int> pii;

const int SIZE = 2e6 + 5;

int n, t[SIZE], h[SIZE];
pii th[SIZE];
unordered_map<int, int> g[SIZE], ts;
bool used[SIZE];

void add_edge(int u, int v) {
    g[u][v] = 1;
    g[v][u] = 0;
}

int main() {
    ifstream cin("input.txt");

    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> t[i] >> h[i];
    }

    for(int i = 0; i < n; i++) {
        th[i] = {t[i], h[i]};
    }

    sort(th, th + n);

    for(int i = 0; i < n; i++) {
        add_edge(0, i + 1);
        add_edge(i + 1 + n, 2 * n + 1);
        for(int j = i + 1; j < n; j++) {
            if(th[j].first - th[i].first >= abs(th[i].second - th[j].second)) {
                add_edge(i + 1, j + 1 + n);
            }
        }
    }


    int mflow = 0;

    for(;;) {
        queue<int> bfs;
        vector<int> rest(2 * n + 2);
        vector<bool> used(2 * n + 2, false);
        bfs.push(0);
        used[0] = 1;

        while(!bfs.empty()) {
            int u = bfs.front();
            bfs.pop();
            for(auto [v, w] : g[u]) {
                if(w > 0 && !used[v]) {
                    bfs.push(v);
                    used[v] = 1;
                    rest[v] = u;
                }
            }
        }

        if(!used.back()) break;

        int u = used.size() - 1;

        while(u > 0) {
            g[rest[u]][u]--;
            g[u][rest[u]]++;
            u = rest[u];
        }
        mflow++;
    }

    cout << n - mflow;

    return 0;
}
