
#include "hint.h"


#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


int mk;


void get_mk(int n, int m) {
    mk = (2.5e8 / m);
}


vector<vector<int>> dp;


inline void mxmz(int& a, int b) {
    if (a < b) {
        a = b;
    }
}


void get_mx_cmn(const vector<int> &a, const vector<int> &b, int l1, int r1, int l2, int r2, vector<int> &res) {
    int n = r1 - l1;
    int m = r2 - l2;
    if (n == 0 || m == 0) {
        return;
    }
    if (r1 > a.size() || r2 > b.size()) {
        return;
    }
    dp.assign(n + 1, vector<int>(m + 1, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i + l1] == b[j + l2]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            }
            mxmz(dp[i + 1][j + 1], dp[i][j + 1]);
            mxmz(dp[i + 1][j + 1], dp[i + 1][j]);
        }
    }
    int i = n - 1;
    int j = m - 1;
    int lstsz = res.size();
    while (dp[i + 1][j + 1] != 0) {
        if (a[i + l1] == b[j + l2] && dp[i + 1][j + 1] == dp[i][j] + 1) {
            res.push_back(a[i + l1]);
            i -= 1;
            j -= 1;
        } else if (dp[i + 1][j + 1] == dp[i + 1][j]) {
            j -= 1;
        } else {
            i -= 1;
        }
    }
    reverse(res.begin() + lstsz, res.end());
}


void get_mx_cmn1(const vector<int>& a, const vector<int>& b, int l1, int r1, int l2, int r2, vector<int>& res) {
    int n = r1 - l1;
    int m = r2 - l2;
    if (n == 0 || m == 0) {
        return;
    }
    dp.resize(n + 1);
    for (int i = 0; i <= n; ++i) {
        dp[i].resize(m + 1);
        for (int j = 0; j <= m; ++j) {
            dp[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i + l1] == b[j + l2]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            }
            mxmz(dp[i + 1][j + 1], dp[i][j + 1]);
            mxmz(dp[i + 1][j + 1], dp[i + 1][j]);
        }
    }
    int i = n - 1;
    int j = m - 1;
    int lstsz = res.size();
    while (i >= 0 && j >= 0 && dp[i + 1][j + 1] != 0) {
        if (a[i + l1] == b[j + l2] && dp[i + 1][j + 1] == dp[i][j] + 1) {
            res.push_back(a[i + l1]);
            i -= 1;
            j -= 1;
        } else if (dp[i + 1][j + 1] == dp[i + 1][j]) {
            j -= 1;
        } else {
            i -= 1;
        }
    }
    if(res.size() != lstsz){
        reverse(res.begin() + lstsz, res.end());
    }
}


void add(vector<bool>& d, int x, int logn) {
    for (int i = 0; i < logn; ++i) {
        d.push_back((bool)((x >> i) & 1));
    }
}


int get(const vector<bool>& d, ll s, int logn) {
    ll res = 0;
    ll f = s;
    for (int i = 0; i < logn; ++i) {
        if(d[f + i]){
            res += ((ll)(1) << i);
        }
    }
    return res;
}


int get_nxt(const vector<int>& a, int bg, int x) {
    for (int i = bg; i < a.size(); ++i) {
        if (a[i] == x) {
            return i;
        }
    }
    return 1e9;
}


bool operator<(const vector<int>& a, const vector<int>& b) {
    if (a.size() != b.size()) {
        return a.size() < b.size();
    }
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] != b[i]) {
            return a[i] < b[i];
        }
    }
    return false;
}


const int logn = 15;
const int bglogn = 18;

void code(vector<int>& a, vector<bool>& res) {
    int n = a.size();
    if (n == 0) {
        return;
    }
    vector<int> b(n);
    b[0] = a[0];
    for (int i = 1; i < n; ++i) {
        b[i] = a[i] - a[i - 1];
    }
    vector<int> x;
    for (int i = 0; i < a.size(); ++i) {
        if(b[i] < (1 << logn) - 1){
            add(res, b[i], logn);
        } else {
            add(res, (1 << logn) - 1, logn);
            x.push_back(b[i]);
        }
    }
    for (auto f : x) {
        add(res, f, bglogn);
    }
}


void decode(vector<int> &a, const vector<bool>& x, int n) {
    if (n == 0) {
        return;
    }
    a.resize(n);
    vector<int> b(n);
    vector<int> o;
    for (int i = 0; i < n; ++i) {
        int d = get(x, i * logn, logn);
        if (d == (1 << logn) - 1) {
            o.push_back(i);
        } else {
            b[i] = d;
        }
    }
    for (int j = 0; j < o.size(); ++j) {
        int i = o[j];
        b[i] = get(x, n * logn + j * bglogn, bglogn);
    }
    a[0] = b[0];
    for (int i = 1; i < n; ++i) {
        a[i] = a[i - 1] + b[i];
    }
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> res;
    res.clear();
    int n = a.size();
    int m = b.size();
    get_mk(n, m);
    vector<int> ind(n);
    int i = 0;
    int j = 0;
    for (auto x : sol) {
        int ni = get_nxt(a, i, x);
        int nj = get_nxt(b, j, x);
        for (; i < ni; ++i) {
            ind[i] = j;
        }
        j = nj + 1;
        ind[i] = j;
        i += 1;
    }
    for (; i < n; ++i) {
        ind[i] = j;
    }
    vector<int> f;
    f.reserve(n / mk);
    for (int i = mk - 1; i < n; i += mk) {
        f.push_back(ind[i]);
    }
    code(f, res);
    return res;
}



vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector<int> res;
    int n = a.size();
    int m = b.size();
    get_mk(n, m);
    int prvs = 0;
    int i = 0;
    vector<int> f;
    decode(f, hint, n / mk);
    for (int s = 0; s < n; s += mk) {
        int l1 = s;
        int r1 = s + mk;
        int l2 = prvs;
        int r2;
        if (r1 < n) {
            r2 = f[i];
        } else {
            r1 = n;
            r2 = m;
        }
        get_mx_cmn1(a, b, l1, r1, l2, r2, res);
        prvs = r2;
        i += 1;
    }
    return res;
}


/*
18 18
1 4 6 7 5 8 2 3 4 5 7 2 8 3 4 6 5 3
4 0 5 7 6 2 8 5 3 4 7 1 9 2 3 4 8 1
*/