#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>
#include <bitset>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


mt19937 rnd(1312341);

const int iters = 100;

int n, s, c;
const int mxn = 1e4;


bitset<mxn + 1> a;
bitset<mxn + 1> b;


int get_bst1(int &v) {
    int mxx = -1;
    for (int t = 0; t < iters; ++t) {
        int i = rnd() % n;
        int x = a[i];
        if (i < n - 2) {
            x += (a[n - 2] && a[n - 1]);
        }
        if (i > 1) {
            x += (a[0] && a[1]);
        }
        if (x > mxx) {
            mxx = x;
            v = i;
        }
    }
    return mxx;
}



int get_bst2(int &v) {
    int mxx = -1;
    for (int t = 0; t < iters; ++t) {
        int i = rnd() % n;
        int x = a[i];
        if (i + 1 < n && i - 1 >= 0) {
            x += (a[i - 1] && a[i + 1]);
        }
        if (x > mxx) {
            mxx = x;
            v = i;
        }
    }
    return mxx;
}


void apply1(int i) {
    a[i] = 0;
    a = (((a >> i)) << (i + 1)) | (((a << (n - i - 1)) & b) >> (n - i));
    a[n] = 0;
}


void apply2(int i) {
    a[i] = 0;
    a = (((a >> (i + 1))) << i) | (((a << (n - i)) & b) >> (n - i - 1));
}


void solve(vector<int> &res) {
    res.clear();
    int f = n;
    for (int i = 0; i < n; ++i) {
        a[i] = 1;
        b[i] = 1;
    }
    vector<int> mx;
    for(int i = 0; f > 0; ++i) {
        int x = i % (s + c);
        if (x < s) {
            int v;
            int k = get_bst1(v);
            apply1(v);
            res.push_back(v);
            f -= k;
        } else {
            int v;
            int k = get_bst2(v);
            apply2(v);
            res.push_back(v);
            f -= k;
        }
        // assert(a.count() == f);
    }
}


int32_t main() {
    cin >> n >> s >> c;
    vector<int> res;
    if (s == 0) {
        for (int i = 0; i < (n + 2) / 2; ++i) {
            res.push_back(n / 2);
        }
    } 
    else{
        solve(res);
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); ++i) {
        cout << res[i] + 1 << " ";
    }
    cout << "\n";
    return 0;
}