#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>
#include <bitset>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


mt19937 rnd(1312341);

const int iters = 100;

int n, s, c;
const int mxn = 1e4;


vector<int> a;


void apply1(int i) {
    a[i] = 0;
    for (int j = 1; j < i; ++j) {
        if (a[j]) {
            a[j - 1] = 1;
        }
        a[j] = 0;
    }
    for (int j = n - 2; j > i; --j) {
        if (a[j]) {
            a[j + 1] = 1;
        }
        a[j] = 0;
    }
}


void apply2(int i) {
    a[i] = 0;
    for (int j = i - 1; j >= 0; --j) {
        if (a[j]) {
            a[j + 1] = 1;
        }
        a[j] = 0;
    }
    for (int j = i + 1; j < n; ++j) {
        if (a[j]) {
            a[j - 1] = 1;
        }
        a[j] = 0;
    }
}


void go_down(int &l, int &r) {
    if (l > r) {
        return;
    }
    if (l == 0) {
        if (r > 0) {
            r -= 1;
        }
    } else {
        l -= 1;
        r -= 1;
    }
}


void go_up(int& l, int& r) {
    if (l > r) {
        return;
    }
    if (r == n - 1) {
        if (l < n - 1) {
            l += 1;
        }
    } else {
        l += 1;
        r += 1;
    }
}



void go_to(int &l, int &r, int x) {
    if (l > r) {
        return;
    }
    if (l == r && x == l) {
        r -= 1;
        l += 2;
    } else if (l < x && x < r) {
        l += 1;
        r -= 1;
    } else if (l == x) {
        r -= 1;
    } else if (r == x) {
        l += 1;
    }
}

void solve(vector<int> &res) {
    a.assign(n, 1);
    int l1 = 0;
    int r1 = (n - 1) / 2;
    int l2 = r1 + 1;
    int r2 = n - 1;
    for (int i = 0; l1 <= r1 || l2 <= r2; ++i) {
        int x = i % (s + c);
        int ln1 = r1 - l1 + 1;
        int ln2 = r2 - l2 + 1;
        if (x < s) {
            if (ln1 > ln2) {
                res.push_back(r1);
                r1 -= 1;
                go_down(l1, r1);
                go_up(l2, r2);
            } else {
                res.push_back(l2);
                l2 += 1;
                go_down(l1, r1);
                go_up(l2, r2);
            }
            //apply1(res.back());
        } else {
            if (ln1 > ln2) {
                int v = (l1 + r1) / 2;
                res.push_back(v);
                go_to(l1, r1, v);
                l2 -= 1;
                r2 -= 1;
            } else {
                int v = (l2 + r2) / 2;
                res.push_back(v);
                go_to(l2, r2, v);
                l1 += 1;
                r1 += 1;
            }
            //apply2(res.back());
        }
    }
}


int32_t main() {
    cin >> n >> s >> c;
    vector<int> res;
    if (s == 0) {
        for (int i = 0; i < (n + 2) / 2; ++i) {
            res.push_back(n / 2);
        }
    } 
    else{
        solve(res);
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] != 0) {
            //assert(0);
        }
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); ++i) {
        cout << res[i] + 1 << " ";
    }
    cout << "\n";
    return 0;
}

/*
6 1 1
*/