#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

const int bucket = 640;

vector <bool> genHint (const vector <int> &a, const vector <int> &b, const vector <int> &sol){
    
    // vector <bool> hint;
    // int i_sol = 0, sz_sol = sol.size ();
    // for (int i : a){
    //     if (i_sol < sz_sol && i == sol [i_sol]){
    //         hint.push_back (1);
    //         i_sol ++;
    //     }
    //     else hint.push_back (0);
    // }
    // return hint;

    vector <bool> hint;
    int na = a.size (), nb = b.size (), ns = sol.size ();
    int ia = 0, ib = 0;
    vector <pair <int, int> > pairs;
    for (int is = 0; is < ns; is ++){
        while (a [ia] != sol [is]) ia ++;
        while (b [ib] != sol [is]) ib ++;
        pairs.push_back ({ia, ib});
        ia ++;
        ib ++;
    }
    int ip = 0;
    for (int i = 0; i <= (na - 1) / bucket; i ++){
        while (ip < ns && pairs [ip].first < (i + 1) * bucket) ip ++;
        int x = (ip == ns ? nb : pairs [ip].second);
        for (int k = 17; k >= 0; k --){
            hint.push_back (x & (1 << k));
        }
    }
    return hint;

}

const int maxn = 2e5+5;
short dp [bucket+5][maxn];
char par [bucket+5][maxn];

vector <int> solve (const vector <int> &a, const vector <int> &b, const vector <bool> &hint){

    int sz_hint = hint.size ();
    vector <int> hint1;
    for (int i = 0; i < sz_hint; i += 18){
        int x = 0;
        for (int j = 0; j < 18; j ++){
            x = x * 2 + hint [i + j];
        }
        hint1.push_back (x);
    }

    vector <int> sol;
    int na = a.size (), nb = b.size ();

    for (int start_i = 0; start_i < na; start_i += bucket){

        int start_j = (start_i == 0 ? 0 : hint1 [start_i / bucket - 1]);
        int end_j = hint1 [start_i / bucket];

        if (a [start_i] == b [start_j]) dp [0][start_j] = 1, par [0][start_j] = '0';
        else dp [0][start_j] = 0, par [0][start_j] = '0';

        for (int j = start_j + 1; j < end_j; j ++){
            if (a [start_i] == b [j]) dp [0][j] = 1, par [0][j] = '0';
            else dp [0][j] = dp [0][j - 1], par [0][j] = '2';
        }
        for (int i = start_i + 1; i < min (na, start_i + bucket); i ++){
            if (a [i] == b [start_j]) dp [i - start_i][start_j] = 1, par [i - start_i][start_j] = '0';
            else dp [i - start_i][start_j] = dp [i - start_i - 1][start_j], par [i - start_i][start_j] = '1';
            for (int j = start_j + 1; j < end_j; j ++){
                if (a [i] == b [j]) dp [i - start_i][j] = dp [i - start_i - 1][j - 1] + 1, par [i - start_i][j] = '0';
                else{
                    if (dp [i - start_i - 1][j] > dp [i - start_i][j - 1]) dp [i - start_i][j] = dp [i - start_i - 1][j], par [i - start_i][j] = '1';
                    else dp [i - start_i][j] = dp [i - start_i][j - 1], par [i - start_i][j] = '2';
                }
            }
        }
        vector <int> curr_sol;
        int i = min (na, start_i + bucket) - 1, j = end_j - 1;
        while (i >= start_i && j >= start_j){
            if (a [i] == b [j]) curr_sol.push_back (a [i]);
            if (par [i - start_i][j] == '0') i --, j --;
            else if (par [i - start_i][j] == '1') i --;
            else j --;
        }
        reverse (curr_sol.begin (), curr_sol.end ());
        for (int s : curr_sol) sol.push_back (s);
    }

    return sol;

    // int sza = a.size ();
    // vector <int> sol;
    // for (int i = 0; i < sza; i ++){
    //     if (hint [i]) sol.push_back (a [i]);
    // }
    // return sol;

}