#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 2e5 + 10;
const int SMALL_N = 1e4 + 10;
const int LOG = 16;
const int BIG = 1e7;

void decompose(int x, vector<bool> &ret) {
    for(int i = 0; i < LOG; i ++) {
        ret.push_back(x % 2);
        x /= 2;
    }
}

int get(vector<bool> &ret) {
    int ans = 0;
    for(int i = 0; i < LOG; i ++) {
        if(ret.back()) {
            ans += 1 << i;
        }
        ret.pop_back();
    }
    return ans;
}

bool used[MAX_N];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<bool> ret = {};
    ll lasta = 0, lastb = 0;
    int prva = 0, prvb = 0;
    int nowa = 0,  nowb = 0;
    for(int i = 0; i < sol.size(); i ++) {
        while(a[nowa] != sol[i]) {nowa ++;}
        while(b[nowb] != sol[i]) {nowb ++;}
        if((nowa - lasta) * (nowb - lastb) >= BIG) {
            if(prva == lasta) {
                ret.push_back(0);
                decompose(prva, ret);
                decompose(prvb, ret);
                lasta = prva;
                lastb = prva;
            } else {
                ret.push_back(1);
                decompose(prva, ret);
                decompose(prvb, ret);
                lasta = prva;
                lastb = prva;
            }
        } 
        if(i == sol.size() - 1) {
            ret.push_back(prva != lasta);
            decompose(nowa, ret);
            decompose(nowb, ret);
            lasta = nowa;
            lastb = nowb;
        }
        prva = nowa; prvb = nowb;
        nowa ++; nowb ++;
    }
    return ret;
}

vector<int> dp[MAX_N];
vector<int> hist[MAX_N];

void lcs(const vector<int>& a, const vector<int>& b, vector<int> &ret) {
    for(int i = 0; i <= a.size(); i ++) {
        dp[i] = vector<int>(b.size() + 1, -mod);
        hist[i] = vector<int>(b.size() + 1, -mod);
    }
    dp[0][0] = 0;
    for(int i = 0; i <= a.size(); i ++) {
        for(int j = 0; j <= b.size(); j ++) {
            cerr << i << " " << j << " " << dp[i][j] << endl;
            if(i < a.size()) {
                if(chkmax(dp[i + 1][j], dp[i][j])) {
                    hist[i + 1][j] = 1;                    
                }
            }
            if(j < b.size()) {
                if(chkmax(dp[i][j + 1], dp[i][j])) {
                    hist[i][j + 1] = 2;                    
                }
            }
            if(i < a.size() && j < b.size() && a[i] == b[j]) {
                if(chkmax(dp[i + 1][j + 1], dp[i][j] + 1)) {
                    hist[i + 1][j + 1] = 3;
                }
            }
        }
    }
    int posi = a.size(), posj = b.size();
    vector<int> toPush = {};
    while(true) {
        if(hist[posi][posj] == -mod) {
            break;
        }
        if(hist[posi][posj] == 1) {posi --;}
        if(hist[posi][posj] == 2) {posj --;}
        if(hist[posi][posj] == 3) {posi --; posj --; toPush.push_back(a[posi]); cerr << "here" << a[posi] << endl;}
    }
    reverse(toPush.begin(), toPush.end());
    for(auto it : toPush) {
        ret.push_back(it);
    }
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint1) {
    vector<int> ans = {};
    vector<bool> hint = hint1;
    reverse(hint.begin(), hint.end());
    int lasta = 0, lastb = 0;
    while(!hint.empty()) {
        bool on = hint.back(); hint.pop_back();
        vector<int> helpa = {}, helpb = {};
        int x = get(hint), y = get(hint);
        if(on) {
            for(; lasta < x; lasta ++) { helpa.push_back(a[lasta]); }
            for(; lastb < y; lastb ++) { helpb.push_back(b[lastb]); }
            lcs(helpa, helpb, ans);
        }
        lasta = x + 1;
        lastb = y + 1;
        ans.push_back(a[x]);        
    }
    return ans;
}
