#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 2e5 + 10;
const int LOG = 16;
const int BIG = 1;
const int BUCKET_CNT = 100;
const int BUCKET_SIZE = 2 * MAX_N / BUCKET_CNT;

void decompose(int x, vector<bool> &ret) {
    for(int i = 0; i < LOG; i ++) {
        ret.push_back(x % 2);
        x /= 2;
    }
}

int get(vector<bool> &ret) {
    int ans = 0;
    for(int i = 0; i < LOG; i ++) {
        if(ret.back()) {
            ans += 1 << i;
        }
        ret.pop_back();
    }
    return ans;
}

int bucket[MAX_N];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<bool> ret = {};
    int nowa = 0,  nowb = 0;
    int cnt = 0;
    for(int i = 0; i < sol.size(); i ++) {
        while(a[nowa] != sol[i]) {nowa ++;}
        while(b[nowb] != sol[i]) {nowb ++;}
        bucket[nowa / BUCKET_SIZE] ++;
    }
    for(int i = 0; i <= a.size() / BUCKET_SIZE; i ++) {
        decompose(bucket[i], ret);
    }
    return ret;
}

int dp[BUCKET_SIZE + 1][BUCKET_SIZE + 1];
int hist[BUCKET_SIZE + 1][BUCKET_SIZE + 1];
vector<int> occ[MAX_N];

int lcs(const vector<int>& a, const vector<int>& b, vector<int> &ret, int start, int fin, int cnt, int from) {
    for(int i = 0; i <= fin - start; i ++) {
        for(int j = 0; j <= cnt; j ++) {
            dp[i][j] = hist[i][j] = mod;
        }
    }
    dp[0][0] = from;
    for(int i = 1; i <= fin - start; i ++) {
        for(int j = 0; j <= cnt; j ++) {
            if(chkmin(dp[i][j], dp[i - 1][j])) {
                hist[i][j] = 1;
            }
            if(j != 0) {
                int who = dp[i - 1][j - 1];
                int where = lower_bound(occ[a[i + start - 1]].begin(), occ[a[i + start - 1]].end(), who + 1) - occ[a[i + start - 1]].begin();
                if(chkmin(dp[i][j], occ[a[i + start - 1]][where])) {
                    hist[i][j] = 2;
                }
            }
        }
    }
    vector<int> toPush;
    int posi = fin - start, posj = cnt;
    while(true) {
        if(hist[posi][posj] == mod) {
            break;
        }
        if(hist[posi][posj] == 2) {
            toPush.push_back(a[start + posi - 1]);
            posi --;
            posj --;
        }
        if(hist[posi][posj] == 1) {
            posi --;
        }
    }
    reverse(toPush.begin(), toPush.end());
    for(auto it : toPush) { 
        ret.push_back(it);
    }
    return dp[fin - start][cnt];
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint1) {
    vector<int> ans = {};
    vector<bool> hint = hint1;
    reverse(hint.begin(), hint.end());
    for(int i = 0; i < b.size(); i ++) {
        occ[b[i]].push_back(i);
    }
    for(int i = 0; i < MAX_N; i ++) {
        occ[i].push_back(mod + 2);
    }
    int now = -1;
    for(int i = 0; i <= a.size() / BUCKET_SIZE; i ++) {
        int cnt = get(hint);
        if(!cnt) {continue;}
        now = lcs(a, b, ans, i * BUCKET_SIZE, min((i + 1) * BUCKET_SIZE, (int)a.size()), cnt, now);
    }
    return ans;
}
