#include "hint.h"
void dec_to_bin(std::vector<bool> &end,int num,int size)
{
	if(size==0)return;
	dec_to_bin(end,num/2,size-1);
	end.push_back(num%2);
}
int bin_to_dec(const std::vector<bool> &end,int s,int e)
{
	if(end.size()<e)
		return -1;
	int res=0;
	for(int i=s;i<e;i++)
		res=2*res+end[i];
	return res;
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	const std::vector<int> *smaller;

	if(a.size()<=b.size())smaller=&a;
	else smaller=&b;
	std::vector<bool> hint;
	std::vector<bool> help;
	int t=0;
	for(int i=0;i<smaller->size();i++)
		if(sol[t]==smaller->at(i))
		{
			help.push_back(true);
			t++;
			if(t==sol.size())break;
		}
		else help.push_back(false);

	hint.push_back(help[0]);
	int n=1;

	for(int i=1;i<help.size();i++)
	{
		if(help[i]==help[i-1])n++;
		else
		{
			dec_to_bin(hint,n,17);
			n=1;
		}
	}
	dec_to_bin(hint,n,17);

	return hint;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	const std::vector<int> *smaller;

	if(a.size()<=b.size())smaller=&a;
	else smaller=&b;

	std::vector<int> sol;
	std::vector<bool> help;

	int num;
	bool res=hint[0];

	int n=1;
	while((num=bin_to_dec(hint,n,n+17))!=-1)
	{
		for(int i=0;i<num;i++)
			help.push_back(res);
		res=!res;
		n+=17;
	}

	for(int i=0;i<help.size();i++)
		if(help[i])
			sol.push_back(smaller->at(i));
	return sol;
}
/*
3 4
1 2 3
1 2 3 4
3
1 2 3
*/