#include<iostream>
#include<vector>
#include<algorithm>
#include<stack>
#include "hint.h"
using namespace std;

const int INTERVAL=1e3, BINS=12;

struct interval
{
    int l, r, cnt;
};

int dp[INTERVAL][INTERVAL];

vector<bool> IntToBin(int x)
{
    vector<bool> res;
    for(int i=0; i<BINS; i++)
    {
        res.push_back(x%2!=0);
        x/=2;
    }
    reverse(res.begin(), res.end());

    return res;
}

int BinToInt(vector<bool> v, int l, int r)
{
    int x=0, p=1;
    for(int i=r; i>=l; i--)
    {
        if(v[i])
        {
            x+=p;
        }

        p*=2;
    }

    return x;
}

pair<int, int> GetRes(int l1, int r1, int cnt1, int l2, int r2, int cnt2, const vector<int>& a, const vector<int>& b, vector<int>& res)
{
    pair<int, int> ans;
    for(int i=l1; i<=r1; i++)
    {
        for(int j=l2; j<=r2; j++)
        {
            if(a[i]==b[j])
            {
                dp[i-l1][j-l2]=1;
                if(i-l1>0 && j-l2>0)
                {
                    dp[i-l1][j-l2]+=dp[i-l1-1][j-l2-1];
                }

                if(dp[i-l1][j-l2]==min(cnt1, cnt2))
                {
                    ans={i, j};
                    i=r1;
                    break;
                }
            }
            else
            {
                if(i-l1>0 && j-l2>0)
                {
                    dp[i-l1][j-l2]=max(dp[i-l1][j-l2-1], dp[i-l1][j-l2-1]);
                }
                else if(i-l1>0)
                {
                    dp[i-l1][j-l2]=dp[i-l1-1][j-l2];
                }
                else if(j-l2>0)
                {
                    dp[i-l1][j-l2]=dp[i-l1][j-l2-1];
                }
                else
                {
                    dp[i-l1][j-l2]=0;
                }
            }
        }
    }

    stack<int> temp;
    int i=ans.first, j=ans.second;
    while(cnt1>0 && cnt2>0)
    {
        if(a[i]==b[j])
        {
            temp.push(a[i]);
            cnt1--, cnt2--, i--, j--;
        }
        else if(i-l1>0 && j-l2>0)
        {
            if(dp[i-l1-1][j-l2]>dp[i-l1][j-l2-1])
            {
                i--;
            }
            else
            {
                j--;
            }
        }
        else if(i-l1>0)
        {
            i--;
        }
        else
        {
            j--;
        }
    }

    while(!temp.empty())
    {
        res.push_back(temp.top());
        temp.pop();
    }

    return ans;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> res;

    int idx=0;
    for(int i=0; i<a.size(); i+=INTERVAL)
    {
        int cnt=0;
        for(int j=i; j<a.size() && j<i+INTERVAL && idx<sol.size(); j++)
        {
            if(a[j]==sol[idx])
            {
                cnt++;
                idx++;
            }
        }

        vector<bool> temp=IntToBin(cnt);
        for(bool b:temp)
        {
            res.push_back(b);
        }
    }

    idx=0;
    for(int i=0; i<b.size(); i+=INTERVAL)
    {
        int cnt=0;
        for(int j=i; j<b.size() && j<i+INTERVAL && idx<sol.size(); j++)
        {
            if(b[j]==sol[idx])
            {
                cnt++;
                idx++;
            }
        }

        vector<bool> temp=IntToBin(cnt);
        for(bool b:temp)
        {
            res.push_back(b);
        }
    }

    return res;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    vector<int> res;

    vector<interval> va, vb;

    int idx=0;
    for(int i=0; i<a.size(); i+=INTERVAL)
    {
        va.push_back({i, min(i+INTERVAL-1, (int)(a.size()-1)), BinToInt(hint, idx, idx+BINS-1)});
        idx+=BINS;
    }

    for(int i=0; i<b.size(); i+=INTERVAL)
    {
        vb.push_back({i, min(i+INTERVAL-1, (int)(b.size()-1)), BinToInt(hint, idx, idx+BINS-1)});
        idx+=BINS;
    }

    int i=0, j=0;
    while(i<va.size() && j<vb.size())
    {
        pair<int, int> p=GetRes(va[i].l, va[i].r, va[i].cnt, vb[j].l, vb[j].r, vb[j].cnt, a, b, res);

        if(va[i].cnt==vb[j].cnt)
        {
            i++, j++;
        }
        else if(va[i].cnt<vb[j].cnt)
        {
            vb[j].l=p.second+1;
            vb[j].cnt-=va[i].cnt;

            i++;
        }
        else
        {
            va[i].l=p.first+1;
            va[i].cnt-=vb[j].cnt;

            j++;
        }
    }

    return res;
}
/*
5 6
1 2 9 3 3
1 9 9 7 8 3
3
1 9 3
*/

