#include<iostream>
#include<vector>
#include<stack>
#include<tuple>
#include "hint.h"
using namespace std;

const int MAXN=1e4, INTERVAL=3500, MAXS=12;

int dp[MAXN+1][MAXN+1];

vector<int> GetSegment(int l, int r, vector<int> v)
{
    vector<int> res;

    for(int i=l; i<=r; i++)
    {
        res.push_back(v[i]);
    }

    return res;
}

stack<bool> IntToBin(int x)
{
    stack<bool> res;

    for(int i=0; i<MAXS; i++)
    {
        res.push(x%2!=0);
        x/=2;
    }

    return res;
}

int BinToInt(vector<bool> v)
{
    int res=0, p=1;
    while(!v.empty())
    {
        if(v.back())
        {
            res+=p;
        }

        p*=2;
        v.pop_back();
    }

    return res;
}

pair<stack<int>, int> GetLCS(vector<int> a, vector<int> b, int cnt)
{
    stack<int> res;

    int n=a.size(), m=b.size();
    for(int i=0; i<=n; i++)
    {
        for(int j=0; j<=m; j++)
        {
            if(i==0 || j==0)
            {
                dp[i][j]=0;
            }
            else if(a[i-1]==b[j-1])
            {
                dp[i][j]=dp[i-1][j-1]+1;
            }
            else
            {
                dp[i][j]=max(dp[i-1][j], dp[i][j-1]);
            }

            if(dp[i][j]==cnt)
            {
                n=i, m=j;

                break;
            }
        }
    }

    int i=n, j=m;
    while(i>0 && j>0)
    {
        if(a[i-1]==b[j-1])
        {
            res.push(a[i-1]);
            i--, j--;
        }
        else if(dp[i-1][j]>dp[i][j-1])
        {
            i--;
        }
        else
        {
            j--;
        }
    }

    return {res, n};
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> res;

    int n=a.size(), m=b.size(), k=sol.size();

    int idx=0;
    for(int i=0; i<n; i+=INTERVAL)
    {
        int cnt=0;
        for(int j=i; j<min(n, i+INTERVAL) && idx<k; j++)
        {
            if(a[j]==sol[idx])
            {
                cnt++;
                idx++;
            }
        }

        stack<bool> temp=IntToBin(cnt);
        while(!temp.empty())
        {
            res.push_back(temp.top());
            temp.pop();
        }
    }

    idx=0;
    for(int i=0; i<m; i+=INTERVAL)
    {
        int cnt=0;
        for(int j=i; j<min(m, i+INTERVAL) && idx<k; j++)
        {
            if(b[j]==sol[idx])
            {
                cnt++;
                idx++;
            }
        }

        stack<bool> temp=IntToBin(cnt);
        while(!temp.empty())
        {
            res.push_back(temp.top());
            temp.pop();
        }
    }

    return res;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    vector<int> res;

    int n=a.size(), m=b.size(), k=hint.size();

    vector<tuple<int, int, int> > sega, segb;

    int idx=0;
    for(int i=0; i<n; i+=INTERVAL)
    {
        vector<bool> temp;
        for(int j=idx; j<idx+MAXS; j++)
        {
            temp.push_back(hint[j]);
        }
        idx+=MAXS;

        int cnt=BinToInt(temp);

        sega.push_back({i, min(n-1, i+INTERVAL-1), cnt});
    }

    for(int i=0; i<m; i+=INTERVAL)
    {
        vector<bool> temp;
        for(int j=idx; j<idx+MAXS; j++)
        {
            temp.push_back(hint[j]);
        }
        idx+=MAXS;

        int cnt=BinToInt(temp);

        segb.push_back({i, min(m-1, i+INTERVAL-1), cnt});
    }

    int i=0, j=0;
    while(i<sega.size() && j<segb.size())
    {
        int l1, r1, cnt1, l2, r2, cnt2;
        tie(l1, r1, cnt1)=sega[i];
        tie(l2, r2, cnt2)=segb[j];

        stack<int> lcs;
        int idx;
        if(cnt1==cnt2)
        {
            tie(lcs, idx)=GetLCS(GetSegment(l1, r1, a), GetSegment(l2, r2, b), cnt1);
            i++, j++;
        }
        else if(cnt1<cnt2)
        {
            tie(lcs, idx)=GetLCS(GetSegment(l2, r2, b), GetSegment(l1, r1, a), min(cnt1, cnt2));
            l2+=idx;
            cnt2-=cnt1;
            segb[j]=tie(l2, r2, cnt2);
            i++;
        }
        else
        {
            tie(lcs, idx)=GetLCS(GetSegment(l1, r1, a), GetSegment(l2, r2, b), min(cnt1, cnt2));
            l1+=idx;
            cnt1-=cnt2;
            sega[i]=tie(l1, r1, cnt1);
            j++;
        }

        while(!lcs.empty())
        {
            res.push_back(lcs.top());
            lcs.pop();
        }
    }

    return res;
}
/*
5 6
1 2 9 3 3
1 9 9 7 8 3
3
1 9 3
*/


