#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

const int bucket = 3000;

void add(vector <bool> &v, int x)
{
	for (int i = 0; i < 18; i++)
	{
		if (x & (1 << i))
		v.push_back(1);
		
		else 
		v.push_back(0);
	}
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
	vector <int> v1, v2;
	int idx = 0;
	for (int i = 0; i < (int)a.size() && idx < (int)sol.size(); i++)
	if (a[i] == sol[idx])
	{
		v1.push_back(i);
		idx++;
	}
	
	idx = 0;
	for (int i = 0; i < (int)b.size() && idx < (int)sol.size(); i++)
	if (b[i] == sol[idx])
	{
		v2.push_back(i);
		idx++;
	}
	
	vector <bool> ans;
	
	int last_pos1 = -1, last_pos2 = -1;
	int pos = 0;
	while (pos < (int)sol.size())
	{
		if (v1[pos] - last_pos1 > bucket && v2[pos] - last_pos2 > bucket)
		{
			last_pos1 += bucket;
			last_pos2 += bucket;
			add(ans, last_pos1);
			add(ans, last_pos2);
			
			continue;
		}
		
		if (v1[pos] - last_pos1 > bucket)
		{
			last_pos1 += bucket;
			add(ans, last_pos1);
		    last_pos2 = v2[pos]-1;
		    add(ans, last_pos2);
		    
		    continue;
		}
		
		if (v2[pos] - last_pos2 > bucket)
		{
			last_pos2 += bucket;
			last_pos1 = v1[pos]-1;
			add(ans, last_pos1);
			add(ans, last_pos2);
			
			continue;
		}
		
		while (pos < (int)sol.size() && v1[pos] - last_pos1 <= bucket && v2[pos] - last_pos2 <= bucket)
		pos++;
		pos--;
		
		last_pos1 = v1[pos], last_pos2 = v2[pos];
		add(ans, last_pos1);
		add(ans, last_pos2);
		
		pos++;
	}
	
	return ans;
}


int dp[bucket + 3][bucket + 3];
vector <int> f(const vector <int> &a, const vector <int> &b, int l1, int r1, int l2, int r2)
{
	if (l1 > r1 || l2 > r2)
	return {};
	
	int sz1 = r1 - l1 + 1, sz2 = r2 - l2 + 1; 
	for (int i = 1; i <= sz1; i++)
	for (int j = 1; j <= sz2; j++)
	{
		dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
		if (a[l1+i-1] == b[l2+j-1])
		dp[i][j] = max(dp[i][j], dp[i-1][j-1] + 1);
	}
	
	int idx1 = sz1, idx2 = sz2;
	vector <int> ans;
	while (idx1 && idx2)
	{
		if (a[idx1+l1-1] == b[idx2+l2-1] && dp[idx1][idx2] == dp[idx1-1][idx2-1] + 1)
		{
			ans.push_back(a[idx1+l1-1]);
			idx1--;
			idx2--;
			continue;
		}
		
		if (dp[idx1][idx2] == dp[idx1-1][idx2])
		idx1--;
		
		else 
		idx2--;
	}
	
	reverse(ans.begin(), ans.end());
	return ans;
}

int get(const vector <bool> &v, int &pos)
{
	int x = 0;
	for (int i = 0; i < 18; i++)
	if (v[pos+i])
	x ^= (1 << i);
	
	pos += 18;
	return x;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
	int pos = 0;
	vector <int> ans;
	int last_pos1 = -1, last_pos2 = -1;
	while (pos < (int)hint.size())
	{
		int l = get(hint, pos), r = get(hint, pos);
		auto curr = f(a, b, last_pos1 + 1, l, last_pos2 + 1, r);
		last_pos1 = l, last_pos2 = r;
		
		for (auto j: curr)
		ans.push_back(j);
	}
	
	return ans;
}
 
