#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include "hint.h"

#define fr first
#define sc second
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
#define de(x) cout << #x << " = " << x << endl;

using namespace std;
using namespace __gnu_pbds;

template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using matrix = vector<vector<T>>;

const int CNT_BLOCKS = 5;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol){
	vector<bool> ret;
	int sol_size = sol.size(), block_size = (sol_size + CNT_BLOCKS - 1) / CNT_BLOCKS;
	vector<int> cuts_a;
	vector<int> cuts_b;
	
	for(int i = 0, j = 0, t = 0; i < a.size(); i ++){
		if(a[i] == sol[j] && j < sol.size()){
			++ t;
			++ j;
		}
		if(t == block_size){
			cuts_a.pb(i);
			t = 0;
		}
	}
	
	for(int i = 0, j = 0, t = 0; i < b.size(); i ++){
		if(b[i] == sol[j] && j < sol.size()){
			++ t;
			++ j;
		}
		if(t == block_size){
			cuts_b.pb(i);
			t = 0;
		}
	}
	for(int i = 0; i < cuts_a.size(); i ++){
		for(int j = 19; j >= 0; j --){
			if((cuts_a[i] >> j) & 1) ret.pb(1);
			else					 ret.pb(0);
		}
		for(int j = 19; j >= 0; j --){
			if((cuts_b[i] >> j) & 1) ret.pb(1);
			else					 ret.pb(0);
		}
	}
	return ret;
}

matrix<pair<int, int>> dp;

void solve_small(vector<int> &A, vector<int> &B, vector<int> &ret){
	auto a = A;
	auto b = B;
	reverse(all(a)); a.pb(0); reverse(all(a));
	reverse(all(b)); b.pb(0); reverse(all(b));
	dp = matrix<pair<int, int>>(a.size() + 1, vector<pair<int, int>>(b.size() + 1));
	for(int i = 1; i < a.size(); i ++){
		for(int j = 1; j < b.size(); j ++){
			if(a[i] == b[j]){
				dp[i][j] = {dp[i - 1][j - 1].fr + 1, 1};
			}
			else{
				if(dp[i - 1][j].fr <= dp[i][j - 1].fr){
					dp[i][j] = {dp[i][j - 1].fr, 2};
				}
				else{
					dp[i][j] = {dp[i - 1][j].fr, 0};
				}
			}
		}
	}
	int i0 = a.size() - 1, j0 = b.size() - 1;
	while(i0 != 0 && j0 != 0){
		if(dp[i0][j0].sc == 0){
			-- i0;
		}
		else if(dp[i0][j0].sc == 2){
			-- j0;
		}
		else{
			ret.pb(a[i0]);
			-- i0; -- j0;
		}
	}
	reverse(all(ret));
}

vector<int> solve(const vector<int> &A, const vector<int> &B, const vector<bool> &hint){
	vector<int> ret, tmp, cuts_a, cuts_b;
	for(int i = 0, j = 0; i < hint.size(); i ++){
		tmp.pb(hint[i]);
		if(i % 20 == 19){
			int p = 1, a = 0;
			while(!tmp.empty()){
				a += tmp.back() * p;
				p *= 2;
				tmp.pop_back();
			}
			if(j % 2 == 0) cuts_a.pb(a);
			else		   cuts_b.pb(a);
			++ j;
		}
	}
	/// for(auto x : cuts_a) cout << x << " "; cout << endl;
	/// for(auto x : cuts_b) cout << x << " "; cout << endl;
	int idx_a = 0, idx_b = 0;
	cuts_a.pb(A.size() - 1);
	cuts_b.pb(B.size() - 1);
	vector<int> curr_a, curr_b;
	for(int i = 0; i < cuts_a.size(); i ++){
		curr_a.clear();
		curr_b.clear();
		while(idx_a <= cuts_a[i]){
			curr_a.pb(A[idx_a]);
			++ idx_a;
		}
		while(idx_b <= cuts_b[i]){
			curr_b.pb(B[idx_b]);
			++ idx_b;
		}
		/// for(auto x : curr_a) cout << x << " "; cout << endl;
		/// for(auto x : curr_b) cout << x << " "; cout << endl;
		vector<int> curr_sol;
		solve_small(curr_a, curr_b, curr_sol);
		for(auto x : curr_sol) ret.pb(x);
	}
	return ret;
}

/**int main(){
	vector<int> A = {0, 8, 36, 11, 70, 25, 16, 57, 34, 79, 67, 9, 11, 17, 7, 52, 1, 56, 85, 46, 12, 89, 34, 16, 55, 46, 2, 9, 0, 11, 57, 0, 19, 93, 64, 42, 18, 80, 51, 5, 12, 18, 14, 23, 36, 74, 75, 89, 30, 60, 35, 95, 49, 22, 63, 56, 68, 17, 17, 20, 29, 75, 21, 0, 68, 85, 42, 39, 17, 94, 44, 81, 64, 10, 5, 0, 84, 32, 89, 67, 93, 77, 62, 94, 51, 25, 51, 19, 95, 68, 91, 24, 95, 12, 24, 64, 49, 19, 55, 19, 65, 99, 0, 29, 61, 57, 82, 46, 90, 71, 65, 35, 0, 79, 29, 51, 56, 32, 22, 51, 1, 14, 75, 48, 78, 52, 12, 80, 23, 67, 99, 88, 18, 51, 17, 80, 9, 99, 78, 99, 23, 95, 34, 75, 74, 15, 79, 30, 48, 1, 82, 1, 67, 9, 49, 98, 61, 14, 78, 36, 81, 29, 24, 52, 80, 94, 84, 89, 93, 14, 40, 68, 9, 74, 96, 83, 90, 75, 13, 90, 28, 47, 91, 96, 57, 40, 94, 70, 54, 24, 7, 88, 53, 83, 92, 33, 77, 76, 75, 23, 90, 15, 91, 51, 42, 87, 34, 84, 14, 99, 74, 43, 47, 65, 91, 4, 57, 37, 26, 64, 61, 33, 4, 14, 17, 48, 99, 94, 24, 74, 69, 66, 42, 13, 17, 84, 52, 3, 68, 67, 2, 94, 10, 1, 59, 53, 57, 68, 90, 84, 84, 51, 69, 40, 17, 86, 88, 68, 33, 64, 43, 2, 30, 85, 67, 99, 21, 20, 54, 89, 87, 9, 83, 49, 10, 94, 2, 68, 14, 92, 4, 51, 95, 73, 91, 64, 60, 80, 32, 45, 44, 27, 99, 27, 12, 67, 78, 85, 87, 33, 74, 26, 42, 9, 75, 4, 55, 77, 24, 22, 21, 28, 73, 68, 2, 64, 32, 14, 96, 16, 11, 41, 44, 62, 20, 8, 29, 98, 94, 68, 83, 20, 94, 77, 82, 21, 82, 89, 98, 58, 11, 71, 87, 84, 91, 41, 1, 75, 7, 97, 92, 18, 90, 88, 80, 10, 96, 62, 61, 42, 82, 44, 15, 77, 22, 97, 98, 56, 86, 49, 14, 50, 72, 53, 34, 64, 46, 35, 39, 53, 33, 83, 71, 75, 71, 4, 86, 20, 18, 47, 14, 0, 91, 29, 29, 65};
	vector<int> B = {78, 80, 21, 17, 81, 88, 67, 53, 41, 53, 69, 40, 89, 61, 93, 74, 96, 17, 49, 68, 73, 87, 40, 91, 34, 54, 91, 78, 36, 73, 43, 66, 53, 17, 35, 34, 5, 2, 39, 98, 56, 61, 38, 97, 74, 32, 23, 70, 1, 24, 90, 74, 12, 30, 65, 98, 37, 8, 76, 25, 81, 72, 91, 86, 89, 27, 72, 46, 81, 64, 44, 89, 25, 35, 38, 51, 67, 61, 21, 20, 38, 12, 94, 50, 94, 11, 48, 83, 19, 77, 8, 53, 49, 52, 91, 90, 31, 64, 36, 12, 80, 80, 54, 57, 15, 92, 8, 34, 6, 29, 6, 44, 93, 0, 46, 40, 11, 94, 23, 83, 23, 84, 88, 72, 88, 79, 62, 19, 95, 50, 83, 75, 31, 89, 32, 98, 82, 40, 85, 40, 22, 91, 84, 67, 92, 82, 7, 55, 28, 83, 38, 52, 67, 26, 76, 7, 58, 91, 26, 53, 41, 61, 29, 72, 51, 61, 23, 33, 54, 60, 25, 28, 51, 61, 95, 95, 43, 55, 3, 71, 38, 93, 23, 57, 20, 52, 64, 30, 43, 42, 83, 84, 3, 12, 9, 54, 26, 32, 39, 32, 92, 64, 60, 95, 77, 7, 43, 20, 62, 46, 44, 52, 39, 19, 61, 11, 71, 77, 41, 14, 19, 77, 51, 75, 41, 60, 29, 67, 44, 21, 51, 88, 37, 63, 83, 15, 23, 78, 87, 37, 24, 31, 90, 16, 51, 3, 79, 74, 81, 73, 41, 52, 50, 92, 27, 91, 52, 9, 11, 96, 82, 62, 84, 19, 78, 19, 86, 1, 98, 74, 38, 74, 57, 80, 42, 60, 84, 22, 35, 17, 47, 28, 21, 97, 20, 49, 40, 72, 10, 51, 20, 44, 66, 4, 15, 96, 75, 2, 97, 25, 28, 35, 0, 85, 68, 94, 98, 52, 68, 85, 21, 15, 13, 42, 64, 33, 43, 5, 57, 5, 8, 77, 49, 26, 33, 65, 22, 60, 67, 71, 86, 47, 59, 86, 84, 27, 32, 82, 31, 1, 19, 52, 16, 32, 46, 33, 17, 90, 90, 74, 95, 98, 3, 97, 77, 88, 62, 51, 49, 81, 23, 87, 28, 82, 25, 64, 61, 57, 99, 44, 58, 18, 96, 27, 51, 94, 60, 20, 84, 50, 47, 32, 0, 2, 29, 77, 91, 43, 81, 92, 24, 4, 79, 4, 38, 56};
	vector<int> S = {17, 89, 93, 74, 17, 68, 17, 5, 32, 24, 12, 65, 46, 35, 51, 48, 52, 12, 80, 80, 15, 29, 93, 40, 83, 75, 40, 7, 83, 76, 91, 51, 43, 57, 26, 64, 61, 14, 24, 74, 52, 1, 57, 84, 17, 21, 20, 49, 10, 51, 44, 4, 28, 68, 94, 68, 21, 71, 84, 1, 90, 88, 62, 49, 64, 18, 47, 0, 29};
	
	auto H = genHint(A, B, S);
	auto NS = solve(A, B, H);
	cout << (NS == S) << endl;
}*/

/**
{0, 8, 36, 11, 70, 25, 16, 57, 34, 79, 67, 9, 11, 17, 7, 52, 1, 56, 85, 46, 12, 89, 34, 16, 55, 46, 2, 9, 0, 11, 57, 0, 19, 93, 64, 42, 18, 80, 51, 5, 12, 18, 14, 23, 36, 74, 75, 89, 30, 60, 35, 95, 49, 22, 63, 56, 68, 17, 17, 20, 29, 75, 21, 0, 68, 85, 42, 39, 17, 94, 44, 81, 64, 10, 5, 0, 84, 32, 89, 67, 93, 77, 62, 94, 51, 25, 51, 19, 95, 68, 91, 24, 95, 12, 24, 64, 49, 19, 55, 19, 65, 99, 0, 29, 61, 57, 82, 46, 90, 71, 65, 35, 0, 79, 29, 51, 56, 32, 22, 51, 1, 14, 75, 48, 78, 52, 12, 80, 23, 67, 99, 88, 18, 51, 17, 80, 9, 99, 78, 99, 23, 95, 34, 75, 74, 15, 79, 30, 48, 1, 82, 1, 67, 9, 49, 98, 61, 14, 78, 36, 81, 29, 24, 52, 80, 94, 84, 89, 93, 14, 40, 68, 9, 74, 96, 83, 90, 75, 13, 90, 28, 47, 91, 96, 57, 40, 94, 70, 54, 24, 7, 88, 53, 83, 92, 33, 77, 76, 75, 23, 90, 15, 91, 51, 42, 87, 34, 84, 14, 99, 74, 43, 47, 65, 91, 4, 57, 37, 26, 64, 61, 33, 4, 14, 17, 48, 99, 94, 24, 74, 69, 66, 42, 13, 17, 84, 52, 3, 68, 67, 2, 94, 10, 1, 59, 53, 57, 68, 90, 84, 84, 51, 69, 40, 17, 86, 88, 68, 33, 64, 43, 2, 30, 85, 67, 99, 21, 20, 54, 89, 87, 9, 83, 49, 10, 94, 2, 68, 14, 92, 4, 51, 95, 73, 91, 64, 60, 80, 32, 45, 44, 27, 99, 27, 12, 67, 78, 85, 87, 33, 74, 26, 42, 9, 75, 4, 55, 77, 24, 22, 21, 28, 73, 68, 2, 64, 32, 14, 96, 16, 11, 41, 44, 62, 20, 8, 29, 98, 94, 68, 83, 20, 94, 77, 82, 21, 82, 89, 98, 58, 11, 71, 87, 84, 91, 41, 1, 75, 7, 97, 92, 18, 90, 88, 80, 10, 96, 62, 61, 42, 82, 44, 15, 77, 22, 97, 98, 56, 86, 49, 14, 50, 72, 53, 34, 64, 46, 35, 39, 53, 33, 83, 71, 75, 71, 4, 86, 20, 18, 47, 14, 0, 91, 29, 29, 65}
{78, 80, 21, 17, 81, 88, 67, 53, 41, 53, 69, 40, 89, 61, 93, 74, 96, 17, 49, 68, 73, 87, 40, 91, 34, 54, 91, 78, 36, 73, 43, 66, 53, 17, 35, 34, 5, 2, 39, 98, 56, 61, 38, 97, 74, 32, 23, 70, 1, 24, 90, 74, 12, 30, 65, 98, 37, 8, 76, 25, 81, 72, 91, 86, 89, 27, 72, 46, 81, 64, 44, 89, 25, 35, 38, 51, 67, 61, 21, 20, 38, 12, 94, 50, 94, 11, 48, 83, 19, 77, 8, 53, 49, 52, 91, 90, 31, 64, 36, 12, 80, 80, 54, 57, 15, 92, 8, 34, 6, 29, 6, 44, 93, 0, 46, 40, 11, 94, 23, 83, 23, 84, 88, 72, 88, 79, 62, 19, 95, 50, 83, 75, 31, 89, 32, 98, 82, 40, 85, 40, 22, 91, 84, 67, 92, 82, 7, 55, 28, 83, 38, 52, 67, 26, 76, 7, 58, 91, 26, 53, 41, 61, 29, 72, 51, 61, 23, 33, 54, 60, 25, 28, 51, 61, 95, 95, 43, 55, 3, 71, 38, 93, 23, 57, 20, 52, 64, 30, 43, 42, 83, 84, 3, 12, 9, 54, 26, 32, 39, 32, 92, 64, 60, 95, 77, 7, 43, 20, 62, 46, 44, 52, 39, 19, 61, 11, 71, 77, 41, 14, 19, 77, 51, 75, 41, 60, 29, 67, 44, 21, 51, 88, 37, 63, 83, 15, 23, 78, 87, 37, 24, 31, 90, 16, 51, 3, 79, 74, 81, 73, 41, 52, 50, 92, 27, 91, 52, 9, 11, 96, 82, 62, 84, 19, 78, 19, 86, 1, 98, 74, 38, 74, 57, 80, 42, 60, 84, 22, 35, 17, 47, 28, 21, 97, 20, 49, 40, 72, 10, 51, 20, 44, 66, 4, 15, 96, 75, 2, 97, 25, 28, 35, 0, 85, 68, 94, 98, 52, 68, 85, 21, 15, 13, 42, 64, 33, 43, 5, 57, 5, 8, 77, 49, 26, 33, 65, 22, 60, 67, 71, 86, 47, 59, 86, 84, 27, 32, 82, 31, 1, 19, 52, 16, 32, 46, 33, 17, 90, 90, 74, 95, 98, 3, 97, 77, 88, 62, 51, 49, 81, 23, 87, 28, 82, 25, 64, 61, 57, 99, 44, 58, 18, 96, 27, 51, 94, 60, 20, 84, 50, 47, 32, 0, 2, 29, 77, 91, 43, 81, 92, 24, 4, 79, 4, 38, 56}
{17, 89, 93, 74, 17, 68, 17, 5, 32, 24, 12, 65, 46, 35, 51, 48, 52, 12, 80, 80, 15, 29, 93, 40, 83, 75, 40, 7, 83, 76, 91, 51, 43, 57, 26, 64, 61, 14, 24, 74, 52, 1, 57, 84, 17, 21, 20, 49, 10, 51, 44, 4, 28, 68, 94, 68, 21, 71, 84, 1, 90, 88, 62, 49, 64, 18, 47, 0, 29}
0000
0000
0000
0100
010
0000
0000
0000
0100
010

78 80 21 
17 81 88 

67 53 41 
53 69 40 

89 61 93 
74 96 17 

49 68 73 
87 40 91 

34 54 91 
78 36 73 

43 66 53 
17
*/