#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

bool used[MAXN + 5];
vector<int> G[MAXN + 5];
pair<int, int> d[MAXN + 5];

void find_path(int u)
{
    used[u] = true;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (!used[v])
        {
            find_path(v);
            break;
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> d[i].first >> d[i].second;
    }

    sort(d + 1, d + n + 1);

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            if (d[j].first - d[i].first >= abs(d[j].second - d[i].second)) G[i].push_back(j);
        }
    }

    int cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (!used[i])
        {
            find_path(i);
            cnt++;
        }
    }

    cout << cnt << endl;

    return 0;
}
