#include <iostream>
#include <vector>
#include <algorithm>

#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& res) {
    return {};
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int n = (int) a.size();
    int m = (int) b.size();

    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));
    vector<vector<pair<int, int>>> parent(n + 1, vector<pair<int, int>>(m + 1));

    for (int i = 0; i <= n; ++i) {
        parent[i][0] = {-1, -1};
    }
    for (int j = 0; j <= m; ++j) {
        parent[0][j] = {-1, -1};
    }

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a[i - 1] == b[j - 1]) {
                dp[i][j] = dp[i - 1][j - 1] + 1;
                parent[i][j] = {i - 1, j - 1};
            } else if (dp[i - 1][j] > dp[i][j - 1]) {
                dp[i][j] = dp[i - 1][j];
                parent[i][j] = {i - 1, j};
            } else {
                dp[i][j] = dp[i][j - 1];
                parent[i][j] = {i, j - 1};
            }
        }
    }
    
    vector<int> res;
    int i = n, j = m;

    while (i > 0 and j > 0) {
        int nexti = parent[i][j].first;
        int nextj = parent[i][j].second;

        if (nexti + 1 == i and nextj + 1 == j) {
            res.push_back(a[nexti]);
        }

        i = nexti;
        j = nextj;
    }

    // cout << "length is " << dp[n][m] << endl;

    reverse(res.begin(), res.end());

    return res;
}