#include "hint.h"
#include<bits/stdc++.h>
using namespace std;

const int SZ=18,nmax=2e5+42,C=1e4;

vector<bool> my_hint={};

void add(int val)
{
    for(int bit=SZ-1;bit>=0;bit--)
        if((val&(1<<bit)))my_hint.push_back(1);
        else my_hint.push_back(0);
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<int> in[2];
    in[0]={};
    in[1]={};

    int pointer=0;

    pointer=0;
    for(int i=0;i<a.size();i++)
    {
        if(pointer<sol.size()&&a[i]==sol[pointer])
        {
            in[0].push_back(i);
            pointer++;
        }
    }

    pointer=0;
    for(int j=0;j<b.size();j++)
    {
        if(pointer<sol.size()&&b[j]==sol[pointer])
        {
            in[1].push_back(j);
            pointer++;
        }
    }

    int use=sqrt(sol.size())/1.75;
    use=max(use,1);

    int SZ=(sol.size()-2+use-1)/use;

    //cout<<"use= "<<use<<" SZ= "<<SZ<<endl;

    for(int i=0;i<sol.size();i++)
    {
        if(i==0||i==sol.size()-1||i%SZ==0)
        {
            add(in[0][i]);
            add(in[1][i]);
        }
    }

    return my_hint;
}

vector<int> seen[nmax];

vector<int> mem_a,mem_b;

vector<int> outp;

vector< pair<int/*position*/,int/*id*/> > low;
vector< pair<int/*value*/,int/*id previous*/> > prv={};

void lis(int la,int lb,int ra,int rb)
{
    //cout<<la<<" "<<lb<<" "<<ra<<" "<<rb<<endl;
    low={};
    prv={};

    for(int i=la+1;i<ra;i++)
    {
        int start=lower_bound(seen[mem_a[i]].begin(),seen[mem_a[i]].end(),rb)-seen[mem_a[i]].begin();
        start--;

        //cout<<"i= "<<i<<" mem_a= "<<mem_a[i]<<" seen= ";for(auto w:seen[mem_a[i]])cout<<w<<" ";cout<<endl;

        while(start>=0&&seen[mem_a[i]][start]>lb)
        {
            int cur=seen[mem_a[i]][start];

            //cout<<"link "<<i<<" "<<cur<<endl;

            int pos=lower_bound(low.begin(),low.end(),make_pair(cur,-2))-low.begin();

            int my_prv=-1;

            if(pos>0)my_prv=low[pos-1].second;

            if(pos<low.size())low[pos]={cur,prv.size()};
            else low.push_back({cur,prv.size()});

            prv.push_back({mem_a[i],my_prv});

            start--;
        }
    }

    /*
    cout<<"merging "<<la<<" "<<lb<<" "<<ra<<" "<<rb<<endl;
    cout<<"low: ";for(auto w:low)cout<<w.first<<" "<<w.second<<endl;
    cout<<endl;
    */

    if(low.size()>0)
    {
        int me=low.back().second;

        vector<int> nums={};

        while(me>=0)
        {
            nums.push_back(prv[me].first);
            me=prv[me].second;
        }

        reverse(nums.begin(),nums.end());
        for(auto w:nums)outp.push_back(w);
    }
}

int dp[C][C];

void hand(int la,int lb,int ra,int rb)
{
    //cout<<"hand "<<la<<" "<<lb<<" "<<ra<<" "<<rb<<endl;

    int low_a=la+1;
    int low_b=lb+1;

    int high_a=ra-1;
    int high_b=rb-1;

    if(low_a>high_a||low_b>high_b)return;

    int SZ_a=high_a-low_a+1;
    int SZ_b=high_b-low_b+1;

    for(int i=1;i<=SZ_a;i++)
        for(int j=1;j<=SZ_b;j++)
        {
            dp[i][j]=0;

            if(i>1)dp[i][j]=max(dp[i][j],dp[i-1][j]);
            if(j>1)dp[i][j]=max(dp[i][j],dp[i][j-1]);

            if(mem_a[i-1+low_a]==mem_b[j-1+low_b])
            {
                if(i>1&&j>1)dp[i][j]=max(dp[i][j],1+dp[i-1][j-1]);
                else dp[i][j]=1;
            }
        }

    vector<int> help={};

    int i=SZ_a;
    int j=SZ_b;

    while(i>=1&&j>=1)
    {
        if(i>1&&dp[i][j]==dp[i-1][j])i--;
        else if(j>1&&dp[i][j]==dp[i][j-1])j--;
        else
        {
            help.push_back(mem_a[i-1+low_a]);

            i--;
            j--;
        }
    }

    reverse(help.begin(),help.end());

    for(auto w:help)outp.push_back(w);

    //cout<<"help= ";for(auto w:help)cout<<w<<" ";cout<<endl;
}

void extend(int la,int lb,int ra,int rb)
{

    while(la+1<ra&&lb+1<rb&&mem_a[la+1]==mem_b[lb+1])
    {
        outp.push_back(mem_a[la+1]);
        la++;
        lb++;
    }

    long long O1=1LL*(ra-la)*(rb-lb);

    long long O2=0;
    for(int i=la+1;i<ra;i++)
    {
        int from=upper_bound(seen[mem_a[i]].begin(),seen[mem_a[i]].end(),lb)-seen[mem_a[i]].begin();

        int to=lower_bound(seen[mem_a[i]].begin(),seen[mem_a[i]].end(),rb)-seen[mem_a[i]].begin();
        to--;

        O2+=to-from;
    }

    O2=O2*log2(ra-la+rb-lb);

    /*
    if(O1<O2&&ra-la+1<C&&rb-lb+1<C)hand(la,lb,ra,rb);
    else
    */
    lis(la,lb,ra,rb);

    outp.push_back(mem_b[rb]);
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    mem_a=a;
    mem_b=b;

    for(int i=0;i<b.size();i++)
        seen[b[i]].push_back(i);

    vector< pair<int,int> > groups={};

    for(int i=0;i<hint.size();)
    {
        int l=0;
        int r=0;

        for(int j=SZ-1;j>=0;j--)
        {
            if(hint[i++])l+=(1<<j);
        }

        for(int j=SZ-1;j>=0;j--)
        {
            if(hint[i++])r+=(1<<j);
        }

        groups.push_back({l,r});
    }

    //cout<<"groups: ";for(auto w:groups)cout<<w.first<<" "<<w.second<<endl;

    if(groups.size()==0)return {};

    outp.push_back(a[groups[0].first]);

    for(int i=1;i<groups.size();i++)
    {
        extend(groups[i-1].first,groups[i-1].second,groups[i].first,groups[i].second);
    }

    return outp;
}
/*
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
*/
