#include "hint.h"
#include<bits/stdc++.h>
using namespace std;

const int SZ=18,nmax=2e5+42,BIT=351;

vector<bool> my_hint={};

void add(int val)
{
    for(int bit=SZ-1;bit>=0;bit--)
        if((val&(1<<bit)))my_hint.push_back(1);
        else my_hint.push_back(0);
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<int> in[2];
    in[0]={};
    in[1]={};

    int pointer=0;

    pointer=0;
    for(int i=0;i<a.size();i++)
    {
        if(pointer<sol.size()&&a[i]==sol[pointer])
        {
            in[0].push_back(i);
            pointer++;
        }
    }

    pointer=0;
    for(int j=0;j<b.size();j++)
    {
        if(pointer<sol.size()&&b[j]==sol[pointer])
        {
            in[1].push_back(j);
            pointer++;
        }
    }

    if(in[0].size()==0)return {};

    /*
    in[0].push_back(a.size()+1);
    in[1].push_back(b.size()+1);
    */

    vector< pair<int,int> > path={};

    int i=0,j=0;
    for(int t=0;t<in[0].size();t++)
    {
        int x=in[0][t];
        int y=in[1][t];

        while(i<x)
        {
            path.push_back({i,j});
            i++;
        }

        while(j<y)
        {
            path.push_back({i,j});
            j++;
        }

        path.push_back({i,j});
        i++;
        j++;
    }

    //for(auto w:path)cout<<w.first<<" "<<w.second<<endl;

    set< pair<int,int> > on_path={};

    for(auto w:path)
        on_path.insert({w.first/BIT,w.second/BIT});

    int x=0,y=0;

    vector<bool> send={};

    while(x<=i/BIT&&y<=j/BIT)
    {
        if(on_path.count({x+1,y}))
        {
            x++;
            send.push_back(1);
        }
        else
        {
            y++;
            send.push_back(0);
        }
    }

    return send;
}

vector<int> mem_a,mem_b;

int start[nmax];
vector<int> seen[nmax];

int highest[nmax],rightest[nmax];

int ask(int x,int y)
{
    if(x<0||y<0)return 0;

    if(y<start[x])return highest[y];
    if(y-start[x]>=seen[x].size())return rightest[x];

    return seen[x][y-start[x]];
}

//bool ON[nmax/BIT+42][nmax/BIT+42];
bool ON[10000][10000];

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    if(hint.size()==0)return {};

    mem_a=a;
    mem_b=b;

    vector< pair<int,int> > areas={};
    areas.push_back({0,0});

    int x=0,y=0;

    for(int i=0;i<hint.size();i++)
    {
        if(hint[i])x++;
        else y++;

        areas.push_back({x,y});
    }

    //cout<<"areas: ";for(auto w:areas)cout<<w.first<<" "<<w.second<<endl;

    for(auto w:areas)ON[w.first][w.second]=1;

    int LIS=0,final_x=0,final_y=0;

    for(int i=0;i<a.size();i++)
    {
        for(int j=0;j<b.size()/BIT+42;j++)
        {
            if(ON[i/BIT][j])
            {
                int x=i;

                int y=j*BIT;

                start[i]=y;

                while(ON[x/BIT][y/BIT]&&x<a.size()&&y<b.size())
                {
                    int cur=ask(x,y-1);
                    cur=max(cur,ask(x-1,y));
                    if(a[x]==b[y])cur=max(cur,ask(x-1,y-1)+1);

                    seen[x].push_back(cur);

                    if(cur>LIS)
                    {
                        LIS=cur;

                        final_x=x;
                        final_y=y;
                    }

                    highest[y]=cur;
                    rightest[x]=cur;

                    //cout<<x<<" "<<y<<" -> "<<cur<<endl;

                    y++;
                }

                seen[x].shrink_to_fit();

                break;
            }
        }
    }

    //cout<<"LIS= "<<LIS<<endl;

    vector< int > ret={};

    while(final_x>=0&&final_y>=0)
    {
        if(ask(final_x,final_y)==ask(final_x-1,final_y))final_x--;
        else if(ask(final_x,final_y)==ask(final_x,final_y-1))final_y--;
        else
        {
            ret.push_back(a[final_x]);
            final_x--;
            final_y--;
        }
    }

    reverse(ret.begin(),ret.end());

    return ret;
}
/*
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{

    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
*/

