#include <bits/stdc++.h>
#include "hint.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

string convertToBinary(int number) {
    string result = "";
    while (number) {
        result.push_back((number & 1) + '0');
        number >>= 1;
    }

    while (result.size() < 17) {
        result.push_back('0');
    }

    reverse(result.begin(), result.end());

    return result;
}

int convertToDecimal(string binaryNumber) {
    int answer = 0;
    for (int i = 0; i < (int)binaryNumber.size(); i++) {
        answer <<= 1;
        answer += (binaryNumber[i] - '0');
    }

    return answer;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if (17 * sol.size() <= min(a.size(), b.size())) {
        vector<bool> hint;
        for (int i = 0; i < (int)sol.size(); i++) {
            string bin = convertToBinary(sol[i]);
            for (char bit : bin) {
                hint.push_back(bit - '0');
            }
        }
        hint.push_back(1);
        return hint;
    } else {
        std::vector<int> f = a, s = b;

        if (f.size() > s.size()) {
            std::swap(f, s);
        }

        std::vector<bool> hint(f.size(), false);
        int pos = 0;
        for (int i = 0; i < (int)f.size() && pos < sol.size(); i++) {
            if (f[i] == sol[pos]) {
                hint[i] = true;
                pos++;
            }
        }

        hint.push_back(0);

        return hint;
    }
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if (hint.back()) {
        vector<int> sol;
        for (int i = 0; i < (int)hint.size() - 1; i += 17) {
            string bin = "";
            for (int j = i; j < i + 17; j++) {
                bin.push_back(hint[j] + '0');
            }

            sol.emplace_back(convertToDecimal(bin));
        }

        return sol;
    } else {
        std::vector<int> f = a, s = b;

        if (f.size() > s.size()) {
            std::swap(f, s);
        }

        std::vector<int> sol;
        for (int i = 0; i < f.size(); i++) {
            if (hint[i]) {
                sol.emplace_back(f[i]);
            }
        }

        return sol;
    }
}
