#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> orders;

void read() {
    cin >> n;

    orders.resize(n);
    for (auto &order : orders) {
        cin >> order.first >> order.second;
    }
}

bool ok(pair<int, int> order1, pair<int, int> order2) {
    if (order1.second == order2.second) {
        return true;
    }

    if (abs(order1.first - order2.first) == 1 && abs(order1.second - order2.second) == 1) {
        return true;
    }

    return false;
}

void solve() {
    sort(orders.begin(), orders.end());

    vector<pair<pair<int, int>, int>> groups;
    for (int i = 0; i < n; i++) {
        int groupPos = -1;
        for (int j = 0; j < (int)groups.size(); j++) {
            if (ok(groups[j].first, orders[i])) {
                if (groupPos == -1) {
                    groupPos = j;
                } else if (groups[groupPos].second > groups[j].second) {
                    groupPos = j;
                }
            }
        }

        if (groupPos == -1) {
            groups.emplace_back(orders[i], 1);
        } else {
            groups[groupPos].first = orders[i];
            groups[groupPos].second++;
        }
    }

    cout << groups.size() << endl;
}

int main() {
    setIO();

    read();

    solve();
}
