#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> orders;

void read() {
    cin >> n;

    orders.resize(n);
    for (auto &order : orders) {
        cin >> order.first >> order.second;
    }
}

bool ok(pair<int, int> order1, pair<int, int> order2) {
    if (order1.second == order2.second) {
        return true;
    }

    if (abs(order1.first - order2.first) == 1 && abs(order1.second - order2.second) == 1) {
        return true;
    }

    return false;
}

vector<vector<int>> graph;
vector<bool> used;

void dfs(int node) {
    used[node] = true;

    for (int adj : graph[node]) {
        if (!used[adj]) {
            dfs(adj);
        }
    }
}

void solve() {
    sort(orders.begin(), orders.end());

    graph.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (ok(orders[i], orders[j])) {
                graph[i].emplace_back(j);
            }
        }
    }

    int answer1 = 0;
    used.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            answer1++;
            dfs(i);
        }
    }

    int answer2 = 0;
    fill(used.begin(), used.end(), false);
    for (int i = n - 1; i >= 0; i--) {
        if (!used[i]) {
            answer2++;
            dfs(i);
        }
    }

    cout << min(answer1, answer2) << endl;
}

int main() {
    setIO();

    read();

    solve();
}
