#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> orders;

void read() {
    cin >> n;

    orders.resize(n);
    for (auto &order : orders) {
        cin >> order.first >> order.second;
    }
}

bool ok(pair<int, int> order1, pair<int, int> order2) {
    int timeNeeded = abs(order1.second - order2.second);
    int timeRemained = abs(order1.first - order2.first);
    return (timeNeeded <= timeRemained);
}

vector<vector<int>> graph;
vector<bool> used;
vector<int> inDeg;

void dfs(int node) {
    used[node] = true;

    for (int adj : graph[node]) {
        if (!used[adj]) {
            dfs(adj);
        }
    }
}

void solve() {
    sort(orders.begin(), orders.end());

    graph.resize(n);
    inDeg.resize(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (ok(orders[i], orders[j])) {
                graph[i].emplace_back(j);
                inDeg[j]++;
            }
        }
    }

    int answer = 0;
    used.resize(n, false);
    for (int i = 0; i < n; i++) {
        if (!inDeg[i] && !used[i]) {
            answer++;
            dfs(i);
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
