#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> orders;

void read() {
    cin >> n;

    orders.resize(n);
    for (auto &order : orders) {
        cin >> order.first >> order.second;
    }
}

bool ok(pair<int, int> order1, pair<int, int> order2) {
    int timeNeeded = abs(order1.second - order2.second);
    int timeRemained = abs(order1.first - order2.first);
    return (timeNeeded <= timeRemained);
}

void solve() {
    sort(orders.begin(), orders.end());

    vector<pair<int, int>> groups;
    for (int i = 0; i < n; i++) {
        int groupPos = -1;
        for (int j = 0; j < (int)groups.size(); j++) {
            if (ok(groups[j], orders[i])) {
                if (groupPos == -1) {
                    groupPos = j;
                } else {
                    if (groups[j].first > groups[groupPos].first) {
                        groupPos = j;
                    }
                }
            }
        }

        if (groupPos == -1) {
            groups.emplace_back(orders[i]);
        } else {
            groups[groupPos] = orders[i];
        }
    }

    cout << groups.size() << endl;
}

int main() {
    setIO();

    read();

    solve();
}
