#include "hint.h"

#define ENDL '\n'

std::vector<bool> genHint(const std::vector<int>& a,
                          const std::vector<int>& b,
                          const std::vector<int>& sol) {
    std::vector<bool> res;

    auto max_n = std::max(a.size(), b.size());
    res.reserve(2 * max_n);

    for (auto i = 0, j = 0; i < sol.size(); ++i) {
        if (sol[j] == a[i]) {
            res.push_back(true);
            res.push_back(false);

            ++j;
        } else if (sol[j] == b[i]) {
            res.push_back(true);
            res.push_back(true);

            ++j;
        } else {
            res.push_back(false);
        }
    }

    return res;
}

std::vector<int> solve(const std::vector<int>& a,
                       const std::vector<int>& b,
                       const std::vector<bool>& hint) {
    std::vector<int> res;
    res.reserve(a.size() + b.size());

    for (auto i = 0, j = 0; i < hint.size(); ++i, ++j) {
        auto curr = hint[i];
        if (!curr) {
            continue;
        }

        auto seq = hint[++i];
        if (seq) {
            res.push_back(b[j]);
        } else {
            res.push_back(a[j]);
        }
    }

    return res;
}
