#include "hint.h"
#ifdef DEBUG
#include <iostream>
#endif

std::vector<bool> genHint(const std::vector<int>& a,
                          const std::vector<int>& b,
                          const std::vector<int>& sol) {
    auto max_n = std::max(a.size(), b.size());

    std::vector<bool> hint;
    hint.reserve(2 * max_n);

    for (auto i = 0, j = 0; i < sol.size() && j < max_n; ++j) {
        if (j < a.size() && a[j] == sol[i]) {
            hint.push_back(true);
            hint.push_back(false);

            ++i;

            continue;
        } 

        if (j < b.size() && b[j] == sol[i]) {
            hint.push_back(true);
            hint.push_back(true);

            ++i;

            continue;
        }

        hint.push_back(false);
        hint.push_back(false);
    }

#ifdef DEBUG
    std::cout << "hint: ";
    for (auto val : hint) {
        std::cout << val << " ";
    }
    std::cout << std::endl;
#endif

    return hint;
}

std::vector<int> solve(const std::vector<int>& a,
                       const std::vector<int>& b,
                       const std::vector<bool>& hint) {
    std::vector<int> res;
    res.reserve(hint.size() / 2);

    for (auto i = 0; i < hint.size(); i += 2) {
        auto op = hint[i];
        auto val = hint[i + 1];

        if (!op) {
            continue;
        }

        if (val) {
            res.push_back(b[i / 2]);
        } else {
            res.push_back(a[i / 2]);
        }
    }

    return res;
}
