// #define DEBUG

#include "hint.h"
#ifdef DEBUG
#include <iostream>
#define ENDL '\n'
#endif

std::vector<bool> genHint(const std::vector<int>& a,
                          const std::vector<int>& b,
                          const std::vector<int>& sol) {
    auto& target = a.size() < b.size() ? a : b;
    
    std::vector<bool> res;
    res.reserve(target.size());

    for (auto i = 0, j = 0; i < target.size() && j < sol.size(); ++i) {
        if (target[i] == sol[j]) {
#ifdef DEBUG
            std::cout << target[i] << " == " << sol[j] << ENDL;
#endif

            res.push_back(true);
            ++j;
        } else {
#ifdef DEBUG
            std::cout << target[i] << " != " << sol[j] << ENDL;
#endif

            res.push_back(false);
        }
    }

#ifdef DEBUG
    std::cout << "hint: ";
    for (auto val : res) {
        std::cout << val << " ";
    }
    std::cout << ENDL;
#endif

    return res;
}

std::vector<int> solve(const std::vector<int>& a,
                       const std::vector<int>& b,
                       const std::vector<bool>& hint) {
    auto& target = a.size() < b.size() ? a : b;

    std::vector<int> res;
    res.reserve(hint.size());

    for (auto i = 0; i < hint.size(); ++i) {
        if (hint[i]) {
            res.push_back(target[i]);
        }
    }

    return res;
}
