#include <iostream>
#include "hint.h"
using namespace std;

vector<bool> genHintA(const vector<int>& a, const vector<int>& sol) {
    int i = 0;
    int iSol = 0;

    bool generator;
    vector<bool> hint;

    while (iSol != sol.size()) {
        if (a[i] == sol[iSol]) {
            iSol++;
            generator = true;
        } else {
            generator = false;
        }

        hint.push_back(generator);
        i++;
    }

    return hint;
}

vector<bool> genHintB(const vector<int>& b, const vector<int>& sol) {
    int i = 0;
    int iSol = 0;

    bool generator;
    vector<bool> hint;

    while (iSol != sol.size()) {
        if (b[i] == sol[iSol]) {
            iSol++;
            generator = true;
        } else {
            generator = false;
        }

        hint.push_back(generator);
        i++;
    }

    return hint;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b,
                          const vector<int>& sol) {
    vector<bool> hint;

    if (a.size() > b.size())
        hint = genHintB(b, sol);
    else
        hint = genHintA(a, sol);

    return hint;
}

vector<int> solveA(const vector<int>& a, const vector<bool>& hint, int calcSize) {
    vector<int> sol;

    for (int i = 0; i < a.size(); i++) {
        if (hint[i] == 1) {
            sol.push_back(a[i]);
            if (sol.size() == calcSize)
                break;
        }
    }

    return sol;
}

vector<int> solveB(const vector<int>& b, const vector<bool>& hint, int calcSize) {
    vector<int> sol;

    for (int i = 0; i < b.size(); i++) {
        if (hint[i] == 1) {
            sol.push_back(b[i]);
            if (sol.size() == calcSize)
                break;
        }
    }

    return sol;
}

vector<int> solve(const vector<int>& a, const vector<int>& b,
                        const vector<bool>& hint) {
    vector<int> sol;

    int calcSize = 0;
    for (auto it: hint) {
        if (it == true)
            calcSize++;
    }

    if (a.size() > b.size())
        sol = solveB(b, hint, calcSize);
    else
        sol = solveA(a, hint, calcSize);

    return sol;
}
